<?php
/*
Plugin Name: Embed SharePoint OneDrive Documents
Plugin URI: https://plugins.miniorange.com/
Description: This plugin will allow you to sync and embed Sharepoint, OneDrive Business, OneDrive Personal Documents(folders and files) in the WordPress. Allowing users to Download, Preview, Edit sharepoint files from the WordPress itself based on their access level.
Version: 26.0.0
Author: miniOrange
License: GPLv2 or later
License URI: http://www.gnu.org/licenses/gpl-2.0.html
*/


namespace MoSharePointObjectSync;

require_once __DIR__ . "\57\143\x6c\x61\x73\163\55\167\160\x2d\156\x61\x6d\145\163\160\x61\x63\x65\55\141\x75\x74\157\x6c\157\141\x64\x65\162\56\160\x68\x70";
require_once __DIR__ . "\57\127\162\141\x70\x70\145\x72\163\57\167\x70\x57\162\x61\x70\160\x65\x72\56\x70\x68\160";
require_once __DIR__ . "\57\x6c\151\142\x2f\154\151\x63\x65\156\163\145\57\141\165\164\157\x6c\x6f\141\x64\145\x72\x2e\x70\x68\x70";
use MoSharePointObjectSync\API\SyncMOSPS;
use MoSharePointObjectSync\Controller\mediaLibrarySync;
use MoSharePointObjectSync\View\adminView;
use MoSharePointObjectSync\Controller\adminController;
use MoSharePointObjectSync\Observer\adminObserver;
use MoSharePointObjectSync\Observer\mediaObserver;
use MoSharePointObjectSync\Observer\shortcodeObserver;
use MoSharePointObjectSync\Wrappers\dbWrapper;
use MoSharePointObjectSync\Wrappers\pluginConstants;
use MoSharePointObjectSync\API\CustomerMOSPS;
use MoSharePointObjectSync\Observer\taxonomyObserver;
use MoSharePointObjectSync\Observer\appConfigObserver;
use MoSharePointObjectSync\Wrappers\wpWrapper;
use MoSharePointObjectSync\LicenseLibrary\Mo_License_Service;
use MoSharePointObjectSync\LicenseLibrary\Classes\Mo_License_Library;
define("\120\114\x55\107\x49\x4e\x5f\x56\105\x52\x53\x49\117\x4e", "\x32\66\56\x30\x2e\60");
define("\115\117\x5f\x53\x50\x53\137\120\x4c\x55\x47\111\116\137\x55\x52\x4c", plugins_url('', __FILE__));
if (defined("\x4d\x4f\105\123\110\x50\137\124\101\130\x4f\116\x4f\x4d\x59")) {
    goto V3;
}
define("\115\117\x45\x53\110\120\137\124\101\x58\x4f\x4e\x4f\x4d\x59", "\x6d\157\x65\163\150\x70\x2d\143\141\x74\x65\147\157\x72\x79");
V3:
class MOsps
{
    private static $instance;
    public static function mo_sps_load_instance()
    {
        if (isset(self::$instance)) {
            goto cE;
        }
        $qS = __CLASS__;
        new Mo_License_Library();
        self::$instance = new $qS();
        self::$instance->mo_sps_load_hooks();
        cE:
        return self::$instance;
    }
    public function mo_sps_load_hooks()
    {
        add_action("\x61\x64\155\x69\156\x5f\155\145\156\165", array($this, "\155\x6f\x5f\x73\x70\x73\x5f\141\x64\155\151\x6e\x5f\155\145\156\165"));
        add_action("\151\156\x69\164", array(mediaObserver::getObserver(), "\155\157\137\x73\x70\163\x5f\155\x65\x64\151\141\137\157\142\x73\x65\x72\x76\x65\x72"), 0);
        add_action("\151\x6e\x69\164", array(adminObserver::getObserver(), "\x6d\157\137\x73\160\163\137\141\144\x6d\151\x6e\x5f\x6f\x62\163\145\162\x76\145\x72"));
        add_action("\x69\x6e\x69\x74", array(taxonomyObserver::getObserver(), "\x6d\157\137\163\x70\163\137\x72\x65\x67\x69\x73\x74\145\162\137\x74\x61\x78\x6f\156\x6f\155\x79"), 1);
        add_action("\x69\156\151\164", array($this, "\x63\165\x73\164\x6f\x6d\137\x61\x74\x74\x61\x63\150\x6d\x65\x6e\x74\x5f\x70\x6f\163\x74\x5f\164\x79\160\x65"), 0);
        add_action("\x61\144\155\x69\x6e\137\x69\156\151\x74", array(adminController::getController(), "\155\x6f\x5f\x73\160\163\137\x61\x64\155\151\156\137\x63\157\x6e\x74\162\x6f\x6c\154\x65\x72"));
        add_action("\141\144\x6d\151\156\x5f\x65\156\x71\x75\145\165\145\137\x73\x63\162\151\x70\x74\163", array($this, "\155\x6f\x5f\163\x70\x73\137\x73\x65\164\x74\151\x6e\x67\x73\137\x73\x74\171\154\145"));
        add_action("\x61\144\155\x69\x6e\137\x65\156\x71\x75\145\x75\145\x5f\x73\143\x72\151\160\x74\163", array($this, "\155\x6f\x5f\x73\x70\163\137\x73\145\164\x74\x69\156\147\163\x5f\163\x63\x72\x69\160\x74\x73"));
        add_action("\167\x70\137\141\152\x61\170\x5f\x6d\x6f\137\x64\157\143\x5f\154\151\x62\137\x65\x6d\x62\145\144", array(mediaObserver::getObserver(), "\x6d\157\137\x64\157\x63\x5f\154\151\142\137\x65\155\142\x65\x64\137\x61\160\151\x5f\x68\x61\x6e\144\x6c\x65\162"));
        add_action("\x77\x70\x5f\141\x6a\x61\x78\x5f\156\x6f\160\x72\151\166\x5f\155\x6f\x5f\144\x6f\143\x5f\154\x69\142\137\145\x6d\142\x65\144", array(mediaObserver::getObserver(), "\x6d\157\137\144\157\143\x5f\x6c\x69\x62\137\145\155\x62\x65\144\x5f\x61\x70\x69\137\150\141\x6e\x64\x6c\x65\162"));
        if (!Mo_License_Service::is_customer_license_valid()) {
            goto fh;
        }
        add_action("\167\160\137\141\152\x61\x78\137\155\x6f\137\163\160\x73\x5f\163\x79\156\x63\x5f\x66\x69\154\145", array(adminObserver::getObserver(), "\155\157\x5f\163\x70\x73\137\163\x79\156\x63\x5f\146\x69\154\145"));
        add_action("\167\x70\137\141\152\x61\170\x5f\156\x6f\160\x72\151\166\x5f\155\x6f\137\x73\160\x73\137\x73\171\156\143\x5f\146\x69\x6c\x65", array(adminObserver::getObserver(), "\x6d\157\137\x73\x70\x73\137\x73\x79\156\x63\x5f\146\x69\154\x65"));
        add_action("\x77\x70\137\141\152\x61\x78\137\155\x6f\137\163\x70\163\x5f\147\145\164\x5f\x66\x69\154\x65\137\x75\162\154", array(adminObserver::getObserver(), "\x6d\157\137\163\x70\163\137\x67\x65\x74\x5f\x66\x69\154\145\137\165\162\x6c"));
        add_action("\x77\x70\137\x61\x6a\x61\170\137\x6e\157\x70\162\151\166\137\x6d\x6f\137\163\160\x73\x5f\147\x65\x74\137\146\x69\154\x65\137\165\x72\x6c", array(adminObserver::getObserver(), "\x6d\157\x5f\x73\x70\163\137\x67\145\164\x5f\x66\x69\x6c\x65\137\x75\x72\x6c"));
        add_action("\x77\x70\x5f\141\x6a\141\x78\x5f\x6d\x6f\137\x73\x70\x73\x5f\147\145\x74\x5f\165\x72\x6c\x5f\x63\x6f\156\164\145\x6e\164", array(adminObserver::getObserver(), "\x6d\157\137\x73\x70\163\137\x67\145\x74\137\x75\x72\x6c\x5f\143\x6f\x6e\164\145\156\x74"));
        add_action("\167\160\x5f\x61\x6a\x61\x78\x5f\x6e\157\160\162\151\166\137\x6d\157\x5f\x73\160\x73\x5f\147\145\164\137\165\x72\154\137\x63\x6f\156\164\x65\156\164", array(adminObserver::getObserver(), "\x6d\x6f\137\163\160\163\137\147\145\x74\x5f\x75\162\x6c\x5f\x63\157\x6e\x74\x65\156\x74"));
        add_action("\167\x70\137\141\152\141\170\137\155\x6f\137\163\x70\x73\137\163\171\156\143\x5f\x73\x70\145\x63\x69\146\x69\143\137\x66\151\x6c\145", array(adminObserver::getObserver(), "\155\x6f\x5f\x73\x70\163\x5f\x73\x79\156\x63\137\x73\160\145\x63\151\146\x69\x63\x5f\x66\151\154\x65"));
        add_action("\167\160\137\141\152\x61\170\x5f\156\157\160\162\151\x76\x5f\x6d\x6f\137\x73\x70\x73\137\163\171\x6e\143\x5f\x73\160\x65\143\151\x66\151\143\137\x66\x69\x6c\x65", array(adminObserver::getObserver(), "\x6d\x6f\x5f\x73\160\x73\137\163\x79\x6e\x63\137\163\160\145\x63\151\x66\151\x63\x5f\x66\x69\x6c\145"));
        add_action("\167\x70\x5f\141\152\141\170\137\x6d\x6f\137\163\160\163\x5f\x64\x6f\167\x6e\x6c\157\141\x64\137\146\x69\x6c\x65", array(mediaObserver::getObserver(), "\155\x6f\137\x73\x70\x73\x5f\x64\157\167\156\154\157\141\144\137\x66\x69\x6c\145"));
        add_action("\167\x70\137\141\x6a\141\x78\x5f\x6e\157\x70\x72\151\166\x5f\155\157\137\163\160\x73\x5f\x64\x6f\167\156\154\x6f\x61\144\137\146\151\x6c\145", array(mediaObserver::getObserver(), "\155\x6f\x5f\x73\160\163\x5f\x64\157\167\x6e\154\157\141\x64\137\x66\x69\x6c\x65"));
        add_action("\167\x70\137\x61\x6a\141\170\x5f\x6d\157\x5f\x64\x6f\x63\137\x6c\x69\142\x5f\x75\x70\154\x6f\x61\144", array(mediaObserver::getObserver(), "\x6d\157\137\144\157\143\x5f\x6c\x69\142\x5f\x75\160\154\157\x61\144\x5f\141\x70\x69\137\x68\141\x6e\x64\x6c\145\x72"));
        add_action("\167\x70\137\x61\x6a\141\170\137\x6e\157\160\x72\x69\x76\x5f\155\157\x5f\144\157\143\137\154\x69\x62\137\x75\x70\154\157\141\144", array(mediaObserver::getObserver(), "\x6d\x6f\x5f\x64\x6f\x63\x5f\x6c\151\x62\x5f\x75\160\154\157\x61\x64\x5f\141\160\x69\137\150\x61\x6e\144\x6c\145\162"));
        add_action("\x77\x70\137\141\x6a\141\x78\137\155\x6f\x5f\x61\x7a\165\x72\145\137\163\171\156\143\137\141\x6a\141\x78\137\163\165\x62\155\151\x74", array(mediaLibrarySync::getController(), "\155\x6f\x5f\163\160\163\137\x67\x65\164\x5f\x64\x72\x69\x76\x65\x73"));
        add_action("\x77\x70\137\141\152\x61\170\x5f\155\x6f\137\163\160\x73\137\155\x65\x64\151\141\x5f\141\x6a\141\x78\x5f\163\165\x62\155\x69\164", array(mediaLibrarySync::getController(), "\155\157\x5f\x73\x70\x73\137\155\x65\144\151\x61\137\141\152\141\170\x5f\163\165\142\x6d\151\164"));
        add_action("\x77\x70\x5f\141\x6a\141\x78\x5f\x6d\x6f\137\x73\x70\x73\x5f\x67\145\156\x65\162\141\x74\145\137\x75\x72\154", array(SyncMOSPS::getObserver(), "\155\157\137\163\160\163\137\147\x65\156\145\x72\x61\x74\x65\137\x75\x72\x6c"));
        add_action("\167\x70\137\141\x6a\x61\x78\137\155\x6f\137\163\x70\x73\x5f\163\150\157\x72\164\x63\157\144\145", array(shortcodeObserver::getObserver(), "\x6d\157\137\x73\160\163\137\x73\150\x6f\162\164\x63\157\x64\145\x5f\141\x70\x69\137\150\x61\x6e\144\154\x65\162"));
        add_action("\167\160\137\x61\152\x61\x78\137\155\157\137\x73\x70\x73\x5f\x61\x70\160\137\x63\x6f\x6e\146\x69\x67\165\x72\x61\164\151\157\156", array(appConfigObserver::getObserver(), "\x6d\x6f\137\x73\160\163\137\141\160\160\x5f\143\157\156\146\x69\x67\165\x72\141\164\x69\157\156\x5f\141\x70\151\137\x68\141\x6e\144\154\x65\162"));
        add_action("\x77\x70\x5f\x61\x6a\141\170\x5f\155\x6f\x5f\141\172\x75\x72\145\x5f\163\x79\156\143\x5f\141\x6a\x61\x78\x5f\163\165\x62\155\x69\x74", array(mediaLibrarySync::getController(), "\155\x6f\x5f\163\x70\163\137\x67\x65\164\137\x64\x72\151\x76\x65\x73"));
        fh:
        add_shortcode("\115\x4f\x5f\x53\110\101\122\105\x50\x4f\111\x4e\x54\x5f\x4c\111\102\x52\x41\122\x59", array(mediaObserver::getObserver(), "\x6d\x6f\x5f\163\160\163\137\145\x6d\142\x65\144\137\x73\150\157\x72\164\x63\157\144\145\x5f\163\x68\x61\x72\x65\x70\157\151\156\x74\x5f\154\151\x62\x72\141\162\171"));
        add_shortcode("\x4d\117\137\x53\110\x41\x52\x45\120\117\x49\116\124\x5f\x4c\x49\123\124", array(mediaObserver::getObserver(), "\x6d\x6f\137\x73\x70\x73\137\145\155\x62\x65\144\x5f\163\x68\157\x72\x74\143\x6f\144\x65\137\163\x68\141\162\145\x70\x6f\151\x6e\x74\x5f\114\x69\163\x74"));
        add_shortcode("\x4d\117\x5f\x53\x48\101\x52\x45\120\x4f\x49\116\124\137\x55\x50\114\x4f\x41\104", array(mediaObserver::getObserver(), "\155\157\x5f\x73\160\x73\137\x73\x68\157\162\x74\143\157\144\145\x5f\x75\160\x6c\x6f\x61\144\137\x69\156\x5f\163\x68\141\x72\x65\x70\x6f\151\156\x74\x5f\x6c\x69\142\162\141\x72\x79"));
        add_shortcode("\115\x4f\137\x53\x48\101\x52\x45\x50\x4f\x49\x4e\x54\137\104\111\x53\x50\x4c\x41\131\x5f\106\x49\x4c\x45\137\114\111\123\x54", array(mediaObserver::getObserver(), "\x6d\157\137\x73\x70\163\x5f\145\155\x62\145\144\x5f\x73\150\x6f\x72\x74\x63\x6f\144\145\137\x73\150\141\x72\145\160\157\x69\x6e\x74\x5f\x66\x69\154\145\137\x6c\x69\163\x74"));
        add_shortcode("\x4d\117\x5f\123\x48\x41\122\x45\120\x4f\x49\116\x54\x5f\123\x50\x45\x43\111\106\x49\103\137\x46\x49\x4c\105", array(mediaObserver::getObserver(), "\x6d\157\x5f\163\160\163\x5f\145\155\x62\145\x64\x5f\x73\x68\157\162\164\x63\157\x64\x65\137\163\150\141\162\x65\160\157\151\x6e\x74\137\x76\151\144\x65\x6f"));
        add_shortcode("\x4d\x4f\137\123\x48\101\122\105\x50\117\111\x4e\124\137\x4e\x45\127\x53", array(mediaObserver::getObserver(), "\x6d\157\137\x73\x70\x73\137\x65\x6d\x62\145\144\x5f\163\x68\x6f\162\x74\143\x6f\x64\x65\137\163\x68\141\x72\145\160\x6f\x69\x6e\x74\x5f\x6e\x65\x77\163"));
        add_shortcode("\115\x4f\137\123\x48\101\122\105\120\117\x49\x4e\124\137\x45\x56\x45\x4e\x54\123", array(mediaObserver::getObserver(), "\155\157\137\x73\x70\x73\137\145\x6d\x62\145\x64\x5f\x73\150\157\x72\164\x63\x6f\x64\145\x5f\x73\150\141\162\145\x70\157\x69\156\164\x5f\145\166\x65\156\x74\163"));
        add_shortcode("\x4d\x4f\137\x53\x48\101\x52\x45\x50\117\111\116\x54\x5f\125\x50\114\x4f\101\104\x5f\x44\x4f\x43\x55\x4d\x45\116\x54", array(mediaObserver::getObserver(), "\x6d\157\137\163\160\x73\137\x73\x68\157\162\x74\x63\x6f\x64\x65\137\125\x70\154\157\141\x64\x5f\167\157\162\x64\160\162\x65\x73\x73\137\164\157\137\x73\x68\x61\x72\x65\x70\x6f\x69\156\x74\137\x6c\x69\x62\x72\141\162\171"));
        register_activation_hook(__FILE__, array(dbWrapper::getSPSWrapper(), "\x6d\157\x5f\x73\160\163\x5f\143\x72\x65\x61\x74\x65\137\x6d\145\144\x69\141\137\x74\141\142\154\145"));
        register_deactivation_hook(__FILE__, array($this, "\155\157\x5f\x73\x70\x73\137\144\x65\141\143\x74\x69\x76\x61\164\145"));
        add_filter("\x77\x70\137\147\145\x74\x5f\141\x74\164\x61\143\x68\x6d\x65\x6e\x74\x5f\x75\162\154", array($this, "\155\x6f\x5f\x73\x70\x73\137\147\145\x74\x5f\x61\x74\164\141\143\150\x6d\145\x6e\x74\x5f\165\162\154"), 1000, 2);
        add_filter("\x77\x70\137\x70\x72\145\160\x61\x72\145\137\141\164\x74\141\x63\150\155\145\156\164\x5f\x66\x6f\x72\x5f\152\x73", array($this, "\x6d\x6f\x5f\163\160\x73\x5f\x67\x65\164\137\151\x6d\x61\147\x65\137\146\x6f\162\137\x61\x74\x74\x61\x63\x68\155\145\x6e\x74"), 100, 3);
        add_filter("\150\164\164\160\137\162\145\x71\x75\x65\x73\164\x5f\164\151\155\x65\157\165\164", array($this, "\x6d\x6f\137\x73\x70\163\137\x62\x75\155\160\x5f\162\x65\161\x75\145\163\164\x5f\164\151\x6d\145\157\165\x74"));
        add_filter("\x63\162\x6f\x6e\x5f\x73\x63\150\145\x64\x75\x6c\x65\x73", array(SyncMOSPS::getObserver(), "\155\157\137\163\160\163\x5f\143\x72\157\156\137\x63\x75\163\164\x6f\x6d\x5f\163\143\150\145\x64\x75\154\x65"));
        add_action("\x6d\x6f\137\x73\x70\163\x5f\163\171\x6e\x63\137\x64\x6f\x63\137\141\x63\x74\x69\157\156", array(SyncMOSPS::getObserver(), "\x6d\x6f\x5f\x73\x70\163\x5f\163\x79\x6e\x63\137\x64\x6f\x63\137\x61\143\164\151\157\156"), 10, 2);
        add_action("\x6d\157\x5f\x73\160\163\x5f\146\x6f\x6c\x64\x65\162\x5f\163\171\156\143\137\141\143\x74\151\157\x6e", array(SyncMOSPS::getObserver(), "\155\x6f\x5f\x73\x70\x73\x5f\x66\x6f\154\x64\145\x72\137\x73\171\x6e\x63\x5f\x61\143\x74\151\157\x6e"), 10, 1);
        register_uninstall_hook(__FILE__, "\155\x6f\137\163\160\x73\137\165\x6e\x69\156\x73\164\141\154\x6c");
        add_action("\x61\144\x6d\151\156\137\151\156\x69\x74", array($this, "\x6d\x6f\x5f\163\160\x73\137\x70\154\165\x67\151\x6e\137\x63\x68\x65\x63\x6b\137\x6d\x69\147\x72\x61\x74\151\157\x6e"));
        add_action("\x61\144\x6d\x69\156\x5f\x69\156\x69\x74", array($this, "\x6d\x6f\137\163\x70\x73\137\x70\x6c\x75\147\151\156\x5f\150\141\x6e\144\154\145\137\155\x69\147\162\141\x74\151\157\x6e\137\x61\x63\x74\151\157\156"));
    }
    function mo_sps_plugin_check_migration()
    {
        if (get_option("\x6d\x6f\x5f\163\160\163\137\141\x70\160\154\151\143\141\x74\151\x6f\156\x5f\x63\x6f\x6e\146\x69\147") && !get_option("\x6d\157\x5f\x73\160\x73\x5f\x70\x6c\x75\x67\x69\156\137\x6d\x69\147\162\x61\164\151\157\156\x5f\143\157\155\160\x6c\145\164\145\x64")) {
            goto Uh;
        }
        if (!get_option("\155\x6f\x5f\x73\x70\163\137\x61\x70\160\154\151\x63\x61\x74\x69\157\156\137\x63\x6f\156\x66\x69\x67")) {
            goto ty;
        }
        goto s9;
        Uh:
        add_action("\x61\144\x6d\151\x6e\137\x6e\x6f\x74\151\143\x65\x73", array($this, "\x6d\157\137\x73\160\x73\137\160\x6c\x75\147\151\x6e\137\x6d\x69\x67\x72\x61\x74\x69\157\x6e\x5f\x6e\x6f\x74\151\x63\x65"));
        goto s9;
        ty:
        update_option("\x6d\157\x5f\163\160\163\137\x70\154\165\147\151\156\137\x6d\151\147\x72\x61\x74\151\x6f\x6e\137\143\x6f\155\160\x6c\x65\x74\x65\x64", true);
        s9:
    }
    function mo_sps_plugin_migration_notice()
    {
        $iC = isset($_GET["\164\x61\142"]) ? $_GET["\164\141\142"] : "\x61\160\x70\137\x63\157\x6e\x66\151\x67";
        if (!(isset($_GET["\160\x61\x67\145"]) && $_GET["\160\x61\147\x65"] == "\x6d\157\137\163\x70\163" && $iC == "\141\x70\x70\x5f\143\157\156\x66\151\147")) {
            goto R2;
        }
        echo "\11\x9\x3c\144\x69\x76\40\143\154\x61\163\x73\x3d\x22\156\157\x74\151\143\145\40\156\x6f\164\151\x63\145\55\x69\156\146\x6f\x22\76\15\12\11\11\11\74\160\76\111\x74\x20\163\145\x65\155\x73\x20\x79\x6f\165\x20\141\154\162\x65\141\x64\x79\x20\150\x61\166\x65\40\x73\157\155\x65\x20\x63\157\x6e\x66\x69\x67\165\162\141\164\x69\x6f\156\163\x20\163\x65\x74\x20\x75\x70\x20\146\162\x6f\155\x20\x74\150\145\40\160\162\145\166\x69\x6f\x75\163\40\x76\x65\162\x73\x69\x6f\156\40\157\146\40\164\150\145\40\x70\x6c\165\147\151\156\56\40\103\x6c\x69\143\x6b\x20\157\x6e\40\x74\x68\x65\x20\x62\x75\164\164\x6f\x6e\40\142\145\154\x6f\x77\x20\x74\x6f\40\x6d\x69\147\x72\x61\x74\145\40\x79\157\x75\162\x20\143\157\x6e\x66\151\147\165\162\141\x74\x69\x6f\156\x73\56\74\x2f\x70\76\xd\12\11\11\11\74\146\x6f\x72\155\x20\155\x65\164\x68\157\144\75\42\160\x6f\163\x74\42\x20\141\x63\164\151\157\x6e\x3d\x22\x22\76\xd\xa\11\11\x9\11\74\x69\x6e\x70\165\164\40\x74\x79\160\145\x3d\42\150\x69\x64\144\145\x6e\x22\40\x6e\141\155\145\75\x22\155\157\137\x73\160\163\137\x70\x6c\x75\147\151\x6e\137\155\151\147\x72\141\164\151\157\x6e\x5f\141\143\164\151\x6f\x6e\x22\x20\x76\x61\154\x75\x65\x3d\x22\155\151\147\x72\x61\164\x65\x5f\143\x6f\x6e\146\151\147\x75\x72\x61\164\151\x6f\156\163\42\76\xd\xa\x9\x9\11\11";
        submit_button(__("\115\151\x67\x72\141\x74\x65\x20\x43\157\x6e\x66\x69\147\165\x72\141\164\151\x6f\156\x73"), "\x70\162\x69\155\141\162\x79", "\155\157\137\163\x70\x73\x5f\160\x6c\165\147\x69\156\x5f\155\151\147\x72\x61\164\x65\137\142\x75\164\x74\157\x6e");
        echo "\x9\11\x9\74\x2f\146\157\x72\x6d\76\15\12\11\11\74\57\x64\151\x76\76\xd\12\11\x9\11";
        R2:
    }
    function mo_sps_plugin_handle_migration_action()
    {
        if (!(isset($_POST["\155\157\137\x73\x70\163\x5f\160\x6c\x75\x67\151\x6e\137\x6d\151\x67\162\x61\164\151\x6f\x6e\x5f\x61\143\164\x69\157\x6e"]) && $_POST["\155\x6f\137\163\x70\x73\137\x70\x6c\165\x67\151\156\137\155\x69\147\162\x61\x74\x69\x6f\156\137\x61\x63\164\x69\x6f\156"] === "\155\x69\147\162\141\x74\x65\137\143\x6f\156\146\151\x67\165\x72\141\164\151\x6f\x6e\x73" && !get_option("\155\157\x5f\x73\160\x73\x5f\160\x6c\x75\147\151\x6e\x5f\x6d\x69\147\x72\x61\164\151\157\x6e\137\143\x6f\x6d\160\154\x65\x74\x65\144"))) {
            goto Pb;
        }
        wpWrapper::mo_sps_set_option(pluginConstants::TEST_CONNECTION_STATUS, "\x73\165\143\143\145\163\163");
        update_option("\155\x6f\137\x73\160\x73\x5f\x70\x6c\165\147\x69\156\137\155\x69\147\x72\x61\x74\151\157\x6e\x5f\143\x6f\155\160\154\145\x74\x65\x64", true);
        echo "\11\x9\x9\x3c\163\143\162\151\x70\164\40\164\171\160\x65\75\42\164\145\170\164\x2f\152\141\166\141\163\143\x72\151\160\x74\x22\x3e\xd\xa\11\x9\x9\11\x77\x69\x6e\x64\x6f\167\56\x6f\x6e\x6c\x6f\x61\x64\40\75\40\146\x75\156\x63\164\x69\157\x6e\x28\51\40\173\xd\12\x9\11\11\x9\x9\151\x66\40\x28\167\x69\156\x64\157\x77\56\x6c\x6f\143\x61\x74\151\x6f\x6e\x2e\x68\x72\x65\146\56\151\x6e\144\x65\170\117\146\x28\47\x70\141\147\x65\x3d\155\157\x5f\163\160\x73\46\x74\141\142\75\x61\x70\x70\137\x63\157\156\x66\151\147\47\x29\40\41\75\75\x20\x2d\61\x29\40\173\xd\12\11\x9\11\11\11\11\154\157\143\141\x74\x69\157\156\56\x72\145\x6c\157\x61\144\x28\x29\x3b\15\xa\11\11\11\11\x9\175\xd\xa\11\x9\x9\x9\x7d\73\15\xa\x9\11\x9\74\57\163\x63\162\x69\x70\164\76\15\12\11\x9\11";
        Pb:
    }
    public function custom_attachment_post_type()
    {
        $oc = array("\x6e\141\155\x65" => _x("\123\x68\x70\40\101\164\164\141\x63\x68\x6d\x65\156\x74\163", "\x50\x6f\x73\x74\40\x54\x79\x70\x65\40\107\x65\156\x65\162\141\x6c\40\116\141\155\x65", "\x74\x65\x78\x74\137\144\x6f\x6d\x61\x69\156"), "\163\x69\x6e\x67\165\x6c\141\162\x5f\x6e\x61\155\x65" => _x("\123\x68\x70\x20\101\x74\164\141\x63\150\x6d\x65\156\164", "\x50\157\163\x74\40\x54\171\160\x65\x20\123\151\156\147\x75\154\x61\x72\x20\116\x61\155\x65", "\164\x65\x78\x74\137\144\x6f\155\141\x69\156"), "\155\x65\156\x75\x5f\x6e\x61\155\x65" => __("\123\x68\x70\40\101\164\x74\x61\x63\x68\155\x65\x6e\x74\x73", "\164\x65\x78\164\x5f\144\157\x6d\x61\151\156"), "\156\x61\155\145\x5f\x61\x64\155\x69\x6e\137\142\x61\162" => __("\123\150\x70\40\101\164\164\x61\x63\x68\155\145\x6e\x74", "\x74\145\x78\164\137\x64\157\x6d\141\x69\x6e"), "\141\x72\143\150\151\x76\x65\163" => __("\x41\x74\164\141\x63\150\155\145\x6e\164\40\x41\162\x63\x68\151\x76\x65\163", "\x74\x65\170\x74\137\x64\157\155\141\151\x6e"), "\x61\x74\164\162\151\x62\x75\164\x65\163" => __("\x41\164\x74\x61\x63\x68\x6d\145\x6e\x74\x20\x41\x74\164\162\x69\142\x75\164\x65\x73", "\x74\x65\x78\x74\x5f\144\x6f\155\141\151\156"), "\160\x61\162\x65\x6e\164\137\x69\164\x65\x6d\x5f\143\x6f\x6c\x6f\156" => __("\x50\141\162\145\156\x74\40\x41\x74\x74\x61\x63\x68\155\x65\x6e\x74\x3a", "\x74\x65\170\x74\137\144\x6f\x6d\141\151\156"), "\x61\x6c\x6c\137\151\x74\x65\x6d\163" => __("\101\154\154\x20\101\164\164\141\x63\x68\x6d\145\x6e\164\163", "\x74\x65\170\x74\137\x64\157\155\141\x69\x6e"), "\x61\144\x64\x5f\x6e\x65\167\x5f\151\164\x65\155" => __("\x41\144\144\40\x4e\145\x77\x20\101\164\164\x61\x63\x68\155\x65\156\164", "\x74\x65\170\164\x5f\144\157\x6d\141\x69\x6e"), "\141\144\144\x5f\x6e\x65\167" => __("\101\x64\144\40\116\x65\167", "\x74\145\170\x74\137\144\157\x6d\141\x69\x6e"), "\156\x65\x77\x5f\151\164\145\155" => __("\116\145\167\40\101\164\164\x61\143\150\x6d\x65\x6e\164", "\x74\145\170\164\x5f\x64\157\155\141\x69\x6e"), "\x65\144\x69\x74\x5f\151\164\145\155" => __("\x45\144\151\164\x20\101\x74\x74\141\143\x68\x6d\x65\156\164", "\x74\x65\170\x74\137\x64\x6f\x6d\141\151\156"), "\x75\x70\x64\141\x74\145\x5f\151\164\145\x6d" => __("\x55\x70\x64\141\164\x65\40\101\164\164\141\x63\x68\x6d\x65\x6e\x74", "\x74\145\x78\x74\137\x64\157\155\x61\151\156"), "\x76\151\x65\x77\x5f\x69\164\x65\x6d" => __("\126\151\x65\167\x20\x41\164\164\x61\143\x68\155\x65\x6e\164", "\x74\x65\x78\164\x5f\144\157\x6d\141\151\x6e"), "\x76\x69\145\x77\137\151\164\x65\155\x73" => __("\126\x69\145\167\40\101\164\164\141\x63\150\155\x65\x6e\x74\163", "\164\x65\x78\164\x5f\x64\x6f\155\x61\151\156"), "\x73\x65\x61\x72\143\150\137\x69\164\x65\155\x73" => __("\123\145\x61\162\143\150\40\101\x74\x74\141\143\x68\x6d\x65\156\x74", "\x74\145\170\164\x5f\144\157\x6d\x61\x69\x6e"), "\156\x6f\164\x5f\x66\x6f\165\x6e\144" => __("\x41\x74\164\141\143\150\x6d\x65\x6e\x74\40\x4e\x6f\x74\40\146\x6f\165\x6e\x64", "\164\145\170\164\137\x64\x6f\155\141\x69\156"), "\156\x6f\x74\137\x66\157\x75\x6e\144\137\151\156\x5f\x74\162\141\163\x68" => __("\x41\x74\164\141\143\150\155\x65\156\x74\40\116\157\164\x20\146\157\x75\156\144\x20\x69\156\40\124\162\141\x73\x68", "\164\x65\x78\164\137\x64\157\155\141\151\x6e"), "\x66\x65\141\164\x75\162\x65\x64\x5f\151\x6d\141\x67\145" => __("\x46\x65\141\x74\165\162\x65\x64\40\x49\155\141\147\145", "\164\145\170\164\x5f\x64\x6f\155\x61\151\x6e"), "\x73\x65\x74\137\146\x65\141\164\x75\x72\145\144\x5f\x69\155\141\147\x65" => __("\123\145\x74\x20\146\x65\x61\x74\x75\162\x65\x64\40\151\155\x61\x67\145", "\164\145\170\x74\x5f\144\x6f\x6d\141\151\x6e"), "\162\145\155\157\x76\145\137\146\x65\141\164\165\162\x65\144\x5f\x69\x6d\141\147\145" => __("\x52\145\x6d\157\166\145\x20\146\145\x61\x74\165\162\145\144\x20\x69\155\x61\147\x65", "\164\145\170\164\x5f\x64\x6f\155\x61\x69\156"), "\165\x73\x65\137\146\x65\141\164\165\162\145\x64\137\x69\x6d\141\147\x65" => __("\125\163\x65\x20\x61\163\40\x66\145\141\164\165\x72\145\x64\40\151\x6d\141\147\145", "\164\x65\170\164\x5f\x64\157\155\x61\151\156"), "\x69\x6e\163\145\162\x74\x5f\151\156\164\157\x5f\x69\x74\x65\x6d" => __("\111\156\x73\145\162\x74\40\x69\x6e\x74\x6f\40\x61\164\164\141\x63\x68\155\145\156\164", "\x74\x65\x78\x74\137\144\157\155\141\x69\156"), "\x75\x70\154\x6f\141\144\x65\144\x5f\x74\x6f\137\164\x68\x69\x73\137\x69\x74\145\x6d" => __("\x55\160\154\157\141\x64\x65\x64\x20\x74\x6f\x20\x74\x68\x69\x73\x20\141\x74\164\141\x63\150\155\145\x6e\164", "\164\x65\x78\164\x5f\x64\x6f\155\x61\x69\156"), "\151\x74\x65\x6d\163\137\x6c\x69\x73\164" => __("\101\x74\164\x61\x63\150\x6d\x65\x6e\x74\163\40\154\x69\x73\164", "\164\145\x78\164\x5f\x64\x6f\155\141\151\x6e"), "\151\164\145\x6d\163\x5f\154\x69\163\x74\137\156\x61\x76\x69\x67\141\x74\x69\157\x6e" => __("\x41\164\x74\141\x63\150\155\x65\x6e\x74\163\x20\x6c\151\163\x74\x20\156\x61\x76\151\147\141\164\x69\x6f\156", "\164\145\x78\x74\x5f\x64\x6f\155\x61\151\x6e"), "\146\151\154\x74\x65\162\x5f\151\x74\x65\x6d\163\x5f\x6c\151\163\164" => __("\x46\x69\x6c\164\x65\162\x20\141\164\x74\x61\143\x68\155\x65\156\164\163\40\x6c\x69\x73\x74", "\x74\x65\170\x74\137\x64\x6f\155\141\x69\156"));
        $TO = array("\x6c\x61\142\x65\154" => __("\123\x68\160\40\101\164\x74\141\x63\x68\x6d\145\x6e\x74", "\164\145\170\164\x5f\144\x6f\155\141\x69\x6e"), "\144\145\163\143\x72\x69\160\x74\151\x6f\x6e" => __("\x53\150\x70\x20\101\x74\164\x61\x63\150\x6d\x65\x6e\x74\40\x44\145\163\x63\x72\151\x70\164\151\157\x6e", "\164\145\x78\164\x5f\x64\x6f\x6d\x61\x69\x6e"), "\x6c\x61\142\145\x6c\x73" => $oc, "\163\165\x70\x70\x6f\162\164\163" => array("\x74\x69\164\154\145", "\145\144\151\x74\x6f\x72", "\164\150\x75\155\x62\156\x61\151\154", "\145\x78\143\x65\162\x70\164", "\143\165\163\164\x6f\x6d\55\146\x69\x65\x6c\x64\163", "\x70\x61\x67\145\x2d\141\x74\x74\x72\x69\142\x75\164\145\x73"), "\164\141\x78\157\156\157\155\x69\x65\x73" => array("\143\141\164\x65\147\x6f\x72\x79", "\x70\157\x73\164\137\x74\x61\147"), "\150\151\x65\162\141\162\143\150\x69\143\x61\154" => false, "\160\x75\x62\154\151\x63" => true, "\x73\x68\x6f\167\x5f\x75\x69" => true, "\x73\x68\x6f\x77\x5f\x69\x6e\137\x6d\x65\156\165" => false, "\155\145\156\165\x5f\x70\157\x73\x69\164\151\x6f\156" => 5, "\x6d\x65\x6e\165\x5f\151\x63\157\x6e" => "\x64\x61\x73\150\151\143\x6f\156\x73\55\155\x65\144\x69\141\x2d\164\x65\170\x74", "\163\x68\x6f\x77\137\151\x6e\137\141\x64\155\x69\x6e\x5f\x62\x61\x72" => true, "\163\150\157\167\x5f\151\x6e\137\156\x61\166\137\x6d\145\x6e\x75\163" => true, "\x63\x61\156\x5f\145\170\x70\x6f\162\x74" => true, "\150\x61\x73\x5f\141\162\x63\x68\x69\166\145" => true, "\145\x78\x63\154\165\144\145\137\146\162\157\x6d\x5f\x73\x65\x61\162\x63\x68" => false, "\x70\165\142\x6c\151\x63\x6c\171\x5f\x71\165\145\x72\x79\x61\x62\x6c\145" => true, "\143\x61\x70\141\x62\x69\154\151\164\x79\x5f\164\x79\160\x65" => "\160\x6f\x73\164");
        register_post_type("\163\150\160\x5f\141\164\164\141\x63\x68\155\x65\x6e\x74", $TO);
    }
    public function mo_sps_bump_request_timeout()
    {
        return 60;
    }
    public function mo_sps_wpml_delete_duplicate_file($lF, $F8)
    {
        $o_ = get_post_meta($lF, "\x6d\x6f\137\163\x70\x73\137\146\151\x6c\x65\137\x75\x72\154", true);
        if (empty($o_)) {
            goto em;
        }
        wp_delete_post($F8, true);
        em:
    }
    public function mo_sps_pll_delete_duplicate_file($lF, $F8, $P1)
    {
        $o_ = get_post_meta($lF, "\x6d\x6f\137\x73\x70\163\137\146\x69\154\x65\x5f\x75\x72\154", true);
        if (empty($o_)) {
            goto vo;
        }
        wp_delete_post($F8, true);
        vo:
    }
    public function mo_sps_get_attachment_url($S2, $lF)
    {
        $o_ = get_post_meta($lF, "\x6d\157\x5f\x73\160\x73\137\146\x69\x6c\x65\137\165\x72\x6c", true);
        $z6 = get_post_meta($lF, "\155\157\137\x73\x70\163\x5f\x66\151\154\145\137\x65\x64\x69\x74\137\165\x72\x6c", true);
        if (!empty($o_)) {
            goto F8;
        }
        $o_ = $S2;
        F8:
        if (empty($z6)) {
            goto HT;
        }
        return $z6;
        HT:
        return $o_;
    }
    public static function mo_sps_deactivate()
    {
        if (!get_option("\163\160\x73\x5f\154\x6b")) {
            goto xa;
        }
        $B3 = new CustomerMOSPS();
        $B3->mo_sps_update_key_status();
        xa:
        delete_option("\x6d\157\137\163\160\163\x5f\x61\144\x6d\151\x6e\x5f\x70\x61\x73\163\x77\x6f\x72\x64");
        delete_option("\155\x6f\137\x73\x70\163\137\141\144\x6d\151\156\x5f\143\165\x73\164\157\155\x65\x72\x5f\x6b\x65\171");
        delete_option("\x6d\157\x5f\163\x70\x73\x5f\141\x64\155\151\156\x5f\141\160\x69\x5f\x6b\145\171");
        delete_option("\155\x6f\137\x73\x70\x73\x5f\141\144\155\x69\156\137\160\x68\x6f\x6e\145");
        delete_option("\155\x6f\137\163\160\163\x5f\162\145\147\151\163\164\x72\141\164\x69\x6f\156\x5f\163\164\141\x74\165\x73");
        delete_option("\x6d\157\x5f\x73\160\163\x5f\143\165\x73\164\157\155\x65\x72\x5f\x74\x6f\153\145\156");
        delete_option("\x73\x70\163\137\x6c\153");
        delete_option("\155\x6f\137\163\160\x73\x5f\166\x6c\137\143\x68\145\x63\x6b\137\x74");
        delete_option("\155\x6f\137\163\160\163\137\x76\154\137\143\150\145\x63\153\x5f\163");
    }
    public function mo_sps_get_image_for_attachment($Tk, $r0, $ie)
    {
        $lF = $r0->ID;
        $o_ = get_post_meta($lF, "\x6d\x6f\x5f\163\160\163\x5f\146\151\x6c\x65\x5f\165\x72\x6c", true);
        if (!($Tk["\x75\x72\154"] == $o_ && $Tk["\x74\x79\160\x65"] == "\151\x6d\141\147\x65")) {
            goto ng;
        }
        $Tk["\151\x63\157\x6e"] = $Tk["\165\162\x6c"];
        ng:
        return $Tk;
    }
    public function mo_sps_admin_menu()
    {
        $bq = add_menu_page("\155\151\x6e\151\117\x72\141\156\147\x65\x20\123\150\x61\x72\145\120\157\x69\x6e\164\40\111\x6e\x74\145\x67\162\141\x74\x69\x6f\x6e\40" . __("\53\x20\123\171\156\x63"), "\123\x68\x61\x72\x65\x50\x6f\x69\x6e\164\57\x4f\x6e\145\x44\x72\151\166\x65", "\x61\x64\155\151\x6e\x69\x73\x74\x72\141\164\157\162", "\x6d\157\137\x73\x70\163", array(adminView::getView(), "\x6d\x6f\x5f\163\x70\x73\x5f\x6d\x65\156\x75\137\x64\151\x73\x70\154\x61\171"), plugin_dir_url(__FILE__) . "\x69\155\141\x67\x65\x73\x2f\155\151\x6e\x69\157\162\141\156\x67\145\137\155\145\156\165\x2e\x70\x6e\147");
    }
    function mo_sps_settings_style($bq)
    {
        if (!($bq != "\164\157\160\154\145\x76\x65\154\x5f\x70\141\147\145\137\x6d\x6f\x5f\163\x70\x73")) {
            goto Xr;
        }
        return;
        Xr:
        $zQ = plugins_url("\151\156\143\154\x75\x64\145\163\57\x63\x73\163\57\x6d\157\137\163\x70\x73\137\163\145\164\164\151\156\147\163\x2e\143\163\x73", __FILE__);
        $sW = plugins_url("\x69\156\143\x6c\165\144\x65\163\57\143\163\163\x2f\163\x65\x6c\x65\x63\x74\167\157\157\56\155\151\x6e\x2e\x63\163\163", __FILE__);
        $ua = plugins_url("\151\x6e\x63\154\x75\x64\145\163\57\x63\163\163\x2f\x70\x68\157\156\x65\x2e\143\163\x73", __FILE__);
        wp_enqueue_style("\x6d\x6f\137\163\160\163\137\160\x68\x6f\x6e\x65\137\x63\163\163", $ua, array(), PLUGIN_VERSION);
        wp_enqueue_style("\x6d\x6f\137\163\160\x73\x5f\143\163\x73", $zQ, array(), PLUGIN_VERSION);
        wp_enqueue_style("\x6d\157\x5f\x73\x70\163\x5f\x73\x65\x6c\145\x63\x74\167\x6f\x6f\x5f\x63\x73\163", $sW, array(), PLUGIN_VERSION);
    }
    function mo_sps_settings_scripts($bq)
    {
        if (!($bq != "\164\x6f\x70\x6c\145\x76\145\154\x5f\x70\141\x67\x65\x5f\155\x6f\x5f\163\160\x73")) {
            goto V6;
        }
        return;
        V6:
        wp_enqueue_script("\x6a\161\165\x65\162\171");
        wp_enqueue_media();
        $nG = plugins_url("\x69\x6e\x63\x6c\x75\x64\x65\163\x2f\152\163\57\160\150\x6f\156\145\56\x6a\163", __FILE__);
        $k5 = plugins_url("\151\156\143\154\165\x64\x65\163\57\x6a\163\57\x6d\x6f\x5f\163\160\x73\x5f\x73\x65\x74\x74\x69\156\x67\163\x2e\152\x73", __FILE__);
        $Sc = plugins_url("\x69\x6e\x63\154\x75\x64\x65\x73\x2f\x6a\x73\57\x73\x65\154\145\x63\x74\167\157\x6f\56\x6d\x69\156\56\x6a\163", __FILE__);
        $Px = plugins_url("\151\156\x63\154\165\144\x65\163\57\x6a\x73\x2f\163\x65\154\145\x63\x74\62\x2e\155\x69\x6e\56\152\x73", __FILE__);
        wp_enqueue_script("\155\x6f\137\163\x70\x73\x5f\160\150\157\x6e\145\137\x6a\x73", $nG, array(), PLUGIN_VERSION);
        wp_enqueue_script("\163\x65\x74\164\x69\156\147\137\x6a\x73\x5f\165\x72\154", $k5, array("\152\161\165\145\x72\171"), PLUGIN_VERSION);
        wp_enqueue_script("\155\x6f\x5f\163\x70\163\x5f\x73\x65\154\145\x63\x74\167\x6f\x6f\137\x6a\163", $Sc, array("\152\161\165\x65\x72\171"), PLUGIN_VERSION);
        wp_enqueue_script("\155\x6f\137\163\x70\x73\x5f\163\145\x6c\x65\x63\x74\x32\x5f\152\163", $Px, array(), PLUGIN_VERSION);
    }
}
MOsps::mo_sps_load_instance();
