(function ($) {
    let view_mode = embedConfig.view_mode;
    let column_to_add = embedConfig.column_to_add ?? {};
    let elements_to_show = embedConfig.elements_to_show && embedConfig.elements_to_show !== '' ? embedConfig.elements_to_show : {};
    let list_option = embedConfig.list_option;
    let liverify = embedConfig.isliverify;
    let folder_download_option = embedConfig.folder_download_option;
    let preview_option = embedConfig.preview_option;
    let user_roles_emails = embedConfig.user_roles_emails;
    let folder_file_permissions = embedConfig.permissions ? JSON.parse(embedConfig.permissions) : {};
    let preview_width = embedConfig.preview_width;
    let global_search_doc = [];
    let filtered_doc = [];
    let preview_pop_up_content = [];

    let item_id = embedConfig.item_id;
    let current_db_id = embedConfig.db_id;
    let home = 'root', selected_site_id = '', selected_drive_id = '', selected_folder_id = '', currentView = 'root';
    let list_embedding_columns = embedConfig.list_embedding_columns ? JSON.parse(embedConfig.list_embedding_columns) : '';
    let list_embedding_columns_width = embedConfig.list_embedding_columns_width ? JSON.parse(embedConfig.list_embedding_columns_width) : '';
    let is_shortcode = embedConfig.is_shortcode;
    let is_plugin_view = embedConfig.is_plugin;
    let is_list_shortcode = embedConfig.is_list_shortcode;

    let sc_path = (embedConfig.sc_path != '' && embedConfig.sc_path != undefined) ? embedConfig.sc_path : { 0: 'home', 'path': 'home' };
    let breadcrumbs = [`<span index="0" class="mo_doc_lib_breadcrumb_item" id="mo_sps_breadcrumb_home_${current_db_id}"><span class="dashicons dashicons-admin-home"></span></span>`];

    if (is_shortcode) {
        selected_site_id = embedConfig.site_id;
        selected_drive_id = embedConfig.drive_id;
        selected_folder_id = embedConfig.folder_id;

        let home_item_id = embedConfig.folder_id ? embedConfig.folder_id : (embedConfig.drive_id ? embedConfig.drive_id : embedConfig.site_id);
        breadcrumbs = [`<span index="0" class="mo_doc_lib_breadcrumb_item" home_item_id="${home_item_id}" id="mo_sps_breadcrumb_home_${current_db_id}"><span class="dashicons dashicons-admin-home"></span></span>`];

        setTimeout(() => {
            load_breadcrumbs(breadcrumbs);
        }, 1000);

        if (!home_item_id) {
            home = embedConfig.connector == 'onedrive' || embedConfig.connector == 'personal' ? 'site' : 'root';
        } else {
            home = embedConfig.home;
        }
        
        if (home) {
            setTimeout(() => {
                loadPaths[home].init()
            }, 1000);
        }
        else {
            setTimeout(() => {
                $(`#mo_doc_lib_container__loader_${current_db_id}`).html('<p style="color:#9f9a9a;">You are not allowed to access the content!</p>');
            }, 3000);
        }

    } else if (embedConfig.current_state) {

        home = currentView = embedConfig.folder_id ? 'folder' : (embedConfig.drive_id ? 'drive' : (embedConfig.site_id ? 'site' : (embedConfig.connector == 'onedrive' || embedConfig.connector == 'personal' ? 'site' : 'root')));

        if(home == 'root' && (embedConfig.connector == 'onedrive' || embedConfig.connector == 'personal')) {
            currentView = 'site';
            home = 'site';
            selected_site_id = embedConfig.current_state.site_id;

        } else {
            if (embedConfig.current_state.state_name == 'site') {
                currentView = 'site';
                selected_site_id = embedConfig.current_state.site_id;
            }
            if (embedConfig.current_state.state_name == 'drive') {
                currentView = 'drive';
                selected_site_id = embedConfig.current_state.site_id;
                selected_drive_id = embedConfig.current_state.drive_id;
            }
            if (embedConfig.current_state.state_name == 'folder') {
                currentView = 'folder';
                selected_site_id = embedConfig.current_state.site_id;
                selected_drive_id = embedConfig.current_state.drive_id;
                selected_folder_id = embedConfig.current_state.folder_id;
            }
        }
         

        let saved_breadcrumb = [];
        if (embedConfig.current_state) {
            let breadcrumb = embedConfig.current_state.breadcrumb;
            breadcrumb = breadcrumb ? breadcrumb : [];
            breadcrumb.forEach(ele => {
                saved_breadcrumb.push(ele.replaceAll('\\', ''));
            });
        }

        breadcrumbs = $.isEmptyObject(saved_breadcrumb) ? [`<span index="0" class="mo_doc_lib_breadcrumb_item" id="mo_sps_breadcrumb_home_${current_db_id}"><span class="dashicons dashicons-admin-home"></span></span>`] : saved_breadcrumb;
        load_breadcrumbs(breadcrumbs);

        if (currentView) {
            setTimeout(() => {
                loadPaths[currentView].init()
            }, 1000);
        }
        else {
            setTimeout(() => {
                $(`#mo_doc_lib_container__loader_${current_db_id}`).html('<p style="color:#9f9a9a;">You are not allowed to access the content!</p>');
            }, 3000);
        }
    } else {
        if (embedConfig.connector == 'onedrive' || embedConfig.connector == 'personal') home = 'site';
        load_breadcrumbs(breadcrumbs);
        if (home) {
            setTimeout(() => {
                loadPaths[home].init()
            }, 1000);
        }
        else {
            setTimeout(() => {
                $(`#mo_doc_lib_container__loader_${current_db_id}`).html('<p style="color:#9f9a9a;">You are not allowed to access the content!</p>');
            }, 3000);
        }
    }


    let loadPaths = {
        'root': {
            'init': function (search = false) {

                currentView = 'root';

                $('.mo_doc_lib_customize_folder_view').css('display', 'flex');
                load_all_sites(search);
            },
        },
        'site': {
            'init': function (search = false) {

                currentView = 'site';
                selected_folder_id = '';
                selected_drive_id = '';

                if (embedConfig.connector == 'personal') {
                    load_all_personal_onedrives(breadcrumbs, search);
                } else if (embedConfig.connector == 'onedrive') {
                    load_all_onedrives(breadcrumbs, search);
                } else {
                    load_all_drives(selected_site_id, breadcrumbs, search);
                }
            },
        },
        'drive': {
            'init': function () {

                currentView = 'drive';
                selected_folder_id = '';

                load_all_documents(selected_drive_id, breadcrumbs);
            }
        },
        'folder': {
            'init': function () {

                currentView = 'folder';

                load_all_folder_items(selected_drive_id, selected_folder_id, breadcrumbs);
            }
        },

        'list_items': {
            'init': function () {

                currentView = 'list_itemview_modes';

                load_all_list_items(selected_site_id, selected_drive_id);
            }
        }
    }

    if(liverify) {
        eventHandlers();
    }

    function load_breadcrumbs(breadcrumbs) {

        let html = '';
        let count = 0;
        if(breadcrumbs.length > 2) {
            html += `<span class="mo_doc_lib_breadcrumb_elipsis">...
                <div id="mo_doc_lib_breadcrumb_dropdown_${current_db_id}" class="mo_doc_lib_breadcrumb_dropdown">`
                for (let i = 0; i < (breadcrumbs.length - 2); i++) {
                    html += breadcrumbs[i];
                }
                html+=`</div>
            </span>
            <span style="font-size:1.1rem;font-weight:600;display:flex;align-items:center;">></span>`;
            html += breadcrumbs[breadcrumbs.length - 2] + ' <span style="font-size:1.1rem;font-weight:600;display:flex;align-items:center;">></span> ' + breadcrumbs[breadcrumbs.length - 1];
        } else {
            breadcrumbs.forEach(element => {
                html += element + (count < breadcrumbs.length - 1 ? ' <span style="font-size:1.1rem;font-weight:600;display:flex;align-items:center;">></span> ' : '');
                count += 1;
            });
        }

        if (is_shortcode) {
            if (elements_to_show['breadcrumbs'] == 'breadcrumbs') {
                $(`#mo_doc_lib_breadcrumb_${current_db_id}`).html(html);
            } else {
                $(`#mo_doc_lib_breadcrumb_${current_db_id}`).remove();
            }
        } else {
            $(`#mo_doc_lib_breadcrumb_${current_db_id}`).html(html);
        }

        $(`span[id^='mo_sps_breadcrumb_']`).attr('disable','true');

    }

    function load_all_sites(search) {
        if (!search) {
            docLibEmbedHandleBackendCalls('mo_sps_get_all_sites', { is_plugin: is_plugin_view, sc_path: sc_path }).then((res) => {
                if (!res.success){
                    mo_doc_lib_handle_errors(res);
                    return;
                }

                var all_sites = res.data;
                if(is_shortcode && $.isEmptyObject(all_sites) && breadcrumbs.length == 1) {
                    $(`#mo_doc_lib_display_on_page_container_${current_db_id}`).hide();
                    return;
                }
                global_search_doc = all_sites;
                
                hide_show_or_disable_elements();
                render_sites(all_sites);
                
            });
        } else {
            
            render_sites(filtered_doc);
        }
    }

    function load_all_personal_onedrives(breadcrumbs, search) {
        if (!search) {
            docLibEmbedHandleBackendCalls('mo_sps_get_personal_onedrives', { current_state: breadcrumbs, is_plugin: is_plugin_view, sc_path: sc_path }).then((res) => {
                if (!res.success) {
                    mo_doc_lib_handle_errors(res);
                    return;
                }

                var all_drives = res.data;
                if(is_shortcode && $.isEmptyObject(all_drives) && breadcrumbs.length == 1) {
                    $(`#mo_doc_lib_display_on_page_container_${current_db_id}`).hide();
                    return;
                }
                global_search_doc = all_drives;
                hide_show_or_disable_elements();
                render_drives(all_drives);
                
            });
        } else {
            render_drives(filtered_doc);
        }
    }

    function load_all_onedrives(breadcrumbs, search) {
        if (!search) {
            docLibEmbedHandleBackendCalls('mo_sps_get_onedrives', { current_state: breadcrumbs, is_plugin: is_plugin_view, sc_path: sc_path }).then((res) => {
                if (!res.success) {
                    mo_doc_lib_handle_errors(res);
                    return;
                }

                var all_drives = res.data;
                if(is_shortcode && $.isEmptyObject(all_drives) && breadcrumbs.length == 1) {
                    $(`#mo_doc_lib_display_on_page_container_${current_db_id}`).hide();
                    return;
                }
                global_search_doc = all_drives;
                hide_show_or_disable_elements();
                render_drives(all_drives);
            });
        } else {
            render_drives(filtered_doc);
        }
    }

    function load_all_drives(site_id, breadcrumbs, search) {
        if (!search) {
            docLibEmbedHandleBackendCalls('mo_sps_get_all_drives', { site_id: site_id, current_state: breadcrumbs, is_plugin: is_plugin_view, sc_path: sc_path }).then((res) => {
                if (!res.success) {
                    mo_doc_lib_handle_errors(res);
                    return;
                }

                var all_drives = res.data;
                if(is_shortcode && $.isEmptyObject(all_drives) && breadcrumbs.length == 1) {
                    $(`#mo_doc_lib_display_on_page_container_${current_db_id}`).hide();
                    return;
                }
                global_search_doc = all_drives;
                hide_show_or_disable_elements();
                render_drives(all_drives);
            });
        } else {
            render_drives(filtered_doc);
        }
    }

    function load_all_documents(drive_id, breadcrumbs) {
        docLibEmbedHandleBackendCalls('mo_sps_get_all_documents', { drive_id: drive_id, current_state: breadcrumbs, is_plugin: is_plugin_view, sc_path: sc_path }).then((res) => {
            if (!res.success) {
                mo_doc_lib_handle_errors(res);
                return;
            }

            var all_docs = {'data':res.data.all_docs};
            if(res.data.parent_upload_permission){
                elements_to_show['upload_btn'] = 'upload_btn';
            }
            else {
                elements_to_show['upload_btn'] = '';
            }

            if(is_shortcode && Array.isArray(all_docs.data) && all_docs.data.length === 0 && breadcrumbs.length == 1) {
                $(`#mo_doc_lib_display_on_page_container_${current_db_id}`).hide();
                return;
            }
            hide_show_or_disable_elements();
            process_documents(all_docs, drive_id);
        });
    }

    function load_all_folder_items(drive_id, folder_id, breadcrumbs) {
        docLibEmbedHandleBackendCalls('mo_sps_get_all_folder_items', { drive_id: drive_id, folder_id: folder_id, current_state: breadcrumbs, is_plugin: is_plugin_view, sc_path: sc_path }).then((res) => {
            if (!res.success) {
                mo_doc_lib_handle_errors(res);
                return;
            }
            var all_docs = {'data':res.data.all_docs};

            if(res.data.parent_upload_permission){
                elements_to_show['upload_btn'] = 'upload_btn';
            }
            else {
                elements_to_show['upload_btn'] = '';
            }

            if(is_shortcode && Array.isArray(all_docs.data) && all_docs.data.length === 0 && breadcrumbs.length == 1) {
                $(`#mo_doc_lib_display_on_page_container_${current_db_id}`).hide();
                return;
            }
            hide_show_or_disable_elements();
            process_documents(all_docs, drive_id);
        });
    }

    function load_all_list_items(site_id, drive_id) {

        if (is_list_shortcode) {
            docLibEmbedHandleBackendCalls('mo_sps_get_all_list_items', { site_id: site_id, drive_id: drive_id, list_embedding_columns: list_embedding_columns }).then((res) => {
                if (!res.success) {
                    mo_doc_lib_handle_errors(res);
                    return;
                }
                hide_show_or_disable_elements();
                process_list_items_true(res, drive_id);
            });
        } else {
            docLibEmbedHandleBackendCalls('mo_sps_get_all_list_items', { site_id: site_id, drive_id: drive_id }).then((res) => {
                if (!res.success) {
                    mo_doc_lib_handle_errors(res);
                    return;
                }
                hide_show_or_disable_elements();
                process_list_items_true(res, drive_id);
                
            });
        }

    }

    function render_sites(all_sites) {
        // This code is added for the further implementation of grid view of sites.
        // if (view_mode == "grid_view") {
            // $(`#mo_doc_lib_container_${current_db_id}`).html(`<div class="mo_doc_lib_site_card_container" id="mo_doc_lib_site_card_container_${current_db_id}"></div>`);
            // all_sites.forEach(site => {
            //     $(`#mo_doc_lib_site_card_container_${current_db_id}`).append(`<div name="mo_doc_lib_site_${current_db_id}" breadcrumb="${site.displayName}" id="${site.id}" class="mo_doc_lib_table_site_card">
            //         <div class="mo_doc_lib_drive_list_name">
            //             <span style="color:#036c70;" class="dashicons dashicons-admin-site-alt"></span>
            //             ${site.displayName}
            //         </div>
            //         <div class="mo_doc_lib_site_card_action">
            //             ${is_shortcode ? `<div class="mo_doc_lib_col mo_doc_lib_col-2" data-label="Site Name"></div>`:`<div class="mo_doc_lib_col mo_doc_lib_col-2" data-label="Site Name"><div title="Manage Access" id="${site.id}" doc_name="${site.displayName}" doc_type="site" class="mo_doc_lib_site_manage_access mo_doc_lib_folder_file_manage_access"><img width="18px" height="18px" src="${embedConfig.add_user_icon}"/></div></div>`}
            //             <div title="${site.webUrl}" class="mo_doc_lib_col mo_doc_lib_col-3" data-label="Site URL"><div title="Preview in Sharepoint" site_url="${site.webUrl}" class="mo_doc_lib_site_manage_access mo_doc_lib_site_redirect_to_sharepoint"><img width="12px" height="12px" src="${embedConfig.redirect_icon}"/></div></div>
            //             <div class="mo_doc_lib_col mo_doc_lib_col-3" data-label="Site URL"><div title="info" site_url="${site.webUrl}" class="mo_doc_lib_options_dropdown_elipsis mo_doc_lib_site_redirect_to_sharepoint"><img width="12px" height="12px" src="${embedConfig.redirect_icon}"/></div></div>
            //         </div>
            //     </div>`);
            // });
        // } else {
            $(`#mo_doc_lib_container_${current_db_id}`).html(`<ul class="mo_doc_lib_responsive-table">
                    <li class="mo_doc_lib_table-header">
                        <div class="mo_doc_lib_col mo_doc_lib_col-1 ${liverify?'':'mo_doc_lib__disabled'}">Site Name</div>
                    </li>
                </ul>
                <ul id="mo_doc_lib_all_sites_list_${current_db_id}" class="mo_doc_lib_responsive-table mo_doc_lib_item_list"></ul>
            `);

            // manage_access
            all_sites = (Array.isArray(all_sites)) ? all_sites : [all_sites];
            var index = 0;
            if (all_sites.length === 0) {
                $(`#mo_doc_lib_all_sites_list_${current_db_id}`).css('justify-content', 'center');
                $(`#mo_doc_lib_all_sites_list_${current_db_id}`).html(`<div style="display:flex;justify-content:center;align-items:center;flex-direction:column;"><img height="350px" src="${embedConfig.empty_folder_image}"/> <span style="font-weight:500;margin:10px;">There is no site found.</span></div>`)
                return;
            }
            all_sites.forEach(site => {
                $(`#mo_doc_lib_all_sites_list_${current_db_id}`).append(`<li name="mo_doc_lib_site_${current_db_id}" breadcrumb="${site.name}" id="${site.id}" class="mo_doc_lib_table-row">
                    <div breadcrumb="${site.name}" id="${site.id}" class="mo_doc_lib_col mo_doc_lib_col-1 ${liverify?'':'mo_doc_lib__disabled'}" data-label="Site Name">
                        <div class="mo_doc_lib_drive_list_name">
                            <span style="color:#036c70;" class="dashicons dashicons-admin-site-alt"></span>
                            ${site.name}
                        </div>
                    </div>
                    <div class="mo_doc_lib_col mo_doc_lib_col-2">${create_file_folder_option_dropdown(site, index, 'info', 'site')}</div>
                    <div class="mo_doc_lib_col mo_doc_lib_col-3">${create_file_folder_option_dropdown(site, index, 'option', 'site')}</div>
                </li>`);
                index++;
            });
        // }
    }

    function render_drives(all_drives) {
        // This code is added for the further implementation of grid view of drives.
        if (view_mode == "grid_view") {

            let container = `<div id="mo_sps_doc_container_${current_db_id}" class="mo_sps_class_doc_container">
                <div id="mo_sps_doc__list_${current_db_id}" class="mo_sps_class_doc__list"></div>
                <div id="mo_sps_doc_file__list_${current_db_id}" class="mo_sps_class_doc__list"></div>
            <div>
            `;

            $(`#sps_embed_container_${current_db_id}`).html(container);
            var file_list = ``;
            var index = 0;

			if (all_drives.length === 0) {
                $(`#mo_sps_doc_file__list_${current_db_id}`).css('justify-content', 'center');
                $(`#mo_sps_doc_file__list_${current_db_id}`).html(`<div style="display:flex;justify-content:center;align-items:center;flex-direction:column;"><img height="350px" src="${embedConfig.empty_folder_image}"/> <span style="font-weight:500;margin:10px;">There is no drive found.</span></div>`)
                return;
            }
            
            all_drives.forEach(drive => {
                if (drive.list == 'genericList'){
                    type = 'genericList';
                } else {
                    type = 'documentLibrary';
                    var doc_type = 'folder';

                    icon = embedConfig.folder_icon;
                    let folder =`<div name="mo_sps_embed_drive_${type}_${current_db_id}" breadcrumb="${drive.name}" id="${drive.id}" drive_id="${drive.id}" class="mo_sps_class_embed_folder">
                        <div val="${drive.name}" breadcrumb="${drive.name}" id="${drive.id}" class="mo_sps_class_embed_folder_image_container">
                            <img breadcrumb="${drive.name}" val="${drive.name}" id="${drive.id}" class="mo_sps_class_embed_folder_image" src="${embedConfig.folder_icon}"/>
                        </div>
                        
                        <div class="mo_sps_class_embed_title_container" id="mo_sps_embed_title_container_${current_db_id}_${drive.id}">
                            <div class="mo_sps_class_embed_title" id="mo_sps_embed_title_${current_db_id}_${drive.id}">
                                ${drive.name}
                            </div>
                            <div class="mo_doc_lib_documents_option_info_container">
                                <div>${create_file_folder_option_dropdown(drive, index, 'info', 'drive')}</div>
                                <div>${create_file_folder_option_dropdown(drive, index, 'option', 'drive')}</div>
                            </div>
                        </div>
                        
                    </div>`;
                    file_list += folder;
                    index += 1;
                }
            });

            $(`#mo_sps_doc_file__list_${current_db_id}`).html(file_list);

            $(`.mo_doc_lib_file_folder_options_dropdown_down`).css('right', '-5rem');
            $(`.mo_doc_lib_file_folder_options_dropdown_up`).css('right', '-5rem');
            $(`.mo_doc_lib_file_folder_info_dropdown_down`).css('right', '-6rem');
            $(`.mo_doc_lib_file_folder_info_dropdown_up`).css('right', '-6rem');

            $(`.mo_doc_lib_file_folder_options_dropdown_down`).css('top','initial');
            $(`.mo_doc_lib_file_folder_options_dropdown_down`).css('bottom', '2rem');
            $(`.mo_doc_lib_file_folder_info_dropdown_down`).css('top','initial');
            $(`.mo_doc_lib_file_folder_info_dropdown_down`).css('bottom', '1.5rem');

        } else {
            if (is_shortcode) {
                if (Object.keys(column_to_add).length) {
                    $(`#mo_doc_lib_container_${current_db_id}`).html(`<ul class="mo_doc_lib_responsive-table">
                            <li class="mo_doc_lib_table-header">
                                ${column_to_add.name ? '<div class="mo_doc_lib_col mo_doc_lib_dcol-1">Drive Name</div>' : '<div class="mo_doc_lib_col mo_doc_lib_dcol-1"></div>'}
                                ${column_to_add.last_modified ? '<div class="mo_doc_lib_col mo_doc_lib_dcol-5">Last Modified Date</div>' : '<div class="mo_doc_lib_col mo_doc_lib_dcol-2"></div>'}
                                ${column_to_add.size ? '<div style="visibility: hidden" class="mo_doc_lib_col mo_doc_lib_dcol-6">Size</div>' : '<div class="mo_doc_lib_col mo_doc_lib_dcol-4"></div>'}
                                <div class="mo_doc_lib_col mo_doc_lib_dcol-3"></div>
                                <div class="mo_doc_lib_col mo_doc_lib_dcol-4"></div>
                            </li>
                        </ul>
                        <ul id="mo_doc_lib_all_drives_list_${current_db_id}" class="mo_doc_lib_responsive-table mo_doc_lib_item_list"></ul>
                    `);
                }
                else {
                    $(`#mo_doc_lib_container_${current_db_id}`).html(`<ul class="mo_doc_lib_responsive-table">
                            <li class="mo_doc_lib_table-header">
                                <div class="mo_doc_lib_col mo_doc_lib_dcol-1">Drive Name</div>
                                <div class="mo_doc_lib_col mo_doc_lib_dcol-5">Last Modified Date</div>
                                <div style="visibility: hidden" class="mo_doc_lib_col mo_doc_lib_dcol-6">Size</div>
                                <div class="mo_doc_lib_col mo_doc_lib_dcol-3"></div>
                                <div class="mo_doc_lib_col mo_doc_lib_dcol-4"></div>
                            </li>
                        </ul>
                        <ul id="mo_doc_lib_all_drives_list_${current_db_id}" class="mo_doc_lib_responsive-table mo_doc_lib_item_list"></ul>
                    `);
                }
            }
            else {
                $(`#mo_doc_lib_container_${current_db_id}`).html(`<ul class="mo_doc_lib_responsive-table">
                        <li class="mo_doc_lib_table-header">
                            <div class="mo_doc_lib_col mo_doc_lib_dcol-1">Drive Name</div>
                            <div class="mo_doc_lib_col mo_doc_lib_dcol-5">Last Modified Date</div>
                            <div style="visibility: hidden" class="mo_doc_lib_col mo_doc_lib_dcol-6">Size</div>
                            <div class="mo_doc_lib_col mo_doc_lib_dcol-3"></div>
                            <div class="mo_doc_lib_col mo_doc_lib_dcol-4"></div>
                        </li>
                    </ul>
                    <ul id="mo_doc_lib_all_drives_list_${current_db_id}" class="mo_doc_lib_responsive-table mo_doc_lib_item_list"></ul>
                `);
            }

            var index = 0;

            if (all_drives.length === 0) {
                $(`#mo_doc_lib_all_drives_list_${current_db_id}`).css('justify-content', 'center');
                $(`#mo_doc_lib_all_drives_list_${current_db_id}`).html(`<div style="display:flex;justify-content:center;align-items:center;flex-direction:column;"><img height="350px" src="${embedConfig.empty_folder_image}"/> <span style="font-weight:500;margin:10px;">There is no drive found.</span></div>`)
                return;
            }

            all_drives.forEach(drive => {
                if (drive.list == 'genericList'){
                    type = 'genericList';
                } else {
                    type = 'documentLibrary';


                // if (mo_doc_lib_has_permission(drive.id, 'view')) {
                    var doc_type = 'folder';
                    var icon = type == 'documentLibrary' ? embedConfig.folder_icon : embedConfig.list_icon;

                    if (is_shortcode) {
                        if (Object.keys(column_to_add).length) {
                            $(`#mo_doc_lib_all_drives_list_${current_db_id}`).append(`<li name="mo_doc_lib_drive_${type}_${current_db_id}" breadcrumb="${drive.name}" drive_id="${drive.id}" class="mo_doc_lib_table-row ${list_option == 'compact_view' ? `mo_doc_lib_table-row-compact` : ``}">
                                ${column_to_add.name ? `<div style="word-break:break-all;" name="mo_doc_lib_drive_${type}_${current_db_id} breadcrumb="${drive.name}" drive_id="${drive.id}" class="mo_doc_lib_col mo_doc_lib_dcol-1" data-label="Doc Name"><div class="mo_doc_lib_list_file_name">
                                <img id="mo_doc_lib_file_icon_${drive.id}" style="margin-right:10px" width="20px" height="20px" src="${icon}"/>
                                <span class="mo_doc_lib_doc_name">${drive.name}</span>
                            </div></div>

                            ` : `<div style="word-break:break-all;" name="mo_doc_lib_${doc_type}" breadcrumb="${drive.name}" id="${drive.id}" class="mo_doc_lib_col mo_doc_lib_dcol-1" data-label="Doc Name"></div>`}
                                ${column_to_add.last_modified ? '<div name="mo_doc_lib_' + doc_type + '" breadcrumb="' + drive.name + '" id="' + drive.id + '" class="mo_doc_lib_col mo_doc_lib_dcol-5" data-label="Doc Date">' + ((type == 'documentLibrary' && drive.lastModifiedDateTime) ? mo_sps_get_date_by_timestamp(drive.lastModifiedDateTime) : '-') + '</div>' : '<div name="mo_doc_lib_' + doc_type + '" breadcrumb="' + drive.name + '" id="' + drive.id + '" class="mo_doc_lib_col mo_doc_lib_dcol-5" data-label="Doc Date"></div>'}
                                ${column_to_add.size ? '<div style="visibility: hidden" name="mo_doc_lib_' + doc_type + '" breadcrumb="' + drive.name + '" id="' + drive.id + '" class="mo_doc_lib_col mo_doc_lib_dcol-6" data-label="Doc Size">' + (drive.quota.used ? mo_sps_get_doc_size(drive.quota.used) : '') + ' / ' + (drive.quota.total ? mo_sps_get_doc_size(drive.quota.total) : '') + '</div>' : '<div name="mo_doc_lib_' + doc_type + '" breadcrumb="' + drive.name + '" id="' + drive.id + '" class="mo_doc_lib_col mo_doc_lib_dcol-6" data-label="Doc Size"></div>'}

                                <div class="mo_doc_lib_col mo_doc_lib_dcol-3">${type == 'documentLibrary' ? `${create_file_folder_option_dropdown(drive, index, 'info', 'drive')}`:``}</div>
                                <div class="mo_doc_lib_col mo_doc_lib_dcol-4">${create_file_folder_option_dropdown(drive, index, 'option', 'drive')}</div>
                            </li>`);
                        } else {
                            $(`#mo_doc_lib_all_drives_list_${current_db_id}`).append(`<li name="mo_doc_lib_drive_${type}_${current_db_id}" breadcrumb="${drive.name}" drive_id="${drive.id}" class="mo_doc_lib_table-row ${list_option == 'compact_view' ? `mo_doc_lib_table-row-compact` : ``}">
                                <div style="word-break:break-all;" name="mo_doc_lib_drive_${type}_${current_db_id}" breadcrumb="${drive.name}" drive_id="${drive.id}" class="mo_doc_lib_col mo_doc_lib_dcol-1" data-label="Doc Name">    
                                    <div class="mo_doc_lib_list_file_name">
                                        <img id="mo_doc_lib_file_icon_${drive.id}" style="margin-right:10px" width="20px" height="20px" src="${icon}"/>
                                        <span class="mo_doc_lib_doc_name">${drive.name}</span>
                                    </div>
                                </div>

                                <div name="mo_doc_lib_${doc_type}" breadcrumb="${drive.name}" id="${drive.id}" class="mo_doc_lib_col mo_doc_lib_dcol-5" data-label="Doc Date">${((type == 'documentLibrary' && drive.lastModifiedDateTime) ? mo_sps_get_date_by_timestamp(drive.lastModifiedDateTime) : '-')}</div>
                                <div style="visibility: hidden" name="mo_doc_lib_${doc_type}" breadcrumb="${drive.name}" id="${drive.id}" class="mo_doc_lib_col mo_doc_lib_dcol-6" data-label="Doc Size">${drive.quota.used ? mo_sps_get_doc_size(drive.quota.used) : '-'} / ${drive.quota.total ? mo_sps_get_doc_size(drive.quota.total) : '-'}</div>

                                <div class="mo_doc_lib_col mo_doc_lib_dcol-3">${type == 'documentLibrary' ? `${create_file_folder_option_dropdown(drive, index, 'info', 'drive')}`:``}</div>
                                <div class="mo_doc_lib_col mo_doc_lib_dcol-4">${create_file_folder_option_dropdown(drive, index, 'option', 'drive')}</div>
                            </li>`);
                        }
                    } else {
                        $(`#mo_doc_lib_all_drives_list_${current_db_id}`).append(`<li name="mo_doc_lib_drive_${type}_${current_db_id}" breadcrumb="${drive.name}" drive_id="${drive.id}" class="mo_doc_lib_table-row ${liverify?'':'mo_doc_lib__disabled'} ${list_option == 'compact_view' ? `mo_doc_lib_table-row-compact` : ``}">
                            <div style="word-break:break-all;" name="mo_doc_lib_drive_${type}_${current_db_id}" breadcrumb="${drive.name}" drive_id="${drive.id}" class="mo_doc_lib_col mo_doc_lib_dcol-1" data-label="Doc Name">
                                <div class="mo_doc_lib_list_file_name">
                                    <img id="mo_doc_lib_file_icon_${drive.id}" style="margin-right:10px" width="25px" height="25px" src="${icon}"/>
                                    <span class="mo_doc_lib_doc_name">${drive.name}</span>
                                </div>
                            </div>

                            <div name="mo_doc_lib_${doc_type}" breadcrumb="${drive.name}" id="${drive.id}" class="mo_doc_lib_col mo_doc_lib_dcol-5" data-label="Doc Date">${((type == 'documentLibrary' && drive.lastModifiedDateTime)? mo_sps_get_date_by_timestamp(drive.lastModifiedDateTime) : '-')}</div>
                            <div style="visibility: hidden" name="mo_doc_lib_${doc_type}" breadcrumb="${drive.name}" id="${drive.id}" class="mo_doc_lib_col mo_doc_lib_dcol-6" data-label="Doc Size">${drive.quota.used ? mo_sps_get_doc_size(drive.quota.used) : '-'} / ${drive.quota.total ? mo_sps_get_doc_size(drive.quota.total) : '-'}</div>

                            <div class="mo_doc_lib_col mo_doc_lib_dcol-3">${type == 'documentLibrary' ? `${create_file_folder_option_dropdown(drive, index, 'info', 'drive')}`:``}</div>
                            <div class="mo_doc_lib_col mo_doc_lib_dcol-4">${create_file_folder_option_dropdown(drive, index, 'option', 'drive')}</div>
                        </li>`);
                    }
                }
                // }

                index++;
            });
        }
    }

    function process_documents(res, drive_id) {
        if (view_mode == "grid_view") {
            // Grid View

            let container = `<div id="mo_sps_doc_container_${current_db_id}" class="mo_sps_class_doc_container">
                <div id="mo_sps_doc__list_${current_db_id}" class="mo_sps_class_doc__list"></div>
                <div id="mo_sps_doc_file__list_${current_db_id}" class="mo_sps_class_doc__list"></div>
            <div>
            `;

            $(`#sps_embed_container_${current_db_id}`).html(container);

            let all_docs = res.data;
            let folder_list = ``;
            let file_list = ``;
            let all_docs_length = all_docs.length;
            var index = 0;

            all_docs.forEach(doc => {
                let icon = embedConfig.file_icon;
                let doc_type = 'file';
                // if (mo_doc_lib_has_permission(doc.id, 'view')) {
                    if (doc.id === selected_folder_id) {
                        all_docs_length = all_docs_length - 1;
                    } else {
                        if (doc.folder != undefined) {
                            icon = embedConfig.folder_icon;
                            doc_type = 'folder';
                            let folder =`<div name="sps_embed_folder_${current_db_id}" breadcrumb="${doc.name}" val="${doc.name}" id="${doc.id}" class="mo_sps_class_embed_folder">
                                <div val="${doc.name}" breadcrumb="${doc.name}" id="${doc.id}" class="mo_sps_class_embed_folder_image_container">
                                    <img breadcrumb="${doc.name}" val="${doc.name}" id="${doc.id}" class="mo_sps_class_embed_folder_image" src="${embedConfig.folder_icon}"/>
                                </div>
                                
                                <div class="mo_sps_class_embed_title_container" id="mo_sps_embed_title_container_${current_db_id}_${doc.id}">
                                    <div class="mo_sps_class_embed_title" id="mo_sps_embed_title_${current_db_id}_${doc.id}">
                                        ${doc.name}
                                    </div>
                                    <div class="mo_doc_lib_documents_option_info_container">
                                        <div>${create_file_folder_option_dropdown(doc, index, 'info', 'folder')}</div>
                                        <div>${create_file_folder_option_dropdown(doc, index, 'option', 'folder')}</div>
                                    </div>
                                </div>
                                
                            </div>`;

                            // folder_list += folder;
                            file_list += folder;

                        } else {
                            file_type = doc.name.split('.');
                            file_type = file_type.pop();
                            if ( 'url' !== file_type ) preview_pop_up_content.push(doc);
                            let docSize = doc.size ? mo_sps_get_doc_size(doc.size) : '0 B';
                            if(embedConfig.connector !== 'personal') {
                                let thumbnailRequired = ['png', 'jpg', 'jpeg', 'mp4', 'avi', 'xlsx', 'xls', 'xlw', 'xlsm', 'ods', 'doc', 'docx', 'docm', 'pdf'];

                                if (thumbnailRequired.includes(file_type)) {
                                    icon = embedConfig.load_icon;

                                    docLibEmbedHandleBackendCallsForThumnails('mo_sps_get_file_thumbnails', { drive_id: drive_id, file_id: doc.id }).then((res) => {
                                        if (!res.success) {
                                            mo_doc_lib_handle_errors(res);
                                            return;
                                        }
                                        icon = res.data;

                                        $(`.mo_doc_lib_file_icon_${doc.id}`).attr('src', res.data);
                                    });
                                }
                            }

                            if (file_type == 'doc' || file_type == 'docx' || file_type == 'docm')
                                icon = embedConfig.worddoc_icon;
                            else if (file_type == 'xlw' || file_type == 'xls' || file_type == 'xlt' || file_type == 'xlsm' || file_type == 'xlsb' || file_type == 'xltx' || file_type == 'xltm' || file_type == 'xlam' || file_type == 'ods' || file_type == 'xlsx')
                                icon = embedConfig.exceldoc_icon;
                            else if (file_type == 'pdf')
                                icon = embedConfig.pdfdoc_icon;
                            else if (file_type == 'url')
                                icon = embedConfig.url_icon;

                            if (doc.download_url != undefined) {
                                let file =
                                    `<div id="mo_doc_lib_grid_files_${doc.id}" doc_id="${doc.id}" ${ 'url' !== file_type ? `key="${preview_pop_up_content.length - 1}"` : ``} title="name: ${doc.name}\nsize: ${docSize}" name="${file_type != 'url' ? 'mo_doc_lib_grid_file' : 'mo_doc_lib_grid_url'}_${current_db_id}" doc_name="${doc.name}" web_url="${doc.webUrl}" download_url="${doc.download_url}" class="mo_sps_class_embed_file">
                                        <div id="${doc.id}" class="mo_sps_class_embed_file_image_container" >
                                            <img id="${doc.id}" class="mo_doc_lib_file_icon_${doc.id} mo_sps_class_embed_file_image" src="${icon}"/>
                                        </div>
                                        <div class="mo_sps_class_embed_title_container" id="mo_sps_embed_title_container_${current_db_id}_${doc.id}">
                                            <div class="mo_sps_class_embed_title" id="mo_sps_embed_title_${current_db_id}_${doc.id}">
                                                ${doc.name}
                                            </div>
                                            <div class="mo_doc_lib_documents_option_info_container">
                                                <div>${create_file_folder_option_dropdown(doc, index, 'info', 'file')}</div>
                                                <div>${create_file_folder_option_dropdown(doc, index, 'option', 'file')}</div>
                                            </div>
                                        </div>
                                    </div>`;
                                file_list += file;

                            } else {
                                if (file_type != 'url') {

                                    let file = `<div id="mo_doc_lib_grid_files_${doc.id}" doc_id="${doc.id}" ${ 'url' !== file_type ? `key="${preview_pop_up_content.length - 1}"` : ``} title="name: ${doc.name}\nsize: ${docSize}" name="mo_doc_lib_grid_${doc_type}_${current_db_id}" doc_name="${doc.name}" web_url="${doc.webUrl}" class="mo_sps_class_embed_file">
                                        <div id="${doc.id}" class="mo_sps_class_embed_file_image_container">
                                            <img id="${doc.id}" class="mo_doc_lib_file_icon_${doc.id} mo_sps_class_embed_file_image" src="${icon}"/> 
                                        </div>
                                        <div class="mo_sps_class_embed_title_container" id="mo_sps_embed_title_container_${current_db_id}_${doc.id}">
                                            <div class="mo_sps_class_embed_title" id="mo_sps_embed_title_${current_db_id}_${doc.id}">
                                                ${doc.name}
                                            </div>
                                            <div class="mo_doc_lib_documents_option_info_container">
                                                <div>${create_file_folder_option_dropdown(doc, index, 'info', 'file')}</div>
                                                <div>${create_file_folder_option_dropdown(doc, index, 'option', 'file')}</div>
                                            </div>
                                        </div>
                                    </div>`;
                                    file_list += file;
                                }
                                else {
                                    let file = `<div id="mo_doc_lib_grid_files_${doc.id}" doc_id="${doc.id}" ${ 'url' !== file_type ? `key="${preview_pop_up_content.length - 1}"` : ``} title="name: ${doc.name}\nsize: ${docSize}" name="mo_doc_lib_grid_${file_type}_${current_db_id}" doc_name="${doc.name}" web_url="${doc.webUrl}" class="mo_sps_class_embed_file">
                                            <div id="${doc.id}" class="mo_sps_class_embed_file_image_container">
                                                <img id="${doc.id}" class="mo_doc_lib_file_icon_${doc.id} mo_sps_class_embed_file_image" src="${icon}"/>
                                            </div>
                                            <div class="mo_sps_class_embed_title_container" id="mo_sps_embed_title_container_${current_db_id}_${doc.id}">
                                                <div class="mo_sps_class_embed_title" id="mo_sps_embed_title_${current_db_id}_${doc.id}">
                                                    ${doc.name}
                                                </div>
                                                <div class="mo_doc_lib_documents_option_info_container">
                                                    <div>${create_file_folder_option_dropdown(doc, index, 'info', 'file')}</div>
                                                    <div>${create_file_folder_option_dropdown(doc, index, 'option', 'file')}</div>
                                                </div>
                                            </div>
                                        </div>`;
                                    file_list += file;
                                }

                            }
                        }
                    }
                // }
                index++;
            });
            if (all_docs_length === 0) {
                $(`#mo_sps_doc__list_${current_db_id}`).css('justify-content', 'center');
                $(`#mo_sps_doc__list_${current_db_id}`).html(`<div style="display:flex;justify-content:center;align-items:center;flex-direction:column;"><img height="400px" src="${embedConfig.empty_folder_image}"/> <span style="font-weight:500;margin:10px;">This folder is empty</span></div>`)
                return;
            }
            $(`#mo_sps_doc__list_${current_db_id}`).html(folder_list);
            $(`#mo_sps_doc_file__list_${current_db_id}`).html(file_list);
            $(`.mo_doc_lib_file_folder_options_dropdown_down`).css('right', '-5rem');
            $(`.mo_doc_lib_file_folder_options_dropdown_up`).css('right', '-5rem');
            $(`.mo_doc_lib_file_folder_info_dropdown_down`).css('right', '-6rem');
            $(`.mo_doc_lib_file_folder_info_dropdown_up`).css('right', '-6rem');

            $(`.mo_doc_lib_file_folder_options_dropdown_down`).css('top','initial');
            $(`.mo_doc_lib_file_folder_options_dropdown_down`).css('bottom', '2rem');
            $(`.mo_doc_lib_file_folder_info_dropdown_down`).css('top','initial');
            $(`.mo_doc_lib_file_folder_info_dropdown_down`).css('bottom', '1.5rem');

        } else {

            // List View

            let all_docs = res.data;

            if (is_shortcode) {
                if (Object.keys(column_to_add).length) {

                    $(`#mo_doc_lib_container_${current_db_id}`).html(`<ul class="mo_doc_lib_responsive-table">
                            <li class="mo_doc_lib_table-header">
                                ${column_to_add.name ? '<div class="mo_doc_lib_col mo_doc_lib_dcol-1">Name</div>' : '<div class="mo_doc_lib_col mo_doc_lib_dcol-1"></div>'}
                                ${column_to_add.last_modified ? '<div class="mo_doc_lib_col mo_doc_lib_dcol-5">Last Modified Date</div>' : '<div class="mo_doc_lib_col mo_doc_lib_dcol-5"></div>'}
                                ${column_to_add.size ? '<div class="mo_doc_lib_col mo_doc_lib_dcol-6">Size</div>' : '<div class="mo_doc_lib_col mo_doc_lib_dcol-6"></div>'}
                                <div class="mo_doc_lib_col mo_doc_lib_dcol-3"></div>
                                <div class="mo_doc_lib_col mo_doc_lib_dcol-4"></div>
                            </li>
                        </ul>
                        <ul id="mo_doc_lib_all_docs_list_${current_db_id}" class="mo_doc_lib_responsive-table mo_doc_lib_item_list"></ul>
                    `);
                }
                else {
                    $(`#mo_doc_lib_container_${current_db_id}`).html(`<ul class="mo_doc_lib_responsive-table">
                            <li class="mo_doc_lib_table-header">
                                <div class="mo_doc_lib_col mo_doc_lib_dcol-1">Name</div>
                                <div class="mo_doc_lib_col mo_doc_lib_dcol-5">Last Modified Date</div>
                                <div class="mo_doc_lib_col mo_doc_lib_dcol-6">Size</div>
                                <div class="mo_doc_lib_col mo_doc_lib_dcol-3"></div>
                                <div class="mo_doc_lib_col mo_doc_lib_dcol-4"></div>
                            </li>
                        </ul>
                        <ul id="mo_doc_lib_all_docs_list_${current_db_id}" class="mo_doc_lib_responsive-table mo_doc_lib_item_list ${liverify?'':'mo_doc_lib__disabled'}"></ul>
                    `);
                }
            }
            else {
                $(`#mo_doc_lib_container_${current_db_id}`).html(`<ul class="mo_doc_lib_responsive-table">
                        <li class="mo_doc_lib_table-header">
                            <div class="mo_doc_lib_col mo_doc_lib_dcol-1">Name</div>
                            <div class="mo_doc_lib_col mo_doc_lib_dcol-5">Last Modified Date</div>
                            <div class="mo_doc_lib_col mo_doc_lib_dcol-6">Size</div>
                            <div class="mo_doc_lib_col mo_doc_lib_dcol-3"></div>
                            <div class="mo_doc_lib_col mo_doc_lib_dcol-4"></div>
                        </li>
                    </ul>
                    <ul id="mo_doc_lib_all_docs_list_${current_db_id}" class="mo_doc_lib_responsive-table mo_doc_lib_item_list"></ul>
                `);
            }


            if (all_docs.length === 0) {
                $(`#mo_doc_lib_all_docs_list_${current_db_id}`).append(`<li style="display:flex;justify-content:center">
                    <img src="${embedConfig.empty_folder_image}" height="400px"/>
                    </li>`);
            }

            let all_docs_length = all_docs.length;
            $("#mo_doc_lib_sc_tree__home").html('');
            var index = 0;
            preview_pop_up_content = [];
            all_docs.forEach(doc => {

                let lastModifiedDateTime = doc.lastModifiedDateTime?mo_sps_get_date_by_timestamp(doc.lastModifiedDateTime):'';
                let docSize = doc.size ? mo_sps_get_doc_size(doc.size) : '0 B';
                if (doc.id === selected_folder_id) {
                    all_docs_length = all_docs_length - 1;
                } else {
                    let icon = embedConfig.file_icon;
                    let doc_type = 'file';
                    if (doc.folder != undefined) {
                        icon = embedConfig.folder_icon;
                        doc_type = 'folder';
                    } else {
                        file_type = doc.name.split('.');
                        file_type = file_type.pop();

                        if ( 'url' !== file_type ) preview_pop_up_content.push(doc);

                        if(embedConfig.connector !== 'personal') {
                            let thumbnailRequired = ['png', 'jpg', 'jpeg', 'mp4', 'avi'];
                            if (thumbnailRequired.includes(file_type)) {
                                icon = embedConfig.load_icon;
                                docLibEmbedHandleBackendCallsForThumnails('mo_sps_get_file_thumbnails', { drive_id: drive_id, file_id: doc.id }).then((res) => {
                                    if (!res.success) {
                                        mo_doc_lib_handle_errors(res);
                                        return;
                                    }

                                    icon = res.data;
                                    $(`#mo_doc_lib_file_icon_${current_db_id}_${doc.id}`).attr('src', res.data);
                                });
                            }
                        }

                        if (file_type == 'doc' || file_type == 'docx' || file_type == 'docm')
                            icon = embedConfig.worddoc_icon;
                        else if (file_type == 'xlw' || file_type == 'xls' || file_type == 'xlt' || file_type == 'xlsm' || file_type == 'xlsb' || file_type == 'xltx' || file_type == 'xltm' || file_type == 'xlam' || file_type == 'ods' || file_type == 'xlsx')
                            icon = embedConfig.exceldoc_icon;
                        else if (file_type == 'pdf')
                            icon = embedConfig.pdfdoc_icon;
                        else if (file_type == 'url')
                            icon = embedConfig.url_icon;
                    }


                    // if (mo_doc_lib_has_permission(doc.id, 'view')) {
                        file_type = doc.name.split('.');
                        file_type = file_type.pop();

                        if (doc_type == 'file' && file_type == 'url')
                            doc_type = file_type;

                        let d_content;

                        if (doc_type === 'file' && doc.download_url != undefined) {
                            if (doc.download_url != undefined) {
                                var download_ajax = `${embedConfig.ajax_url}?action=mo_sps_download_file&drive_id=${selected_drive_id}&file_id=${doc.id}`;
                                d_content = `<a onclick='event.stopPropagation();' class="mo_doc_lib_file_download" href="${download_ajax}"><span class="dashicons dashicons-download"></span></a>`;
                            } else
                                d_content = `-`;
                        } else {
                            d_content = `<div id="${doc.id}" breadcrumb="${doc.name}" class="mo_doc_lib_download_zip_file mo_doc_lib_col mo_doc_lib_fcol-5" data-label="Download">
                            ${doc.size ? `<span class="dashicons dashicons-download"></span>` : '-'}
                            </div><div style="display:none;" 
                            id="mo_sps_downloading_${current_db_id}" class="mo_sps_downloading">Download...0%</div>`;
                        }

                        if (is_shortcode) {

                            if (Object.keys(column_to_add).length) {
                                $(`#mo_doc_lib_all_docs_list_${current_db_id}`).append(`<li name="mo_doc_lib_${doc_type}_${current_db_id}_${doc.id}" web_url="${doc.webUrl}" breadcrumb="${doc.name}" id="${doc.id}" ${ 'url' !== file_type ? `key="${preview_pop_up_content.length - 1}"` : ``} class="mo_doc_lib_table-row ${liverify?'':'mo_doc_lib__disabled'} ${list_option == 'compact_view' ? `mo_doc_lib_table-row-compact` : ``}">
                                        ${column_to_add.name ? `<div style="word-break:break-all;" name="mo_doc_lib_${doc_type}" breadcrumb="${doc.name}" id="${doc.id}" class="mo_doc_lib_col mo_doc_lib_dcol-1" data-label="Doc Name"><div class="mo_doc_lib_list_file_name">
                                            <img id="mo_doc_lib_file_icon_${current_db_id}_${doc.id}" style="margin-right:10px" width="25px" height="25px" src="${icon}"/>
                                            <span class="mo_doc_lib_doc_name">${doc.name}</span>
                                    </div></div>
                                    ` : `<div style="word-break:break-all;" name="mo_doc_lib_${doc_type}" breadcrumb="${doc.name}" id="${doc.id}" class="mo_doc_lib_col mo_doc_lib_dcol-1" data-label="Doc Name"></div>`}
                                    
                                    ${column_to_add.last_modified ? '<div name="mo_doc_lib_' + doc_type + '" breadcrumb="' + doc.name + '" id="' + doc.id + '" class="mo_doc_lib_col mo_doc_lib_dcol-5" data-label="Doc Date">' + lastModifiedDateTime + '</div>' : '<div name="mo_doc_lib_' + doc_type + '" breadcrumb="' + doc.name + '" id="' + doc.id + '" class="mo_doc_lib_col mo_doc_lib_dcol-5" data-label="Doc Date"></div>'}
                                    ${column_to_add.size ? '<div name="mo_doc_lib_' + doc_type + '" breadcrumb="' + doc.name + '" id="' + doc.id + '" class="mo_doc_lib_col mo_doc_lib_dcol-6" data-label="Doc Size">' + (docSize) + '</div>' : '<div name="mo_doc_lib_' + doc_type + '" breadcrumb="' + doc.name + '" id="' + doc.id + '" class="mo_doc_lib_col mo_doc_lib_dcol-6" data-label="Doc Size"></div>'}

                                    ${doc_type == 'folder' ? `
                                        <div class="mo_doc_lib_col mo_doc_lib_dcol-3">${create_file_folder_option_dropdown(doc, index, 'info', 'folder')}</div>
                                        <div class="mo_doc_lib_col mo_doc_lib_dcol-4">${create_file_folder_option_dropdown(doc, index, 'option', 'folder')}</div>`
                                        : 
                                        `<div class="mo_doc_lib_col mo_doc_lib_dcol-3">${create_file_folder_option_dropdown(doc, index, 'info', 'file')}</div>
                                        <div class="mo_doc_lib_col mo_doc_lib_dcol-4">${create_file_folder_option_dropdown(doc, index, 'option', 'file')}</div>`
                                    }
                                </li>`);
                            } else {
                                $(`#mo_doc_lib_all_docs_list_${current_db_id}`).append(`<li name="mo_doc_lib_${doc_type}_${current_db_id}_${doc.id}" breadcrumb="${doc.name}" web_url="${doc.webUrl}" id="${doc.id}" ${ 'url' !== file_type ? `key="${preview_pop_up_content.length - 1}"` : ``} class="mo_doc_lib_table-row ${liverify?'':'mo_doc_lib__disabled'} ${list_option == 'compact_view' ? `mo_doc_lib_table-row-compact` : ``}">
                                    <div style="word-break:break-all;" name="mo_doc_lib_${doc_type}" breadcrumb="${doc.name}" id="${doc.id}" class="mo_doc_lib_col mo_doc_lib_dcol-1" data-label="Doc Name">    
                                        <div class="mo_doc_lib_list_file_name">
                                            <img id="mo_doc_lib_file_icon_${current_db_id}_${doc.id}" style="margin-right:10px" width="25px" height="25px" src="${icon}"/>
                                            <span class="mo_doc_lib_doc_name">${doc.name}</span>
                                        </div>
                                    </div>
                                    
                                    <div name="mo_doc_lib_${doc_type}" breadcrumb="${doc.name}" id="${doc.id}" class="mo_doc_lib_col mo_doc_lib_dcol-5" data-label="Doc Date">${lastModifiedDateTime}</div>
                                    <div name="mo_doc_lib_${doc_type}" breadcrumb="${doc.name}" id="${doc.id}" class="mo_doc_lib_col mo_doc_lib_dcol-6" data-label="Doc Size">${docSize}</div>

                                    ${doc_type == 'folder' ? `
                                        <div class="mo_doc_lib_col mo_doc_lib_dcol-3">${create_file_folder_option_dropdown(doc, index, 'info', 'folder')}</div>
                                        <div class="mo_doc_lib_col mo_doc_lib_dcol-4">${create_file_folder_option_dropdown(doc, index, 'option', 'folder')}</div>`
                                        : 
                                        `<div class="mo_doc_lib_col mo_doc_lib_dcol-3">${create_file_folder_option_dropdown(doc, index, 'info', 'file')}</div>
                                        <div class="mo_doc_lib_col mo_doc_lib_dcol-4">${create_file_folder_option_dropdown(doc, index, 'option', 'file')}</div>`
                                    }
                                </li>`);
                            }
                        } else {
                            $(`#mo_doc_lib_all_docs_list_${current_db_id}`).append(`<li name="mo_doc_lib_${doc_type}_${current_db_id}_${doc.id}" breadcrumb="${doc.name}" download_url="${doc.download_url}" web_url="${doc.webUrl}" id="${doc.id}" ${ 'url' !== file_type ? `key="${preview_pop_up_content.length - 1}"` : ``} class="mo_doc_lib_table-row ${liverify?'':'mo_doc_lib__disabled'} ${list_option == 'compact_view' ? `mo_doc_lib_table-row-compact` : ``}">
                                <div style="word-break:break-all;" name="mo_doc_lib_${doc_type}" breadcrumb="${doc.name}" id="${doc.id}" class="mo_doc_lib_col mo_doc_lib_dcol-1" data-label="Doc Name">
                                    <div class="mo_doc_lib_list_file_name">
                                        <img id="mo_doc_lib_file_icon_${current_db_id}_${doc.id}" style="margin-right:10px" width="25px" height="25px" src="${icon}"/>
                                        <span class="mo_doc_lib_doc_name">${doc.name}</span>
                                    </div>
                                </div>
                                
                                <div name="mo_doc_lib_${doc_type}" breadcrumb="${doc.name}" id="${doc.id}" class="mo_doc_lib_col mo_doc_lib_dcol-5" data-label="Doc Date">${lastModifiedDateTime}</div>
                                <div name="mo_doc_lib_${doc_type}" breadcrumb="${doc.name}" id="${doc.id}" class="mo_doc_lib_col mo_doc_lib_dcol-6" data-label="Doc Size">${docSize}</div>

                                ${doc_type == 'folder' ? `<div class="mo_doc_lib_col mo_doc_lib_dcol-3">${create_file_folder_option_dropdown(doc, index, 'info', 'folder')}</div>
                                    <div class="mo_doc_lib_col mo_doc_lib_dcol-4">${create_file_folder_option_dropdown(doc, index, 'option', 'folder')}</div>`
                                    :
                                    `<div class="mo_doc_lib_col mo_doc_lib_dcol-3">${create_file_folder_option_dropdown(doc, index, 'info', 'file')}</div>
                                    <div class="mo_doc_lib_col mo_doc_lib_dcol-4">${create_file_folder_option_dropdown(doc, index, 'option', 'file')}</div>`
                                }
                            </li>`);
                        }
                    // }
                }
                index++;
            });
        }
    }

    function process_list_items(res, drive_id) {
        let all_docs = res.data[0];

        if (all_docs.length !== 0) {
            let first_data = all_docs[0]
            const keys = Object.keys(first_data);
            const width_keys = Object.keys(list_embedding_columns_width);

            let number_of_columns = Object.keys(all_docs[0]).length;
            if (is_list_shortcode) {
                let content = `<div class="main"><ul id="mo_doc_lib_all_docs_list" class="mo_doc_lib_responsive-table">
                  
                  <li style="width:fit-content;" class="mo_doc_lib_table-header list_header">`;
                for (let i = 0; i < keys.length; i++) {
                    for (const attr in list_embedding_columns_width) {
                        if (attr === keys[i])
                            if (list_embedding_columns_width[attr])
                                content += '<div style="flex-basis:' + list_embedding_columns_width[attr] + '%;margin-left: 8px;margin-right: 8px;word-break:break-all;" class="mo_doc_lib_col mo_doc_lib_fcol-' + (i + 1) + '">' + keys[i] + '</div>';
                            else
                                content += '<div style="flex-basis:15%;margin-left: 8px;margin-right: 8px;word-break:break-all;" class="mo_doc_lib_col mo_doc_lib_fcol-' + (i + 1) + '">' + keys[i] + '</div>';

                    }
                }
                content += '</li></ul></div>';
                $("#mo_doc_lib_container").html(content);
            }
            else {
                $("#mo_doc_lib_container").html(`<ul id="mo_doc_lib_all_docs_list" class="mo_doc_lib_responsive-table">
                <li class="mo_doc_lib_table-header">
                    <div class="mo_doc_lib_col mo_doc_lib_dcol-1">Id</div>
                    <div class="mo_doc_lib_col mo_doc_lib_fcol-1">Title</div>
                    <div class="mo_doc_lib_col mo_doc_lib_fcol-2">Last Modified Date</div>
                    <div class="mo_doc_lib_col mo_doc_lib_fcol-4">Modified By</div>  
                </li>
            </ul>`);
            }
        }
        else {
            $("#mo_doc_lib_container").html(`<ul id="mo_doc_lib_all_docs_list" class="mo_doc_lib_responsive-table">
            <li class="mo_doc_lib_table-header">
                <div class="mo_doc_lib_col mo_doc_lib_dcol-1">Id</div>
                <div class="mo_doc_lib_col mo_doc_lib_dcol-1">Title</div>
                <div class="mo_doc_lib_col mo_doc_lib_dcol-2">Last Modified Date</div>
                <div class="mo_doc_lib_col mo_doc_lib_dcol-4">Modified By</div>  
            </li>
        </ul>`);
        }

        if (all_docs.length === 0) {
            $("#mo_doc_lib_all_docs_list").append(`<li style="display:flex;justify-content:center">
            <img src="${embedConfig.empty_folder_image}" height="400px"/>
            </li>`);
        }

        if (is_list_shortcode) {
            all_docs.forEach(doc => {

                let content = `<li style="width:max-content;" name="mo_doc_lib" class="mo_doc_lib_list-row">`;
                const keys = Object.keys(doc);
                for (let i = 0; i < keys.length; i++) {
                    const key = keys[i];

                    if (doc[key].url) {
                        for (const attr in list_embedding_columns_width) {
                            if (attr === keys[i]) {
                                if (list_embedding_columns_width[attr])
                                    content += '<div style="flex-basis:' + list_embedding_columns_width[attr] + '%;margin-left: 8px;margin-right: 8px;word-break:break-all;" name="mo_doc_lib" breadcrumb="' + keys[i] + '" id="' + keys[i] + '" class="mo_list_row mo_doc_lib_col mo_doc_lib_fcol-' + (i + 1) + '" data-label="' + keys[i] + ' "><a target="_blank" class="mo_doc_lib_file_download" href="' + doc[key].url + '"><b>' + doc[key].url + '</b></a></div>';
                                else
                                    content += '<div style="flex-basis:15%;margin-left: 8px;margin-right: 8px;word-break:break-all;" name="mo_doc_lib" breadcrumb="' + keys[i] + '" id="' + keys[i] + '" class="mo_doc_lib_col mo_doc_lib_fcol-' + (i + 1) + '" data-label="' + keys[i] + ' "><a target="_blank" class="mo_doc_lib_file_download" href="' + doc[key].url + '"><b>' + doc[key].url + '</b></a></div>';
                            }
                        }
                    }
                    else {
                        for (const attr in list_embedding_columns_width) {
                            if (attr === keys[i]) {
                                if (list_embedding_columns_width[attr])
                                    content += '<div style="flex-basis:' + list_embedding_columns_width[attr] + '%;margin-left: 8px;margin-right: 8px;"  name="mo_doc_lib" breadcrumb="' + keys[i] + '" id="' + keys[i] + '" class="mo_list_row mo_doc_lib_col mo_doc_lib_fcol-' + (i + 1) + '" data-label="' + keys[i] + ' ">' + doc[key] + '</div>';
                                else
                                    content += '<div style="flex-basis:15%;margin-left:8px;margin-right:8px;"  name="mo_doc_lib" breadcrumb="' + keys[i] + '" id="' + keys[i] + '" class="mo_doc_lib_col mo_doc_lib_fcol-' + (i + 1) + '" data-label="' + keys[i] + ' ">' + doc[key] + '</div>';
                            }
                        }
                    }

                }
                content += '</li>';
                $("#mo_doc_lib_all_docs_list").append(content);
            });

        }
        else {
            all_docs.forEach(doc => {
                $("#mo_doc_lib_all_docs_list").append(`<li name="mo_doc_lib" breadcrumb="${doc.Title}" id="${doc.id}" class="mo_doc_lib_table-row">
                    <div name="mo_doc_lib" breadcrumb="${doc.id}" id="${doc.id}" class="mo_doc_lib_col mo_doc_lib_dcol-1" data-label="Doc Id">    
                        ${doc.id}
                    </div>
                    
                    <div name="mo_doc_lib" breadcrumb="${doc.Title}" id="${doc.id}" class="mo_doc_lib_col mo_doc_lib_dcol-1" data-label="Doc Name" style="word-break:break-all;">${doc.Title}</div>
                    
                    <div name="mo_doc_lib" breadcrumb="${doc.Title}" id="${doc.id}" class="mo_doc_lib_col mo_doc_lib_dcol-2" data-label="Doc Date">${doc.lastModifiedDateTime?mo_sps_get_date_by_timestamp(doc.lastModifiedDateTime):''}</div>
                    
                    <div name="mo_doc_lib" breadcrumb="${doc.Title}" id="${doc.id}" class="mo_doc_lib_col mo_doc_lib_dcol-4" data-label="Doc Modified By">${doc.lastModifiedBy}</div>
                </li>`);
            });
        }


    }

    function process_list_items_true(res, drive_id) {
        let all_docs = res.data[0];

        if (!is_shortcode) {
            $('#mo_doc_lib_container').append('<table class="table" id="table"></table>');
        }

        let first_data = all_docs[0];
        const keys = Object.keys(first_data);
        temp_list_embedding_columns_width = []
        for(var len = 0; len<keys.length; len++) {
            temp_list_embedding_columns_width.push(100/(keys.length));
        }

        list_embedding_columns_width = list_embedding_columns_width ?? keys;
        const width_keys = Object.keys(keys);
        let number_of_columns = Object.keys(all_docs[0]).length;

        if (is_shortcode) {
            let content = `<thead style="background-color:antiquewhite;position:sticky;top:0;">
                      <tr>`;
            for (let i = 0; i < keys.length; i++) {

                for (const attr in list_embedding_columns_width) {
                    if (attr === keys[i])
                        if (list_embedding_columns_width[attr])
                            content += '<th>' + keys[i] + '</th>';
                        else
                            content += '<th>' + keys[i] + '</th>';

                }

            }
            content += '</tr></thead>';
            $("#table").html(content);
        }
        else {
            $("#table").html(`<thead>
                    <tr>
                        <th class="mo_doc_lib_col mo_doc_lib_dcol-1">Id</th>
                        <th class="mo_doc_lib_col mo_doc_lib_fcol-1">Title</th>
                        <th class="mo_doc_lib_col mo_doc_lib_fcol-2">Last Modified Date</th>
                        <th class="mo_doc_lib_col mo_doc_lib_fcol-4">Modified By</th>  
                    </tr>
                </thead>`);
        }

        if (all_docs.length === 0) {
            $("#table").append(`<tr>
                    <img src="${embedConfig.empty_folder_image}" height="400px"/>
                    </tr>`);
        }

        else {
            if (is_shortcode) {
                all_docs.forEach(doc => {
                    let content = `<tr>`;
                    const keys = Object.keys(doc);
                    for (let i = 0; i < keys.length; i++) {
                        const key = keys[i];
                        if (doc[key].url) {
                            for (const attr in list_embedding_columns_width) {
                                if (attr === keys[i]) {
                                    if (list_embedding_columns_width[attr])
                                        content += '<td><a target="_blank" class="mo_doc_lib_file_download" href="' + doc[key].url + '"><b>' + doc[key].url + '</b></a></td>';
                                    else
                                        content += '<td><a target="_blank" class="mo_doc_lib_file_download" href="' + doc[key].url + '"><b>' + doc[key].url + '</b></a></td>';
                                }
                            }
                        }
                        else {
                            for (const attr in list_embedding_columns_width) {
                                if (attr === keys[i]) {
                                    if (list_embedding_columns_width[attr])
                                        content += '<td>' + doc[key] + '</td>';
                                    else
                                        content += '<td>' + doc[key] + '</td>';
                                }
                            }
                        }


                    }
                    content += '</tr>';
                    $("#table").append(content);
                });

            }
            else {
                all_docs.forEach(doc => {

                    $("#table").append(`<tr>
                                <td>    
                                  ${doc.id}
                                </td>
                                
                                <td>${doc.Title}</td>
                                
                                <td>${doc.lastModifiedDateTime?mo_sps_get_date_by_timestamp(doc.lastModifiedDateTime):''}</td>
                                
                                <td>${doc.lastModifiedBy}</td>
                            </tr>`);
                });
            }
        }
    }

    function create_file_folder_option_dropdown(doc, index, type, doc_type) {
        var content = '';

        var folder_download = is_shortcode && folder_download_option != '' && folder_download_option == 'disable_download' ? false : true;
        var document_size = doc_type == 'drive' ? `${doc.quota.used ? mo_sps_get_doc_size(doc.quota.used) : '-'} / ${doc.quota.total ? mo_sps_get_doc_size(doc.quota.total) : '-'}` : (doc.size ? mo_sps_get_doc_size(doc.size) : '0 B');
        var download_class = doc_type == 'file' ? 'mo_doc_lib_download_ajax' : (doc_type == 'folder' ? 'mo_doc_lib_download_zip_file' : (doc_type == 'drive' ? 'mo_doc_lib_download_zip_file_drive' : 'mo_doc_lib_disabled_dropdown_item'));
        switch(type) {
            case 'info' : content = `<div title="info" id="mo_doc_lib_documents_info_${current_db_id}_${index}" index="${index}" class="mo_doc_lib_file_folder_info_dropdown_container"><img width="14px" height="14px" src="${embedConfig.info_icon}"/>
                    <div class="mo_doc_lib_file_folder_info_dropdown_${index>=6?`up`:`down`}" id="mo_doc_lib_documents_info_dropdown_${current_db_id}_${index}">
                        <div class="mo_doc_lib_file_folder_info_dropdown_items" style="text-align:center;"><b>${doc.name}</b></div>
                        <div class="mo_doc_lib_file_folder_info_dropdown_divider"></div>
                        <div class="mo_doc_lib_file_folder_info_dropdown_items"><b>Last Modified Date</b></br>${doc.lastModifiedDateTime?mo_sps_get_date_by_timestamp(doc.lastModifiedDateTime):''}</div>
                        ${currentView == 'root' || currentView == 'site' ? ``
                        :
                        `<div class="mo_doc_lib_file_folder_info_dropdown_divider"></div>
                        <div class="mo_doc_lib_file_folder_info_dropdown_items"><b>Size</b></br>${document_size}</div>`}
                    </div>
                </div>`;
                break;
            case 'option' : content = `<div id="mo_doc_lib_documents_options_${current_db_id}_${index}" index="${index}" class="mo_doc_lib_file_folder_option_dropdown_container"><span class="mo_doc_lib_file_folder_option_ellipsis dashicons dashicons-ellipsis"></span>
                    <div class="mo_doc_lib_file_folder_options_dropdown_${index>=6?`up`:`down`}" id="mo_doc_lib_documents_options_dropdown_${current_db_id}_${index}">
                        ${embedConfig.connector == 'onedrive' || embedConfig.connector == 'personal' ? `<div class="mo_doc_lib_file_folder_options_dropdown_items mo_doc_lib_site_redirect_to_sharepoint" site_url="${embedConfig.connector == 'personal' && breadcrumbs.length == 1 ? 'https://onedrive.live.com' : doc.webUrl}"><img width="13px" height="13px" src="${embedConfig.onedrive}"/>Preview in OneDrive</div>`:`<div class="mo_doc_lib_file_folder_options_dropdown_items mo_doc_lib_site_redirect_to_sharepoint" site_url="${doc.webUrl}"><img width="13px" height="13px" src="${embedConfig.sharepoint}"/>Preview in Sharepoint</div>`}
                        ${is_shortcode ? ``: `<div class="mo_doc_lib_file_folder_options_dropdown_items mo_doc_lib_folder_file_manage_access" id="mo_doc_lib_documents__ma_${current_db_id}_${index}" doc_id="${doc.id}" doc_name="${doc.name}" doc_type="${doc_type}"><img width="13px" height="13px" src="${embedConfig.add_user_icon}"/>Manage Access</div>`}
                        ${(is_shortcode && doc.doc_download_permission && doc_type == 'file') || (!is_shortcode && doc_type == 'file')? `<div class="mo_doc_lib_file_folder_options_dropdown_items" breadcrumb="${doc.name}" doc_type="${doc_type}" doc_id="${doc.id}" id="mo_doc_lib_download_ajax_${current_db_id}_${index}"><img width="13px" height="13px" src="${embedConfig.download_black}"/>Download</div>`: ``}
                        ${is_shortcode || doc_type != 'file' ? `` : `<div class="mo_doc_lib_file_folder_options_dropdown_items mo_sps_tooltip mo_doc_video_copy_shortcode" index="${index}" doc_id="${doc.id}">
                            <img width="13px" height="13px" src="${embedConfig.copy_icon}"/>Copy Shorcode
                            <span id="mo_sps_copy_file_specific_shortcode_${current_db_id}_${index}" style="width:124px;" class="mo_sps_tooltiptext">Copy Shortcode</span>
                        </div>`}
                        ${1?``:`<div class="mo_doc_lib_file_folder_options_dropdown_divider"></div>
                        <div class="mo_doc_lib_file_folder_options_dropdown_items">Delete</div>`}
                    </div>
                </div>`
                break;
        }

        return content;
    }

    async function download_main_folder(drive_id, folder_id, global_name, global_id, type) {
        var ajax_var = ''
        if(type == 'drive') {
            ajax_var = docLibEmbedHandleBackendCallsForFiles('mo_sps_get_all_documents', { drive_id: drive_id, is_plugin: !is_shortcode , current_state:breadcrumbs, download:true});
        } else {
            ajax_var = docLibEmbedHandleBackendCallsForFiles('mo_sps_get_all_folder_items', { drive_id: drive_id, folder_id: folder_id, is_plugin: !is_shortcode, current_state:breadcrumbs, download:true});
        }

        var items = [];

        ajax_var.then((res) => {

            if (!res.success) {
                $(`.mo_doc_lib_download_progress_display_container`).show();
                $(`.mo_doc_lib_download_progress_display_container`).html(`${res.data.Error}`);
                $(`.mo_doc_lib_download_progress_display_container`).delay(2000).fadeOut();
                return;
            } else {
                if(res.data.length === 0) {
                    $(`.mo_doc_lib_download_progress_display_container`).show();
                    $(`.mo_doc_lib_download_progress_display_container`).html(`Folder/Drive is empty.`);
                    $(`.mo_doc_lib_download_progress_display_container`).delay(2000).fadeOut();
                    return;
                }

                var folderName = global_name;
                var zip = new JSZip();
                var items = res.data;
                var folderCount = 0;
                var fileCount = 0;
                var processedCount = 0;
                let path = '';
                let p_temp_handler = ".mo_doc_lib_download_progress_display_container";
                for (var i = 0; i < items.length; i++) {
                    processItem(drive_id, items[i], folderName);
                }
                function processItem(drive_id, item, path) {
                    if (item.folder) {
                        folderCount++;
                        docLibEmbedHandleBackendCallsForFiles('mo_sps_get_all_folder_items', { drive_id: drive_id, folder_id: item.id, is_plugin: !is_shortcode, current_state:breadcrumbs, download:true }).then((res) => {
                            if (!res.success) {
                                mo_doc_lib_handle_errors(res);
                                return;
                            }
                            subItems = res.data;
                            path = path + "/" + item.name;
                            for (var i = 0; i < subItems.length; i++) {
                                processItem(drive_id, subItems[i], path);
                            }
                            processedCount++;
                            if (processedCount == folderCount + fileCount) {
                                zip.generateAsync({ type: "blob" }, function updateCallback(metadata) {
                                    jQuery(p_temp_handler).show("");
                                    jQuery(p_temp_handler).html("Download..." + metadata.percent.toFixed(2) + " %");

                                });
                                zip.generateAsync({ type: "blob" }).then(function (content) {
                                    jQuery(p_temp_handler).hide();
                                    saveAs(content, folderName + ".zip");
                                });
                            }
                        });
                    }
                    else {
                        items.push(item);
                        fileCount++;
                        var fileName = item.name;
                        var fileUrl = item.download_url;
                        var xhr = new XMLHttpRequest();
                        xhr.open("GET", fileUrl, true);
                        xhr.responseType = "blob";
                        xhr.onload = function (e) {
                            if (this.status == 200) {
                                var fileBlob = new Blob([this.response], { type: xhr.getResponseHeader("Content-Type") });
                                zip.file(path + "/" + fileName, fileBlob);
                                processedCount++;
                            }
                            else {
                                fileCount--;
                            }
                            if (processedCount == folderCount + fileCount) {
                                zip.generateAsync({ type: "blob" }, function updateCallback(metadata) {
                                    jQuery(p_temp_handler).show("");
                                    jQuery(p_temp_handler).html("Download..." + metadata.percent.toFixed(2) + " %");
                                });
                                zip.generateAsync({ type: "blob" }).then(function (content) {
                                    jQuery(p_temp_handler).hide();
                                    saveAs(content, folderName + ".zip");
                                });
                            }
                        };
                        xhr.send();
                    }

                }
            }
        });
    }

    function hide_show_or_disable_elements() {
        $(`.mo_doc_lib_nav_main_${current_db_id}`).css('display', 'flex');

        var hide_or_show_toggle_view = false;

        switch(currentView) {
            case 'root': $(`#mo_doc_lib_upload_file_${current_db_id}`).hide();
                $(`#mo_doc_lib_table_view_${current_db_id}`).hide();
                $(`#mo_doc_lib_grid_view_${current_db_id}`).hide();
                hide_or_show_toggle_view = false;
                break;
            case 'site':
                $(`#mo_doc_lib_upload_file_${current_db_id}`).hide();
                hide_or_show_toggle_view = true;
                break;
            case 'drive':
                if (is_shortcode && elements_to_show['upload_btn'] == 'upload_btn') {
                    $(`#mo_doc_lib_upload_file_${current_db_id}`).show();
                } else if(!is_shortcode) {
                    $(`#mo_doc_lib_upload_file_${current_db_id}`).show();
                }
                hide_or_show_toggle_view = true;
                break;
            case 'folder':
                if (is_shortcode && elements_to_show['upload_btn'] == 'upload_btn') {
                    $(`#mo_doc_lib_upload_file_${current_db_id}`).show();
                } else if(!is_shortcode) {
                    $(`#mo_doc_lib_upload_file_${current_db_id}`).show();
                }
                hide_or_show_toggle_view = true;
                break;
        }

        const displayGrid = () => {
            $(`#mo_doc_lib_table_view_${current_db_id}`).hide();
            $(`#mo_doc_lib_grid_view_${current_db_id}`).show();
        }

        const displayList = () => {
            $(`#mo_doc_lib_table_view_${current_db_id}`).show();
            $(`#mo_doc_lib_grid_view_${current_db_id}`).hide();
        }

        const hideGridAndList = () => {
            $(`#mo_doc_lib_table_view_${current_db_id}`).hide();
            $(`#mo_doc_lib_grid_view_${current_db_id}`).hide();
        }

        if(hide_or_show_toggle_view) {
            if(is_shortcode) {
                if (elements_to_show['toggle_view'] == 'toggle_view') {
                    if(view_mode === "grid_view") displayList();
                    else displayGrid();
                }
            } else {
                if(view_mode === "grid_view") displayList();
                else displayGrid();
            }
        } else {
            hideGridAndList();
        }
    }

    function eventHandlers() {

        $(document).on('click', `div[id^='mo_doc_lib_download_ajax_${current_db_id}_']`, function(e){
            e.preventDefault();
            e.stopPropagation();
            $(`div[id^='mo_doc_lib_documents_options_dropdown_${current_db_id}_']`).slideUp("fast");
            var doc_type = e.currentTarget.getAttribute('doc_type');
            var doc_id = e.currentTarget.getAttribute('doc_id');

            switch(doc_type) {
                case 'file': var download_ajax = `${embedConfig.ajax_url}?action=mo_sps_download_file&drive_id=${selected_drive_id}&file_id=${doc_id}`;
                    window.location.href = download_ajax;
                    break;
                case 'folder': global_id = id_val = e.currentTarget.getAttribute('doc_id');
                    p_temp_handler = ".mo_doc_lib_download_progress_display_container";
                    jQuery(p_temp_handler).show("");
                    $(`.mo_doc_lib_download_progress_display_container`).html('processing downloads...');
                    global_name = e.currentTarget.getAttribute('breadcrumb');
                    var type = "folder";

                    download_main_folder(selected_drive_id, id_val, global_name, global_id, type);
                    break;
                case 'drive': global_id = id_val = e.currentTarget.getAttribute('doc_id');
                    drive_id = id_val;
                    p_temp_handler = ".mo_doc_lib_download_progress_display_container";
                    jQuery(p_temp_handler).show("");
                    $(`.mo_doc_lib_download_progress_display_container`).html('processing downloads...');
                    global_name = e.currentTarget.getAttribute('breadcrumb');
                    var type = "drive";

                    download_main_folder(drive_id, id_val, global_name, global_id, type);
                    break;
            }
        })

        $(document).on('click', `div[id^='mo_doc_lib_documents_info_${current_db_id}_']`, function(e){
            e.preventDefault();
            e.stopPropagation();
            var index = e.currentTarget.getAttribute('index');
            $(`div[id^='mo_doc_lib_documents_info_dropdown_${current_db_id}_']`).slideUp("fast");
            $(`div[id^='mo_doc_lib_documents_options_dropdown_${current_db_id}_']`).slideUp("fast");
            $(`#mo_doc_lib_documents_info_dropdown_${current_db_id}_${index}`).show();
        })

        $(document).on('click', `div[id^='mo_doc_lib_documents_options_${current_db_id}_']`, function(e){
            e.preventDefault();
            e.stopPropagation();
            var index = e.currentTarget.getAttribute('index');
            $(`div[id^='mo_doc_lib_documents_options_dropdown_${current_db_id}_']`).slideUp("fast");
            $(`div[id^='mo_doc_lib_documents_info_dropdown_${current_db_id}_']`).slideUp("fast");
            $(`#mo_doc_lib_documents_options_dropdown_${current_db_id}_${index}`).show();
        })

        $(document).on('click', `div[id^='mo_doc_lib_documents_option_elipsis_${current_db_id}_']`, function(e){
            e.preventDefault();
            e.stopPropagation();
            var unique_id = e.currentTarget.getAttribute('unique_id');
            $(`#mo_doc_lib_documents_option_dropdown_${current_db_id}_${unique_id}`).toggle();
        })

        $(document).on('click', `.mo_doc_lib_site_redirect_to_tab`, function(e) {
            e.preventDefault();
            e.stopPropagation();
            selected_file_id = e.currentTarget.getAttribute('doc_id');
            window.open(`${embedConfig.ajax_url}?action=mo_sps_sync_file&drive_id=${selected_drive_id}&file_id=${selected_file_id}`, '_blank');
        });

        $(document).on('click', '.mo_doc_lib_site_redirect_to_sharepoint', function (e) {
            e.stopPropagation();
            e.preventDefault();
            $(`div[id^='mo_doc_lib_documents_options_dropdown_${current_db_id}_']`).slideUp("fast");
            var site_url = e.currentTarget.getAttribute('site_url');
            window.open(site_url, '_blank');
        });

        $(document).on('click', `.mo_doc_lib_grid_file_option_dropdown`, function(e){
            e.preventDefault();
            e.stopPropagation();

            $(`div[id^='mo_sps_embed_file_option_${current_db_id}_']`).slideUp("fast");
            $(`div[id^='mo_sps_embed_title_ellipses_${current_db_id}_']`).hide();
            $(`div[id^='mo_sps_embed_title_container_${current_db_id}_']`).css('justify-content', 'center');
            $(`div[id^='mo_sps_embed_title_${current_db_id}_']`).css('max-width', '8rem');

            var ele = e.currentTarget;
            var doc_id = ele.getAttribute('doc_id');

            $(`#mo_sps_embed_title_${current_db_id}_${doc_id}`).css('max-width','5rem');
            $(`#mo_sps_embed_title_container_${current_db_id}_${doc_id}`).css('justify-content','space-between');
            $(`#mo_sps_embed_title_ellipses_${current_db_id}_${doc_id}`).css('display','flex');
            $(`#mo_sps_embed_file_option_${current_db_id}_${doc_id}`).show();

        });

        $(document).on('click', '.mo_doc_lib_folder_file_manage_access', function (e) {
            e.stopPropagation();
            e.preventDefault();
            $(`div[id^='mo_doc_lib_documents_options_dropdown_${current_db_id}_']`).slideUp("fast");
            var doc_id = e.currentTarget.getAttribute('doc_id');
            var doc_name = e.currentTarget.getAttribute('doc_name');
            var doc_type = e.currentTarget.getAttribute('doc_type');
            createManageAccessModal(doc_id, doc_name, doc_type);
        });

        // generic handle click for any click on documents tab.
        $(document).on("click", function (event) {
            if (!$(event.target).closest(`.mo_doc_lib__ma_access_options`).length) {
                $(`div[id^='mo_doc_lib__ma_access_drpdn_']`).slideUp("fast");
            }

            var new_access_input_ele = $(`.mo_doc_lib_new_permissions_checkbox:checked`).toArray();
            if (new_access_input_ele.length >= 1) {
                $(`#mo_doc_lib__ma_delete_permissions`).show();
            } else {
                $(`#mo_doc_lib__ma_delete_permissions`).hide();
            }

            if (!$(event.target).closest("#mySearch").length) {
                $(`#mySearchDropdown_${current_db_id}`).slideUp("fast");
            }

            if (!$(event.target).closest(`.mo_doc_lib_breadcrumb_elipsis`).length) {
                $(`#mo_doc_lib_breadcrumb_dropdown_${current_db_id}`).slideUp("fast");
            }

            $(`div[id^='mo_doc_lib_documents_options_dropdown_${current_db_id}_']`).slideUp("fast");

            $(`div[id^='mo_doc_lib_documents_info_dropdown_${current_db_id}_']`).slideUp("fast");
        });

        // handle toggle view for the grid or list
        $(document).on('click', `#mo_doc_lib_table_view_${current_db_id}`, function (e) {
            $(`#mo_doc_lib_table_view_${current_db_id}`).hide();
            $(`#mo_doc_lib_grid_view_${current_db_id}`).show();
            view_mode = 'list_view';
            loadPaths[currentView].init();
            load_breadcrumbs(breadcrumbs);
        });

        $(document).on('click', `#mo_doc_lib_grid_view_${current_db_id}`, function (e) {
            $(`#mo_doc_lib_table_view_${current_db_id}`).show();
            $(`#mo_doc_lib_grid_view_${current_db_id}`).hide();
            view_mode = 'grid_view';
            loadPaths[currentView].init();
            load_breadcrumbs(breadcrumbs);
        });

        // handle click for grid documents
        $(document).on('click', `div[name='mo_doc_lib_grid_file_${current_db_id}']`, function (e) {
            var selected_file_id = e.currentTarget.getAttribute('doc_id');
            var name = e.currentTarget.getAttribute('doc_name');
            var key = e.currentTarget.getAttribute('key');
            var download_url = e.currentTarget.getAttribute('download_url') ?? '';
            var webUrl = e.currentTarget.getAttribute('web_url');
            if ( ! download_url ) {
                download_url = preview_pop_up_content[key]['download_url'];
            }
            e.preventDefault();
            if (is_shortcode) {
                if (preview_option == 'pop_up') {
                    createShortcodeModal(name, `${embedConfig.ajax_url}?action=mo_sps_sync_file&drive_id=${selected_drive_id}&file_id=${selected_file_id}`,download_url, webUrl, selected_file_id, key);
                } else {
                    window.open(`${embedConfig.ajax_url}?action=mo_sps_sync_file&drive_id=${selected_drive_id}&file_id=${selected_file_id}`, '_blank');
                }
            } else {
                createShortcodeModal(name, `${embedConfig.ajax_url}?action=mo_sps_sync_file&drive_id=${selected_drive_id}&file_id=${selected_file_id}`,download_url, webUrl, selected_file_id, key);
            }
        });

        $(document).on('click', `div[name='sps_embed_folder_${current_db_id}']`, function (e) {
            selected_folder_id = e.currentTarget.id;
            selected_folder_name = e.currentTarget.getAttribute('breadcrumb');
            e.preventDefault();
            sc_path['path'] = sc_path[breadcrumbs.length] = sc_path[breadcrumbs.length - 1] + '/' + selected_folder_name;
            breadcrumbs.push(`<span class="mo_doc_lib_breadcrumb_item" index="${breadcrumbs.length}" id="mo_sps_breadcrumb_folder_${current_db_id}_${selected_folder_id}" name="mo_sps_breadcrumb_folder_${current_db_id}" folder_id="${selected_folder_id}">${selected_folder_name}</span>`);

            load_breadcrumbs(breadcrumbs);
            loadPaths['folder'].init();
        });

        // handle click on the documents or folders
        $(document).on('click', `li[name='mo_doc_lib_site_${current_db_id}'], div[name='mo_doc_lib_site_${current_db_id}']`, function (e) {
            selected_site_id = e.currentTarget.id;
            selected_site_name = e.currentTarget.getAttribute('breadcrumb');
            e.preventDefault();
            sc_path['path'] = sc_path[breadcrumbs.length] = sc_path[breadcrumbs.length - 1] + '/' + selected_site_name;
            breadcrumbs.push(`<span class="mo_doc_lib_breadcrumb_item" index="${breadcrumbs.length}" id="mo_sps_breadcrumb_site_${current_db_id}">${selected_site_name} </span>`);
            load_breadcrumbs(breadcrumbs);
            loadPaths['site'].init();

        });

        $(document).on('click', `li[name='mo_doc_lib_drive_documentLibrary_${current_db_id}']`, function (e) {
            var drive_id = e.currentTarget.getAttribute('drive_id');

            selected_drive_id = drive_id;
            selected_drive_name = e.currentTarget.getAttribute('breadcrumb');
            e.preventDefault();
            sc_path['path'] = sc_path[breadcrumbs.length] = sc_path[breadcrumbs.length - 1] + '/' + selected_drive_name;
            breadcrumbs.push(`<span class="mo_doc_lib_breadcrumb_item" index="${breadcrumbs.length}" id="mo_sps_breadcrumb_drive_${current_db_id}">${selected_drive_name} </span>`);
            load_breadcrumbs(breadcrumbs);
            loadPaths['drive'].init();

        });

        $(document).on('click', `div[name^='mo_sps_embed_drive_documentLibrary_${current_db_id}']`, function (e) {
            var drive_id = e.currentTarget.getAttribute('drive_id');
            selected_drive_id = drive_id;
            selected_drive_name = e.currentTarget.getAttribute('breadcrumb');
            e.preventDefault();
            sc_path['path'] = sc_path[breadcrumbs.length] = sc_path[breadcrumbs.length - 1] + '/' + selected_drive_name;
            breadcrumbs.push(`<span class="mo_doc_lib_breadcrumb_item" index="${breadcrumbs.length}" id="mo_sps_breadcrumb_drive_${current_db_id}">${selected_drive_name} </span>`);
            load_breadcrumbs(breadcrumbs);
            loadPaths['drive'].init();

        });

        $(document).on('click', `li[name='mo_doc_lib_drive_genericList_${current_db_id}']`, function (e) {
            selected_drive_id = e.currentTarget.getAttribute('drive_id');
            selected_drive_name = e.currentTarget.getAttribute('breadcrumb');
            e.preventDefault();
            sc_path['path'] = sc_path[breadcrumbs.length] = sc_path[breadcrumbs.length - 1] + '/' + selected_drive_name;
            breadcrumbs.push(`<span class="mo_doc_lib_breadcrumb_item" index="${breadcrumbs.length}" id="mo_sps_breadcrumb_drive_genericList">${selected_drive_name} </span>`);
            load_breadcrumbs(breadcrumbs);
            loadPaths['list_items'].init();

        });

        $(document).on('click', `li[name^='mo_doc_lib_folder_${current_db_id}_']`, function (e) {
            var folder_id = e.currentTarget.id;
            selected_folder_id = folder_id;
            selected_folder_name = e.currentTarget.getAttribute('breadcrumb');

            e.preventDefault();

            sc_path['path'] = sc_path[breadcrumbs.length] = sc_path[breadcrumbs.length - 1] + '/' + selected_folder_name;
            breadcrumbs.push(`<span class="mo_doc_lib_breadcrumb_item" index="${breadcrumbs.length}" id="mo_sps_breadcrumb_folder_${current_db_id}_${selected_folder_id}" name="mo_sps_breadcrumb_folder_${current_db_id}" folder_id="${selected_folder_id}">${selected_folder_name}</span>`);
            load_breadcrumbs(breadcrumbs);
            loadPaths['folder'].init();

        });

        $(document).on('click', `li[name^='mo_doc_lib_file_${current_db_id}_']`, function (e) {
            var selected_file_id = e.currentTarget.id;
            var name = e.currentTarget.getAttribute('breadcrumb');
            var key = e.currentTarget.getAttribute('key');
            var download_url = e.currentTarget.getAttribute('download_url');
            var webUrl = e.currentTarget.getAttribute('web_url');
            if ( ! download_url ) {
                download_url = preview_pop_up_content[key]['download_url'];
            }
            e.preventDefault();
            if (is_shortcode) {
                if (preview_option == 'pop_up') {
                    createShortcodeModal(name, `${embedConfig.ajax_url}?action=mo_sps_sync_file&drive_id=${selected_drive_id}&file_id=${selected_file_id}`,download_url, webUrl, selected_file_id, key);
                } else {
                    window.open(`${embedConfig.ajax_url}?action=mo_sps_sync_file&drive_id=${selected_drive_id}&file_id=${selected_file_id}`, '_blank');
                }
            } else {
                createShortcodeModal(name, `${embedConfig.ajax_url}?action=mo_sps_sync_file&drive_id=${selected_drive_id}&file_id=${selected_file_id}`,download_url, webUrl, selected_file_id, key);
            }

        });

        $(document).on('click', `li[name^='mo_doc_lib_url_${current_db_id}_']`, function (e) {
            selected_file_id = e.currentTarget.id;
            e.preventDefault();

            window.open(`${embedConfig.ajax_url}?action=mo_sps_get_url_content&drive_id=${selected_drive_id}&file_id=${selected_file_id}`, '_blank');
        });


        $(document).on('click', `div[name='mo_doc_lib_grid_url_${current_db_id}']`, function (e) {
            selected_file_id = e.target.id;
            e.preventDefault();

            window.open(`${embedConfig.ajax_url}?action=mo_sps_get_url_content&drive_id=${selected_drive_id}&file_id=${selected_file_id}`, '_blank');
        });

        //  Handle clicks for breadcrumbs //
        $(document).on('click', `.mo_doc_lib_breadcrumb_elipsis`, function(e){
            $(`#mo_doc_lib_breadcrumb_dropdown_${current_db_id}`).toggle();
        })

        $(document).on('click', `#mo_sps_breadcrumb_home_${current_db_id}`, function (e) {
            if(e.currentTarget.getAttribute('disable') && e.currentTarget.getAttribute('disable') === 'true') return;
            breadcrumbs = breadcrumbs.splice(0, 1);
            load_breadcrumbs(breadcrumbs);
            sc_path['path'] = sc_path[0];
            var current_home_item_id = e.currentTarget.getAttribute('home_item_id')
            if (home == 'folder') {
                selected_folder_id = current_home_item_id;
            }
            loadPaths[home].init();
        });

        $(document).on('click', `#mo_sps_breadcrumb_site_${current_db_id}`, function (e) {
            if(e.currentTarget.getAttribute('disable') && e.currentTarget.getAttribute('disable') === 'true') return;
            index = Number(e.target.getAttribute('index'));
            sc_path['path'] = sc_path[index];
            breadcrumbs = breadcrumbs.splice(0, index + 1);
            load_breadcrumbs(breadcrumbs);
            loadPaths['site'].init();
        });

        $(document).on('click', `#mo_sps_breadcrumb_drive_${current_db_id}`, function (e) {
            if(e.currentTarget.getAttribute('disable') && e.currentTarget.getAttribute('disable') === 'true') return;
            index = Number(e.target.getAttribute('index'));
            selected_folder_id = '';
            sc_path['path'] = sc_path[index];
            breadcrumbs = breadcrumbs.splice(0, index + 1);
            load_breadcrumbs(breadcrumbs);
            loadPaths['drive'].init();
        });

        $(document).on('click', `#mo_sps_breadcrumb_drive_genericList_${current_db_id}`, function (e) {
            if(e.currentTarget.getAttribute('disable') && e.currentTarget.getAttribute('disable') === 'true') return;
            index = Number(e.target.getAttribute('index'));
            sc_path['path'] = sc_path[index];
            breadcrumbs = breadcrumbs.splice(0, index + 1);
            load_breadcrumbs(breadcrumbs);
            loadPaths['list_items'].init();
        });

        $(document).on('click', `span[name='mo_sps_breadcrumb_folder_${current_db_id}']`, function (e) {
            if(e.currentTarget.getAttribute('disable') && e.currentTarget.getAttribute('disable') === 'true') return;
            selected_folder_id = e.target.getAttribute('folder_id');
            index = Number(e.target.getAttribute('index'));
            sc_path['path'] = sc_path[index];
            breadcrumbs = breadcrumbs.splice(0, index + 1);
            load_breadcrumbs(breadcrumbs);
            loadPaths['folder'].init();
        });


        // handle folder downloading
        $(document).on('click', ".mo_doc_lib_download_zip_file", function (e) {
            e.stopPropagation();
            let global_id = id_val = e.currentTarget.getAttribute('doc_id');
            let p_temp_handler = "#mo_sps_downloading_" + current_db_id;
            jQuery(p_temp_handler).show("");
            let global_name = e.currentTarget.getAttribute('breadcrumb');
            var type = "folder";

            download_main_folder(selected_drive_id, id_val, global_name, global_id, type);
        });

        // handle drive downloading
        $(document).on('click', ".mo_doc_lib_download_zip_file_drive", function (e) {
            e.stopPropagation();
            let global_id = id_val = e.currentTarget.getAttribute('doc_id');
            drive_id = id_val;
            let p_temp_handler = "#mo_sps_downloading_" + current_db_id;
            jQuery(p_temp_handler).show("");
            let global_name = e.currentTarget.getAttribute('breadcrumb');
            var type = "drive";

            download_main_folder(drive_id, id_val, global_name, global_id, type);
        });

        // Generate shortocde for current view
        $(document).on('click', "#mo_doc_lib_generate_shortcode", function (e) {
            var selected_mode = $(`input[name='default-view']:checked`).val();
            var folder_download_option = $(`input[name='folder-download-option']:checked`).val();
            var mo_doc_lib_elements_to_show_elements = $(`input[name='elements-to-show']:checked`).toArray();
            var elements_to_show = {};
            mo_doc_lib_elements_to_show_elements.forEach(ele => {
                elements_to_show[ele.defaultValue] = ele.defaultValue;
            });

            var mo_doc_lib_table_columns_elements = $(`input[name='table-columns']:checked`).toArray();
            var column_to_add = {};
            mo_doc_lib_table_columns_elements.forEach(ele => {
                column_to_add[ele.defaultValue] = ele.defaultValue;
            });

            var preview_option = $(`input[name='preview-option']:checked`).val();
            var list_option = $(`input[name='list-view-option']:checked`).val();

            var preview_width = $(`#mo_doc_lib_gsc_pw_txt`).val();


            let permissions = '';
            let anonymous_access = '';
            let upload_access = '';

            let shortcode = { 'permissions': permissions, 'anonymous_access': anonymous_access, 'upload_access': '', 'sc_path': sc_path, 'elements_to_show': elements_to_show, 'list_option': list_option,'preview_width': preview_width, 'preview_option': preview_option, 'view_mode': selected_mode, 'column_to_add': column_to_add, 'folder_download_option':folder_download_option };

            if (currentView === 'site') {
                shortcode = { 'home': currentView, 'anonymous_access': anonymous_access, 'upload_access': upload_access, 'site_id': selected_site_id, 'permissions': permissions, 'sc_path': sc_path, 'elements_to_show': elements_to_show, 'list_option': list_option, 'preview_width': preview_width, 'preview_option': preview_option, 'view_mode': selected_mode, 'column_to_add': column_to_add, 'folder_download_option':folder_download_option };

            } else if (currentView === 'drive') {
                shortcode = { 'home': currentView, 'anonymous_access': anonymous_access, 'upload_access': upload_access, 'drive_id': selected_drive_id, 'view_mode': selected_mode, 'permissions': permissions, 'sc_path': sc_path, 'column_to_add': column_to_add, 'elements_to_show': elements_to_show, 'list_option': list_option , 'preview_option': preview_option, 'preview_width': preview_width, 'folder_download_option':folder_download_option };

            } else if (currentView === 'folder') {
                shortcode = { 'home': currentView, 'anonymous_access': anonymous_access, 'upload_access': upload_access, 'drive_id': selected_drive_id, 'view_mode': selected_mode, 'folder_id': selected_folder_id, 'permissions': permissions, 'sc_path': sc_path, 'column_to_add': column_to_add, 'elements_to_show': elements_to_show, 'list_option': list_option, 'preview_option': preview_option, 'preview_width': preview_width, 'folder_download_option':folder_download_option };
            }

            docLibEmbedHandleBackendCallsForFolderTree('mo_sps_generate_and_save_shortcode', { sc_permissions: shortcode, shortcode_id: embedConfig.shortcode_id, sc_path: sc_path }).then((res) => {
                if (!res.success) {
                    mo_doc_lib_handle_errors(res);
                    return;
                }
                window.location = embedConfig.admin_url + 'admin.php?page=mo_sps&tab=short_code';
            });

        });

        // copy shortcode for the individual files
        $(document).on('click', "#mo_doc_lib_copy_list_shortcode", function (e) {

            let mo_doc_lib_is_enable_list_view = $('#mo_doc_lib_is_enable_list_view:checked').val();
            let list_embedding_columns = '';

            if (mo_doc_lib_is_enable_list_view) {
                let children = $(document).find('.mo_doc_lib_sc_tree__checkbox').toArray();
                let widths = $(document).find('.mo_doc_lib_sc_tree__width').toArray();

                list_embedding_columns = {};
                list_embedding_columns_width = {};

                children.forEach(input => {
                    let is_checked = input.checked;
                    let item_id = input.parentElement.getAttribute('item_id');

                    let item_display_name = input.parentElement.getAttribute('item_display_name');

                    widths.forEach(input => {
                        let val = input.value;
                        let val_id = input.parentElement.getAttribute('item_id');
                        let item_display_name = input.parentElement.getAttribute('item_display_name');
                        if (is_checked) {
                            if (item_id == val_id)
                                list_embedding_columns_width[item_display_name] = val;
                        }
                    })

                    if (is_checked)
                        list_embedding_columns[item_id] = item_display_name;
                });



                list_embedding_columns = JSON.stringify(list_embedding_columns);
                list_embedding_columns = `list_embedding_columns='${list_embedding_columns}'`;
                list_embedding_columns_width = JSON.stringify(list_embedding_columns_width);
                list_embedding_columns_width = `list_embedding_columns_width='${list_embedding_columns_width}'`;
            }

            if (currentView === 'list_items') {
                shortcode = `[MO_SHAREPOINT_LIST home="${currentView}" site_id="${selected_site_id}" drive_id="${selected_drive_id}" ${list_embedding_columns} ${list_embedding_columns_width}]`;
            }

            var $temp = $("<input>");
            $("body").append($temp);
            var val = shortcode.replace(/(<([^>]+)>)/ig, "");
            $temp.val(`${val}`).select();
            document.execCommand("copy");
            $temp.remove();

            jQuery("#mo_sps_list_tooltip_text_copy").html("Copied");
            setTimeout(() => {
                jQuery("#mo_sps_list_tooltip_text_copy").html("Copy Shortcode");
            }, 3000);

        });

        // copy shortcode for the uploads
        $(document).on('click', "#mo_doc_lib_copy_upload_shortcode", function (e) {
            e.stopPropagation();
            let permissions = $('#mo_doc_lib_upload_permission_for_specific_folder').val();
            let permission_values = '';

            let shortcode = `[MO_SHAREPOINT_UPLOAD ${permission_values}]`;
            if (currentView === 'folder') {
                shortcode = `[MO_SHAREPOINT_UPLOAD home="${currentView}" drive_id="${selected_drive_id}" folder_id="${selected_folder_id}" height="400px"  width="900px" ${permission_values}]`;
            }

            var temp = jQuery("<input>");
            jQuery("body").append(temp);
            temp.val(shortcode).select();

            document.execCommand("copy");
            temp.remove();

            $('#mo_sps_upload_tooltip_text_copy').html("Copied");
            setTimeout(() => {
                $('#mo_sps_upload_tooltip_text_copy').html("Copy Shortcode");
            }, 3000);
        });

        // copy shortcode for the individual file and embed as preview on page.
        $(document).on('click', ".mo_doc_video_copy_shortcode", function (e) {
            e.stopPropagation();
            $(`div[id^='mo_doc_lib_documents_options_dropdown_${current_db_id}_']`).delay(500).slideUp(500);

            let id_val = e.currentTarget.getAttribute('doc_id');
            let index = e.currentTarget.getAttribute('index');

            let shortcode = `[MO_SHAREPOINT_SPECIFIC_FILE]`;

            if (currentView === 'drive') {
                shortcode = `[MO_SHAREPOINT_SPECIFIC_FILE home="${currentView}" drive_id="${selected_drive_id}" item_id="${id_val}" height="400px"  width="900px"]`;
            } else if (currentView === 'folder') {
                shortcode = `[MO_SHAREPOINT_SPECIFIC_FILE home="${currentView}" drive_id="${selected_drive_id}" folder_id="${selected_folder_id}" item_id="${id_val}" height="400px"  width="900px"]`;
            }

            var temp = jQuery("<input>");
            jQuery("body").append(temp);
            temp.val(shortcode).select();

            document.execCommand("copy");
            temp.remove();

            let p_temp_handler = "#mo_sps_copy_file_specific_shortcode_" + current_db_id + '_' + index;
            jQuery(p_temp_handler).html("Copied");
            setTimeout(() => {
                jQuery(p_temp_handler).html("Copy Shortcode");
            }, 3000);

        });

        // File preview in pop-up
        $(document).on('click', `div[id^='mo_doc_lib_file_preview_in_popup_']`, function (e) {
            selected_file_id = e.target.getAttribute('doc_id');
            e.preventDefault();
            window.open(`${embedConfig.ajax_url}?action=mo_sps_sync_file&drive_id=${selected_drive_id}&file_id=${selected_file_id}`, '_blank');
        });

        $(document).on('click', `#mo_doc_lib_preview_pop_up_go_left_${current_db_id}`, function(e){
            var key = e.currentTarget.getAttribute('key');
            key = key - 1;
            if(key == -1) key = preview_pop_up_content.length - 1;
            var id = preview_pop_up_content[key].id;

            if(view_mode == 'grid_view') {
                $(`#mo_doc_lib_grid_files_${id}`).click();
            } else {
                $(`li[name='mo_doc_lib_file_${current_db_id}_${id}']`).click();
            }
        });

        $(document).on('click', `#mo_doc_lib_preview_pop_up_go_right_${current_db_id}`, function(e){
            var key = e.currentTarget.getAttribute('key');
            key = +key + 1;
            if(key == preview_pop_up_content.length) key = 0;
            var id = preview_pop_up_content[key].id;
            if(view_mode == 'grid_view') {
                $(`#mo_doc_lib_grid_files_${id}`).click();
            } else {
                $(`li[name='mo_doc_lib_file_${current_db_id}_${id}']`).click();
            }

        });

        // Manage access for the documents
        $(document).on('click', "#mo_doc_lib_enable_anonymous_access_folder", function (e) {
            if (e.target.checked) {
                $('#mo_doc_lib_enable_folder_restriction').hide();
                $('#mo_doc_lib_is_enable_role_folder_mapping').prop('checked', false);
                $('.mo_doc_lib_sc_tree_container').hide();
            } else {
                $('#mo_doc_lib_enable_folder_restriction').css('display', 'flex');
            }
        });

        // modal close btn event handle
        $(document).on('click', `#mo_doc_lib_upload_close_btn_${current_db_id}`, function (e) {
            e.preventDefault();
            $(`#mo_doc_preview_modal_container_${current_db_id}`).html('');
        });

        // drop file to upload evernt handle
        $(document).on('drop', `#dropArea_${current_db_id}`, function (e) {
            e.preventDefault();
            $(`#dropArea_${current_db_id}`).css('border', '2px dashed #333');

            const files = e.originalEvent.dataTransfer.files;
            handleFiles(files);
        });

        $(document).on('dragover', `#dropArea_${current_db_id}`, function (e) {
            e.preventDefault();
            $(`#dropArea_${current_db_id}`).css('border', '2px dashed #333');
        });

        $(document).on('change', `#input_file_${current_db_id}`, function (e) {
            var files = $(`#input_file_${current_db_id}`)[0].files;
            handleFiles(files);
        });

        $(document).on('click', `#mo_doc_lib_upload_file_${current_db_id}`, function (e) {
            createModal();
        });

        $(document).on('click', `#dropArea_${current_db_id}`, function (e) {
            e.preventDefault();
            $(`#input_file_${current_db_id}`).click();
        });

        $(document).on('click', `#mo_sps_modal_close_btn_${current_db_id}`, function (e) {
            e.preventDefault();
            $(`#mo_doc_preview_modal_container_${current_db_id}`).empty();
        });

        $(document).on('click', `#input_file_${current_db_id}`, function (e) {
            global_file = '';
        });

        // manage access input and other events handle
        $(document).on('keyup click', `#mo_doc_lib_new_permission_input`, function (event) {
            event.stopPropagation();
            $(`#mo_doc_lib_search_user_role_email_drpdn`).hide();

            var search_text = $(`#mo_doc_lib_new_permission_input`).val();
            if (search_text != '') {
                var search_text = search_text.split(';').pop();
            }

            $(`#listItem`).empty();
            $(`#mo_doc_lib_search_user_role_email_drpdn`).show();
            $(`#mo_doc_lib_search_user_email_list_items`).html('');

            var added_permissions_array = $(`.mo_doc_lib__ma_access_options`).toArray();
            var exclude_user_role_email_array = [];
            added_permissions_array.forEach(ele => {
                exclude_user_role_email_array.push(ele.getAttribute('data-role-email'));
            });


            let status = 'All Logged In Users';

            function appendSectionTitle(title) {
                $(`#mo_doc_lib_search_user_email_list_items`).append(`
                    <div>
                        <div style="text-align: left; background: #9cc9ca; padding: 5px;">
                            <span style="word-wrap: break-word; font-weight: 14px; font-weight: 500;">${title}</span>
                        </div>
                    </div>
                `);
            }

            function appendItem(item, search_text) {
                let highlightedText = item.replace(RegExp(search_text, "i"), match => `<mark class="highlighted-text">${match}</mark>`);
                let itemHTML = `
                    <div class="list_items" id="mo_doc_lib_search_user_role_email_drpdn_item_${item}" item_id="${item_id}" user_email="${item}">
                        <div style="width: 11rem">
                            <span style="word-wrap: break-word;">${highlightedText}</span>
                        </div>
                    </div>
                `;
                $(`#mo_doc_lib_search_user_email_list_items`).append(itemHTML);
            }

            function processItems(items, search_text) {
                var result_cnt = false;
                items.forEach(item => {
                    if (!exclude_user_role_email_array.includes(item) && item.toLowerCase().includes(search_text.toLowerCase())) {
                        appendItem(item, search_text);
                        result_cnt = true;
                    }
                });

                // Adding message in case of no search results.
                if ( ! result_cnt ) {
                    appendItem('No search result found.','');
                }
            }

            //Adding each title and then processing it(basically adding items to list).
            appendSectionTitle('Login Status');
            processItems([status], search_text);

            appendSectionTitle('Roles');
            processItems(Object.values(user_roles_emails['roles']), search_text);

            appendSectionTitle('User Emails');
            processItems(user_roles_emails['emails'], search_text);

         
            
        });

        $(document).on("click", function (event) {
            if (!$(event.target).closest("#mo_sps_generate_restrict_sc").length) {
                $(`#mo_doc_lib_search_user_role_email_drpdn`).slideUp("fast");
            }
        });

        $(document).on('click', `.mo_doc_lib__ma_access_options`, function (e) {
            e.preventDefault();
            var ele = e.currentTarget;
            var user_role_email = ele.getAttribute('data-role-email');
            var ids = user_role_email.replace(/\W/g, '_');
            $(`#mo_doc_lib__ma_access_drpdn_${ids}`).show();
        });

        $(document).on('click', `div[id^='mo_doc_lib__ma_access_items_']`, function (e) {
            e.preventDefault();
            var id = e.currentTarget.id;
            var user_role_email = e.currentTarget.getAttribute('data-role-email');
            var text = (e.currentTarget.textContent).toLowerCase();
            var ids = user_role_email.replace(/\W/g, '_');
            $(`div[id^='mo_doc_lib__ma_access_drpdn_']`).hide();
            $(`#mo_doc_lib__ma_access_type_${ids}`).html(text);
        });

        $(document).on('click', "div[id^='mo_doc_lib_search_user_role_email_drpdn_item_']", function (e) {
            e.preventDefault();
            e.stopPropagation();

            let user_email = e.currentTarget.getAttribute('user_email');
            let ids = user_email.replace(/\W/g, '_');

            $(`#mo_doc_lib_add_new_permisions_empty`).hide();
            $(`#mo_doc_lib_add_new_permissions_rows`).append(`<div id="${ids}" class="mo_doc_lib_add_new_permissions_rows" data-role-email="${user_email}">
                <div>
                    <input data-role-email="${user_email}" class="mo_doc_lib_new_permissions_checkbox" type="checkbox" value="toggle_view" name="elements-to-show">
                    ${user_email}
                </div>
                <div class="dropdown" data-role-email="${user_email}">
                    <div class="mo_doc_lib__ma_access_options" data-role-email="${user_email}" style="display:flex;align-items:center;width:8rem;justify-content:end;">
                        <div id="mo_doc_lib__ma_access_type_${ids}">view</div>
                        <span class="dashicons dashicons-arrow-down"></span>
                    </div>
                    <div id="mo_doc_lib__ma_access_drpdn_${ids}" class="dropdown-content-new">
                        <div class="dropdown-option" id="mo_doc_lib__ma_access_items_view_${ids}" data-role-email="${user_email}">View</div>
                        <div class="dropdown-option" id="mo_doc_lib__ma_access_items_view_download_${ids}" data-role-email="${user_email}">View, Download</div>
                        <div class="dropdown-option" id="mo_doc_lib__ma_access_items_all_${ids}" data-role-email="${user_email}">View, Download, Upload</div>
                    </div>
                </div>
            </div>
            `);

            $(`#mo_doc_lib_search_user_role_email_drpdn`).slideUp("fast");

        });

        $(document).on('click', `#mo_doc_lib__ma_delete_permissions`, function (e) {
            e.preventDefault();
            var selected_permissions = $(`.mo_doc_lib_new_permissions_checkbox:checked`).toArray();
            selected_permissions.forEach(ele => {
                var user_role_email = ele.getAttribute('data-role-email');
                var ids = user_role_email.replace(/\W/g, '_');
                $(`#${ids}`).remove();
            });
        });

        $(document).on('click', `#mo_doc_lib__ma_add_permissions`,async function (e) {
            e.preventDefault();
            var doc_id = e.currentTarget.getAttribute('doc_id');
            var input_val = $(`#mo_doc_lib__ma_inherit_permission_input:checked`).val() ? 'checked' : '';

            await add_permission_for_item(doc_id, input_val);

            await docLibEmbedHandleBackendSaveFunctionality('mo_doc_lib__ma_add_permissions', {'permissions': JSON.stringify(folder_file_permissions)}).then(async (res) => {
                if (!res.success) {
                    mo_doc_lib_handle_errors(res);
                    return;
                }

                $(`#mo_doc_lib_upload_close_btn_${current_db_id}`).click();
            });
        });

        $(document).on('click', `#mo_doc_lib__ma_up, #mo_doc_lib__ma_do, #mo_doc_lib__ma_vi`, function (e) {
            var id = e.currentTarget.id;
            switch (id) {
                case 'mo_doc_lib__ma_up': $(`#mo_doc_lib__ma_vi`).prop("checked", true);
                    break;
                case 'mo_doc_lib__ma_do': $(`#mo_doc_lib__ma_vi`).prop("checked", true);
                    break;
                case 'mo_doc_lib__ma_vi':
                    if ($(`#mo_doc_lib__ma_vi`).val()) {
                        $(`#mo_doc_lib__ma_do`).prop("checked", false);
                        $(`#mo_doc_lib__ma_up`).prop("checked", false);
                    }
                    break;
            }
        })

        // shortcode builder events handle.
        $(document).on('click', '#mo_doc_lib_gsc_preview', function (e) {
            $(`.mo-ms-tab-li-div-active`).removeClass(`mo-ms-tab-li-div-active`);
            $(`#mo_doc_lib_gsc_preview_div`).addClass('mo-ms-tab-li-div-active');
            var content = `
                <div>
                    <div class="mo_doc_lib_gsc_container">
                        <div class="mo_doc_lib_gsc">1. Default View:</div>
                        <div class="mo_doc_lib_gsc__inputs">
                            <div>`
                            if (view_mode == '') {
                                content += `<input type="radio" checked value="list_view" id="mo_doc_lib_gsc_dv_lv" name="default-view">List View&nbsp;&nbsp;`;
                            } else {
                                content += `<input type="radio" ${view_mode == `list_view` ? `checked` : ``} value="list_view" id="mo_doc_lib_gsc_dv_lv" name="default-view">List View&nbsp;&nbsp;`;
                            }
                            content += `<input type="radio" ${view_mode == `grid_view` ? `checked` : ``} value="grid_view" id="mo_doc_lib_gsc_dv_gv" name="default-view">Grid View
                            </div>
                        </div>
                    </div>
                </div>
                <div>
                    <div class="mo_doc_lib_gsc_container">
                        <div class="mo_doc_lib_gsc">2. Elements To Show:</div>
                        <div class="mo_doc_lib_gsc__inputs">
                            <div>`
                            if ($.isEmptyObject(elements_to_show)) {
                                if (!is_shortcode && embedConfig.doc_lib_edit_mode) {
                                    content += `<input type="checkbox" value="breadcrumbs" name="elements-to-show">Breadcrumbs&nbsp;&nbsp;
                                        <input type="checkbox" value="toggle_view" name="elements-to-show">Toggle View&nbsp;&nbsp;
                                        <input type="checkbox" value="search_bar" name="elements-to-show">Search Bar&nbsp;&nbsp
                                       `;
                                } else {
                                    content += `<input type="checkbox" checked value="breadcrumbs" name="elements-to-show">Breadcrumbs&nbsp;&nbsp;
                                        <input type="checkbox" checked value="toggle_view" name="elements-to-show">Toggle View&nbsp;&nbsp;
                                        <input type="checkbox" checked value="search_bar" name="elements-to-show">Search Bar&nbsp;&nbsp
                                        `;
                                }
                            } else {
                                content += `<input type="checkbox" ${'breadcrumbs' in elements_to_show ? `checked` : ``} value="breadcrumbs" name="elements-to-show">Breadcrumbs&nbsp;&nbsp;
                                    <input type="checkbox" ${'toggle_view' in elements_to_show ? `checked` : ``} value="toggle_view" name="elements-to-show">Toggle View&nbsp;&nbsp;
                                    <input type="checkbox" ${'search_bar' in elements_to_show ? `checked` : ``} value="search_bar" name="elements-to-show">Search Bar&nbsp;&nbsp
                                    `;
                            }
                            content += `</div>
                        </div>
                    </div>
                </div>
                <div>
                    <div class="mo_doc_lib_gsc_container">
                        <div class="mo_doc_lib_gsc">3. Table Columns:</div>
                        <div class="mo_doc_lib_gsc__inputs">
                            <div>`;
                            if ($.isEmptyObject(column_to_add)) {
                                if (!is_shortcode && embedConfig.doc_lib_edit_mode) {
                                    content += `<input type="checkbox" value="name" id="mo_doc_lib_gsc_tc_nm" name="table-columns">Name&nbsp;&nbsp;
                                        <input type="checkbox" value="last_modified" id="mo_doc_lib_gsc_tc_lm" name="table-columns">Last Modified&nbsp;&nbsp;
                                        <input type="checkbox" value="size" id="mo_doc_lib_gsc_tc_si" name="table-columns">Size`;
                                } else {
                                    content += `<input type="checkbox" checked value="name" id="mo_doc_lib_gsc_tc_nm" name="table-columns">Name&nbsp;&nbsp;
                                        <input type="checkbox" checked value="last_modified" id="mo_doc_lib_gsc_tc_lm" name="table-columns">Last Modified&nbsp;&nbsp;
                                        <input type="checkbox" checked value="size" id="mo_doc_lib_gsc_tc_si" name="table-columns">Size`;
                                }
                            } else {
                                content += `<input type="checkbox" ${'name' in column_to_add ? `checked` : ``} value="name" id="mo_doc_lib_gsc_tc_nm" name="table-columns">Name&nbsp;&nbsp;
                                    <input type="checkbox" ${'last_modified' in column_to_add ? `checked` : ``} value="last_modified" id="mo_doc_lib_gsc_tc_lm" name="table-columns">Last Modified&nbsp;&nbsp;
                                    <input type="checkbox" ${'size' in column_to_add ? `checked` : ``} value="size" id="mo_doc_lib_gsc_tc_si" name="table-columns">Size`;
                            }
                            content += `</div>
                        </div>
                    </div>
                </div>
                <div>
                    <div class="mo_doc_lib_gsc_container">
                        <div class="mo_doc_lib_gsc">4. Preview File Options:</div>
                        <div class="mo_doc_lib_gsc__inputs">
                            <div>`;
                            if (preview_option == '') {
                                content += `<input type="radio" checked value="new_tab" id="mo_doc_lib_gsc_pfo_nt" name="preview-option">New Tab&nbsp;&nbsp`;
                            } else {
                                content += `<input type="radio" ${preview_option == 'new_tab' ? `checked` : ``} value="new_tab" id="mo_doc_lib_gsc_pfo_nt" name="preview-option">New Tab&nbsp;&nbsp`;
                            }
                            content += `<input type="radio" ${preview_option == 'pop_up' ? `checked` : ``} value="pop_up" id="mo_doc_lib_gsc_pfo_pu" name="preview-option">Pop Up
                            </div>
                        </div>
                    </div>
                </div>
                <div>
                    <div class="mo_doc_lib_gsc_container">
                        <div class="mo_doc_lib_gsc">5. Folder Download:</div>
                        <div class="mo_doc_lib_gsc__inputs">
                            <div>`;
                            if (folder_download_option == '') {
                                content += `<input type="radio" checked value="enable_download" id="mo_doc_lib_gsc_fd_ed" name="folder-download-option">Enable&nbsp;&nbsp`;
                            } else {
                                content += `<input type="radio" ${folder_download_option == 'enable_download' ? `checked` : ``} value="enable_download" id="mo_doc_lib_gsc_fd_ed" name="folder-download-option">Enable&nbsp;&nbsp`;
                            }
                            content += `<input type="radio" ${folder_download_option == 'disable_download' ? `checked` : ``} value="disable_download" id="mo_doc_lib_gsc_fd_dd" name="folder-download-option">Disable
                            </div>
                        </div>
                    </div>
                </div>
                <div>
                    <div class="mo_doc_lib_gsc_container">
                        <div class="mo_doc_lib_gsc">6. File List View:</div>
                        <div class="mo_doc_lib_gsc__inputs">
                            <div>`;
                            if (list_option == '') {
                                content += `<input type="radio" checked value="expanded_view" id="mo_doc_lib_gsc_flv_ev" name="list-view-option">Expanded View&nbsp;&nbsp`;
                            } else {
                                content += `<input type="radio" ${list_option == 'expanded_view' ? `checked` : ``} value="expanded_view" id="mo_doc_lib_gsc_flv_ev" name="list-view-option">Expanded View&nbsp;&nbsp`;
                            }
                            content += `<input type="radio" ${list_option == 'compact_view' ? `checked` : ``} value="compact_view" id="mo_doc_lib_gsc_flv_cv" name="list-view-option">Compact View
                            </div>
                        </div>
                    </div>
                </div>
                <div>
                    <div class="mo_doc_lib_gsc_container">
                        <div class="mo_doc_lib_gsc">7. Preview Width:</div>
                        <div class="mo_doc_lib_gsc__inputs">
                            <div>`;
                            if (preview_width == '') {
                                content += `<input type="number" class="cn" min=40 step=5 value="80" id="mo_doc_lib_gsc_pw_txt" name="preview-width">`;
                            } else {
                                content += `<input type="number" class="cn" min=40 step=5 value="${preview_width}" id="mo_doc_lib_gsc_pw_txt" name="preview-width">`;
                            }
                            content += `</div>
                        </div>
                    </div>
                </div>
            `;
            $(`#mo_doc_lib_gsc_tab_settings`).html(content);
        });

        $(document).on('click', `#mo_doc_lib_gsc_search_div`, function(e) {
            $(`.mo-ms-tab-li-div-active`).removeClass(`mo-ms-tab-li-div-active`);
            $(`#mo_doc_lib_gsc_search_div`).addClass('mo-ms-tab-li-div-active');

            var content = `
                <div>
                    <div class="mo_doc_lib_gsc_selected_items">
                        selected site: <div id="mo_doc_lib_gsc_search_selected_site">${selected_site_name ? selected_site_name : `No site choosen`}</div>
                    </div>
                    <div class="mo_doc_lib_gsc_selected_items">
                        selected site: <div id="mo_doc_lib_gsc_search_selected_drive">${selected_drive_name ? selected_drive_name : `No drive choosen`}</div>
                    </div>
                    <div class="mo_doc_lib_gsc_selected_items">
                        selected site: <div id="mo_doc_lib_gsc_search_selected_folder">${selected_folder_name ? selected_folder_name : `No folder choosen`}</div>
                    </div>
                    <div>
                        You can select the site, drive, and folder from the left side documents view.
                    </div>
                </div>
            `;
            $(`#mo_doc_lib_gsc_tab_settings`).html(content);
        });

        $(document).on('click', `#mo_doc_lib__ma_inherit_permission_input`, async function(e){
            var doc_id = e.currentTarget.getAttribute('doc_id');
            var input_val = $(`#mo_doc_lib__ma_inherit_permission_input:checked`).val() ? 'checked' : '';

            if(input_val == 'checked') {
                var parent_permission = await get_parent_permissions(doc_id);
                $(`#mo_doc_lib__ma_display_and_add_permissions`).html(saved_permissions(parent_permission))
            } else {
                var doc_permission = folder_file_permissions[doc_id] ?? {};
                $(`#mo_doc_lib__ma_display_and_add_permissions`).html(saved_permissions(doc_permission));
            }

        });

        $(document).on('click', `#upload_file_button_${current_db_id}`, async function(e){
            var fileName = $(`#input_file_${current_db_id}`).val();
            fileName = (fileName.split('\\')).pop();
            $(`#mo_sps_upload_status_msg_${current_db_id}`).html(``);
            docLibEmbedHandleUploadSessionCalls('mo_sps_get_upload_session',{drive_id:selected_drive_id, folder_id:selected_folder_id, file_name:fileName}).then(async (res)=>{
                if(!res.success) {
                    if(res.data.Error == 'accessDenied') {
                        $(`#mo_sps_upload_status_msg_${current_db_id}`).html(`<div style="color:#ff0000;">Access Denied</div>`)
                    } else if(res.data.Error == 'BadRequest') {
                        $(`#mo_sps_upload_status_msg_${current_db_id}`).html(`<div style="color:red;">You haven't choosen any file</div>`)
                    } else {
                        $(`#mo_sps_upload_status_msg_${current_db_id}`).html(`<div style="color:red;">${res.data.Error}</div><div style="color:red;">${res.data.Description}</div>`)
                    }

                    jQuery(`#mo_sps_upload_status_msg_${current_db_id}`).show();
                    jQuery(`#mo_sps_upload_status_msg_${current_db_id}`).delay(1000).fadeOut();
                }
                else {
                    $(`#mo_sps_upload_status_msg_${current_db_id}`).html(`<div style="background-color: #04AA6D; color: white; font-weight: bold; padding: 5px"><span style="margin-right: 5px" class="dashicons-yes-alt dashicons"></span>File Uploaded Successfully<span style="cursor:pointer;float:right;" id="mo_sps_close_file_uploaded_message_${current_db_id}" class="dashicons dashicons-no-alt"></span></div>`)
                    await uploadChunks($(`#input_file_${current_db_id}`)[0].files[0],res,current_db_id);
                    loadPaths[currentView].init();
                }

            });
        });

        $(document).on('click', `#mo_sps_close_file_uploaded_message_${current_db_id}`, function(e) {
            jQuery(`#mo_sps_upload_status_msg_${current_db_id}`).hide();
        });

    }

    async function add_permission_for_item(doc_id, input_val) {
        if(input_val == 'checked' && folder_file_permissions[doc_id]) {
            delete folder_file_permissions[doc_id];
        } else {
            var added_permissions_array = $(`.mo_doc_lib__ma_access_options`).toArray();
            var permissions = {'view':[],'download':[],'upload':[]};
            added_permissions_array.forEach(ele => {
                var user_role_email = ele.getAttribute('data-role-email');
                var access_type = ele.innerText;
                var access_array = access_type.split(', ');
                access_array.forEach(type=>{
                    permissions[type].push(user_role_email);
                })
            });


            
                    if ($(`#mo_doc_lib__ma_vi:checked`).val())
                        permissions['view'].push('anonymous');
                    if ($(`#mo_doc_lib__ma_do:checked`).val())
                        permissions['download'].push('anonymous');
                    if ($(`#mo_doc_lib__ma_up:checked`).val())
                        permissions['upload'].push('anonymous');
                    folder_file_permissions[doc_id] = permissions;
                
        }
    }

    async function get_parent_permissions(doc_id) {
        try {
            const res = await docLibEmbedHandleBackendCallsForItemsInheritedPermissions('mo_doc_lib_get_items_inherited_permissions', {
                doc_id: doc_id
            });

            if (!res.success) {
                return null; // or handle the error as needed
            }

            return res.data;
        } catch (error) {
            return; // or handle the error as needed
        }
    }

    async function createManageAccessModal(doc_id, doc_name, doc_type) {
        var doc_permission = folder_file_permissions[doc_id] ?? {};
        var inherit_enable = '';

        if ($.isEmptyObject(doc_permission)) {
            inherit_enable = 'checked';
            doc_permission = await get_parent_permissions(doc_id);
        }

        var site_drive_folder_file_img = '';
        switch (doc_type) {
            case 'file':
                var icon = embedConfig.file_icon;
                file_type = doc_name.split('.');
                file_type = file_type.pop();

                let thumbnailRequired = ['png', 'jpg', 'jpeg', 'mp4', 'avi'];
                if (thumbnailRequired.includes(file_type)) {
                    icon = embedConfig.load_icon;
                    docLibEmbedHandleBackendCallsForThumnails('mo_sps_get_file_thumbnails', { drive_id: selected_drive_id, file_id: doc_id }).then((res) => {
                        if (!res.success) {
                            mo_doc_lib_handle_errors(res);
                            return;
                        }

                        icon = res.data;
                        $(`#mo_doc_lib_file_manage_access_icon`).attr('src', res.data)
                    });
                }
                else if (file_type == 'doc' || file_type == 'docx' || file_type == 'docm')
                    icon = embedConfig.worddoc_icon;
                else if (file_type == 'xlw' || file_type == 'xls' || file_type == 'xlt' || file_type == 'xlsm' || file_type == 'xlsb' || file_type == 'xltx' || file_type == 'xltm' || file_type == 'xlam' || file_type == 'ods' || file_type == 'xlsx')
                    icon = embedConfig.exceldoc_icon;
                else if (file_type == 'pdf')
                    icon = embedConfig.pdfdoc_icon;
                else if (file_type == 'url')
                    icon = embedConfig.url_icon;

                site_drive_folder_file_img = `<img id="mo_doc_lib_file_manage_access_icon" width="20" height="20"src="${icon}"/>`;
                break;
            case 'folder':
                site_drive_folder_file_img = `<img width="20" height="20"src="${embedConfig.folder_icon}"/>`;
                break;
            case 'site':
                site_drive_folder_file_img = `<span class="dashicons dashicons-admin-site-alt"></span>`;
                break;
            case 'drive':
                site_drive_folder_file_img = `<img width="20" height="20"src="${embedConfig.folder_icon}"/>`;
                break;
        }

        var new_modal = `
        <div id="myModal_${current_db_id}" class="modal">
            <div class="modal-content">
                <div class="mo_doc_lib__ma_all_container">
                    <div class="mo_doc_lib__ma_heading">Manage Access</div>
                    <span class="mo_doc_lib_upload_close_btn" id="mo_doc_lib_upload_close_btn_${current_db_id}"><span style="font-size:2rem;color:red;display:flex;align-items:center;" class="dashicons dashicons-no-alt"></span></span>
                </div>
                <div class="mo_doc_lib__ma_all_container">
                    <div class="mo_doc_lib__ma_folder_heading">
                        ${site_drive_folder_file_img}
                        <div>${doc_name}</div>
                    </div>
                </div>

                <div class="mo_doc_lib__ma_all_container">
                        Inherit Permissions
                        <label class="switch">
                            <input ${inherit_enable == ''? '' : 'checked'} type="checkbox" id="mo_doc_lib__ma_inherit_permission_input" name="mo_doc_lib__ma_inherit_permission_input" doc_id="${doc_id}">
                            <span class="slider round"></span>
                        </label>
                </div>

                <div id="mo_doc_lib__ma_display_and_add_permissions">`;

                new_modal += saved_permissions(doc_permission);

                new_modal += `</div>
                <div>
                    <div class="mo_doc_lib__ma_add_permission_container">
                        <div class="mo_doc_lib__ma_add_permission_inputs_container">
                        </div>
                        <div>
                            <button class="mo-ms-tab-content-button" id="mo_doc_lib__ma_delete_permissions" style="display:none">Remove</button>
                            <button class="mo-ms-tab-content-button" id="mo_doc_lib__ma_add_permissions" value="add_permission" doc_id="${doc_id}" doc_name="${doc_name}">Save Permission</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    
        <div id="overlay" class="overlay"></div>`;

        $(`#mo_doc_preview_modal_container_${current_db_id}`).html(new_modal);
    }

    function saved_permissions(doc_permission) {

        var new_modal = `<div id="mo_doc_lib__ma_saved_permission">
        <div class="mo_doc_lib__ma_all_container">
            <div class="mo_doc_lib__ma_general access_heading">
                <div class="mo_doc_lib__ma_subheadings">1. Anonymous Access</div>
                <div>
                    <input type="checkbox" ${doc_permission['view'] && doc_permission['view'].includes('anonymous') ? 'checked' : ''} value="view" id="mo_doc_lib__ma_vi" name="table-columns">View&nbsp;&nbsp;
                    <input type="checkbox" ${doc_permission['download'] && doc_permission['download'].includes('anonymous') ? 'checked' : ''} value="download" id="mo_doc_lib__ma_do" name="table-columns">Download&nbsp;&nbsp;
                    <input type="checkbox" ${doc_permission['upload'] && doc_permission['upload'].includes('anonymous') ? 'checked' : ''} value="upload" id="mo_doc_lib__ma_up" name="table-columns">Upload
                </div>
            </div>
        </div>

        <div class="mo_doc_lib__ma_all_container">
            <div class="mo_doc_lib__ma_input">
                <div class="mo_doc_lib__ma_subheadings">2. Grant Access</div>

                <input class="mo_doc_lib__ma_user_permissions_input" type="text" id="mo_doc_lib_new_permission_input" placeholder="Select user email or role">
                
                <div id="mo_doc_lib_search_user_role_email_drpdn" class="search_div">
                    <div class="list_div">
                        <ul id="mo_doc_lib_search_user_email_list_items" style="padding-left:0;margin:0;">
                        </ul>
                    </div>
                </div>
            </div>
        </div>
        <div id="mo_doc_lib_add_new_permissions" class="mo_doc_lib_add_new_permissions">`;

        new_modal += folder_file_permissions ? `` : `<div id="mo_doc_lib_add_new_permisions_empty" class="mo_doc_lib_add_new_permisions_empty">You haven't configured any restriction.</div>`;
        new_modal += `<div id="mo_doc_lib_add_new_permissions_rows">`;
        
        var permissions_array = {}
        for(const [id, ele] of Object.entries(doc_permission)) {
            for(const role_email of ele) {
                if(role_email != 'anonymous') {
                    switch(id){
                        case 'upload':permissions_array[role_email] = 'view, download, upload';
                            break;
                        case 'download':permissions_array[role_email] = 'view, download';
                            break;
                        case 'view': permissions_array[role_email] = 'view';
                            break;
                    }
                }
            }
        }

        for (const [id, ele] of Object.entries(permissions_array)) {
            var processed_id = id.replace(/\W/g, '_');
            var selected_option = ele;

            new_modal += `<div id="${processed_id}" class="mo_doc_lib_add_new_permissions_rows" data-role-email="${id}">
                <div>
                    <input data-role-email="${id}" class="mo_doc_lib_new_permissions_checkbox" type="checkbox" value="toggle_view" name="elements-to-show">
                    ${id}
                </div>
                <div class="dropdown" data-role-email="${id}">
                    <div class="mo_doc_lib__ma_access_options" data-role-email="${id}" style="display:flex;align-items:center;width:8rem;justify-content:end;">
                        <div id="mo_doc_lib__ma_access_type_${processed_id}">${selected_option}</div>
                        <span class="dashicons dashicons-arrow-down"></span>
                    </div>
                    <div id="mo_doc_lib__ma_access_drpdn_${processed_id}" class="dropdown-content-new">
                        <div class="dropdown-option" id="mo_doc_lib__ma_access_items_view_${processed_id}" data-role-email="${id}">View</div>
                        <div class="dropdown-option" id="mo_doc_lib__ma_access_items_view_download_${processed_id}" data-role-email="${id}">View, Download</div>
                        <div class="dropdown-option" id="mo_doc_lib__ma_access_items_all_${processed_id}" data-role-email="${id}">View, Download, Upload</div>
                    </div>
                </div>
            </div>`;
        }
        new_modal += `</div>
        </div></div>`;

        return new_modal;
    }

    function createModal() {
        var new_modal = `
        <div id="myModal_${current_db_id}" class="modal">
            <div class="modal-content">
                <div class="mo_doc_lib__ma_all_container">
                    <div class="mo_doc_lib__ma_heading">Upload File</div>
                    <span class="mo_doc_lib_upload_close_btn" id="mo_doc_lib_upload_close_btn_${current_db_id}"><span style="font-size:2rem;color:red;display:flex;align-items:center;" class="dashicons dashicons-no-alt"></span></span>
                </div>
                <div class="mo_doc_lib_upload_drop_area" id="dropArea_${current_db_id}">
                <p>Drag and drop a file here, or click to select one.</p>      
                     
            </div>
                <div style="padding:11px;">
                    <input type="file" hidden id="input_file_${current_db_id}">
                    <input type="button" id="upload_file_button_${current_db_id}" class="mo-ms-tab-content-button" value="Upload"/>
                </div>
        
                <div id="mo_sps_progress_div_${current_db_id}" style="display:none;">
                    <div id="mo_sps_progress_bar_div_${current_db_id}" style="width:100%;border:1px solid #ccc;position:relative;">
                        <div style="background:#2C8769;position:absolute;z-index:-1;height:1rem;width:0%;" id="mo_sps_upload_progress_bar_${current_db_id}"></div>
                        <div id="mo_sps_upload_progress_percent_${current_db_id}" style="height:1rem; color: black;">0%</div>
                    </div>
                </div>
                <div id="mo_sps_upload_status_msg_${current_db_id}" style="display:none;padding:1rem;font-size:0.8rem;">
                    <div style="background-color: #04AA6D; color: white; font-weight: bold; padding: 5px"><span style="margin-right: 5px" class="dashicons-yes-alt dashicons"></span>File Uploaded Successfully<span style="cursor:pointer;float:right;" id="mo_sps_close_file_uploaded_message_${current_db_id}" class="dashicons dashicons-no-alt"></span></div>
                </div>
            </div>
        </div>
    
        <div id="overlay" class="overlay"></div>`

        $(`#mo_doc_preview_modal_container_${current_db_id}`).html(new_modal);

    }

    function createShortcodeModal(name, fileUrl, download_url, webUrl, doc_id, key) {
        var file_type = name.split('.');
        file_type = file_type.pop();

        var tag = '';
        var image = ['png', 'jpg', 'jpeg'];
        var video = ['mp4', 'avi', 'webm', 'ogv'];
        var audio = ['mp3', 'ogg', 'wav'];
        var transrorm_to_pdf = ['pdf', 'csv', 'doc', 'docx', 'odp', 'ods', 'odt', 'pot', 'potm', 'potx', 'pps', 'ppsx', 'ppsxm', 'ppt', 'pptm', 'pptx', 'rtf', 'xls', 'xlsx', 'loop', 'fluid', 'wbtx']

        if(image.includes(file_type)) tag = 'image';
        else if(video.includes(file_type)) tag = 'video';
        else if(audio.includes(file_type)) tag = 'audio';
        else tag = 'iframe';

        if(tag === 'iframe' && !transrorm_to_pdf.includes(file_type) && embedConfig.connector === 'personal') tag = 'download';

        docLibEmbedHandleBackendCallsForThumnails('mo_sps_get_sync_file_url',{drive_id:selected_drive_id, file_id:doc_id}).then((res)=>{
            if(!res.success)
                return;

            var content = '';
            var file_url = res.data;
            
                switch(tag) {
                    case 'image' : content = `<img style="object-fit:contain;max-width:80%;max-height:-webkit-fill-available;" id="mo_sps_preview_popup_image"src="${file_url}" alt="Description">`;
                        break;

                    case 'audio' : content = `<audio controls>
                            <source id="mo_sps_preview_popup_amp3" src="${file_url}" type="audio/mp3">
                            <source id="mo_sps_preview_popup_ampeg" src="${file_url}" type="audio/mpeg">
                            <source id="mo_sps_preview_popup_aogg" src="${file_url}" type="audio/ogg">
                            <source id="mo_sps_preview_popup_awav" src="${file_url}" type="audio/wav">
                            Your browser does not support this file.
                        </audio>`;
                        break;

                    case 'video' : content = `<video style="max-width:80%;height:100%;" controls>
                            <source id="mo_sps_preview_popup_vmp4" src="${file_url}" type="video/mp4">
                            <source id="mo_sps_preview_popup_vwebm" src="${file_url}" type="video/webm">
                            <source id="mo_sps_preview_popup_vogg" src="${file_url}" type="video/ogg">
                            Your browser does not support the video tag.
                        </video>`;
                        break;

                    case 'iframe' : content = `<iframe style="width:80%;height: -webkit-fill-available;background:white !important;" src="${fileUrl}" title="Preview" allowtransparency="true"></iframe>`;
                        break;

                    case 'download' : var download_ajax = `${embedConfig.ajax_url}?action=mo_sps_download_file&drive_id=${selected_drive_id}&file_id=${doc_id}`;

                        var icon = embedConfig.file_icon;
                        file_type = name.split('.');
                        file_type = file_type.pop();
    
                        if (file_type == 'doc' || file_type == 'docx' || file_type == 'docm')
                            icon = embedConfig.worddoc_icon;
                        else if (file_type == 'xlw' || file_type == 'xls' || file_type == 'xlt' || file_type == 'xlsm' || file_type == 'xlsb' || file_type == 'xltx' || file_type == 'xltm' || file_type == 'xlam' || file_type == 'ods' || file_type == 'xlsx')
                            icon = embedConfig.exceldoc_icon;
                        else if (file_type == 'pdf')
                            icon = embedConfig.pdfdoc_icon;
                        else if (file_type == 'url')
                            icon = embedConfig.url_icon;
                        content = `<div class="mo_sps_unable_to_preview">
                            <div class="mo_sps_unable_to_preview_container">
                                <img class="mo_sps_unable_to_preview_image" src="${icon}"/>
                                <div class="mo_sps_unable_to_preview_file_name">${name}</div>
                                <div class="mo_sps_unable_to_preview_msg">Hmm... Looks like this file doesn't have a preview we can show you.</div>
                                <a class="mo_sps_unable_to_preview_download_button" href="${download_ajax}">Download</a>
                            </div>
                        </div>`;
                        break;
                }
                $(`#mo_sps_modal_content_file_preview_popup`).html(content);
        });

        var download_permission = preview_pop_up_content[key].doc_download_permission;
        var download_ajax = `${embedConfig.ajax_url}?action=mo_sps_download_file&drive_id=${selected_drive_id}&file_id=${doc_id}`;
        
        let modal = `<div id="myModal_${current_db_id}" class="modal-file-preview">
            <div id="mo_doc_lib_preview_pop_up_go_left_${current_db_id}" key="${key}" class="mo_doc_lib_file_preview_pop_up_right_left"><img src="${embedConfig.right_white}"></div>
            <div class="modal-content-file-preview" id="mo_sps_modal_content_file_preview_popup">
            </div>
            <div id="mo_doc_lib_preview_pop_up_go_right_${current_db_id}" key="${key}" class="mo_doc_lib_file_preview_pop_up_right_left"><img src="${embedConfig.left_white}"></div>
        </div>
    
        <div id="overlay" class="overlay-file-preview">
            <div class="mo_doc_lib__fp_all_container-file-preview">
                <div class="mo_doc_lib__fp_all_container-file-preview-icons">
                    <span class="mo_doc_lib_upload_close_btn" id="mo_doc_lib_upload_close_btn_${current_db_id}"><span style="color:white;" class="dashicons dashicons-arrow-left-alt"></span></span>
                    <div class="mo_doc_lib__fp_heading">${name}</div>
                </div>
                <div class="mo_doc_lib__fp_all_container-file-preview-icons">
                    ${is_shortcode ? `` : `<button type="button" style="display:flex !important;border:none;" class="mo_doc_lib_site_manage_access mo_doc_video_copy_shortcode mo_sps_tooltip" doc_id="${doc_id}" index="uk">
                        <img width="18px" height="18px" src="${embedConfig.copy_icon_white}"/>
                        <span id="mo_sps_copy_file_specific_shortcode_${current_db_id}_uk" style="width:224px;" class="mo_sps_tooltiptext">Copy Shortcode</span>
                    </button>`}
                    ${download_permission ? `<a onclick='event.stopPropagation();' class="mo_doc_lib_file_download" href="${download_ajax}"><div title="Download" class="mo_doc_lib_site_manage_access" style="display:flex !important;"><img width="18px" height="18px" src="${embedConfig.download_white}"/></div></a>`:``}
                    <div title="Preview in Sharepoint" site_url="${webUrl}" class="mo_doc_lib_site_manage_access mo_doc_lib_site_redirect_to_sharepoint"  style="display:flex !important;"><img width="18px" height="18px" src="${embedConfig.redirect_white}"/></div>
                </div>
            </div>
        </div>`

        $(`#mo_doc_preview_modal_container_${current_db_id}`).html(modal);

    }

    function handleFiles(files) {
        var dropArea = $(`#dropArea_${current_db_id}`);
        var fileInput = $(`#input_file_${current_db_id}`);

        if (files.length > 0) {
            var fileName = files[0].name;
            dropArea.html(`<p>File selected: ${fileName}</p>`);
        } else {
            dropArea.html(`<p>No file selected.</p>`);
        }
        global_file = files;
    }

    // handle errors to show in embed view.
    function mo_doc_lib_handle_errors(res) {
        if(!is_shortcode) {
            $(`#mo_doc_lib_container_${current_db_id}`).append(`<div style="display:flex;justify-content:center;align-items:center;width:100%;height:400px;">
                <div style="display:flex;flex-direction:column;align-items:center;">
                    <img style="width:30px !important; height:30px !important;" src="${embedConfig.error_icon}"><br>
                    <div>${res.data.Error}</div><br>
                    <div>${res.data.Description}</div>
                </div>
            </div>`);
        } else {
            $(`#mo_doc_lib_container_${current_db_id}`).html(`<div style="display:flex;justify-content:center;align-items:center;width:100%;height:400px;">
                <div style="display:flex;flex-direction:column;align-items:center;">
                    <img style="width:30px !important; height:30px !important;" src="${embedConfig.error_icon}"><br>
                    <div>Something went wrong...!</div><br>
                    <div>Please check your internet connection or try again after sometime.</div>
                </div>
            </div>`);
        }
    }

    function docLibEmbedHandleUploadSessionCalls(task,payload) {
        return $.ajax({
            url: `${uploadConfig.ajax_url}?action=mo_doc_lib_upload&nonce=${uploadConfig.nonce}`,
            type: "POST",
            data: {
                task,
                payload
            },
            cache:false,
            success: function(data){
                return data;
            },
        });
    }

    //API Handler
    async function docLibEmbedHandleBackendCalls(task, payload) {
        return $.ajax({
            url: `${embedConfig.ajax_url}?action=mo_doc_lib_embed&nonce=${embedConfig.nonce}`,
            type: "POST",
            data: {
                task,
                payload
            },
            cache: false,

            beforeSend: function () {
                $(`#mo_doc_lib_container_${current_db_id}`).html('');
                $(`#sps_embed_container_${current_db_id}`).html('');

                $(`#mo_doc_lib_container_${current_db_id}`).hide();
                $(`#sps_embed_container_${current_db_id}`).hide();
                $('.mo_doc_lib_shortcode_container').hide();

                $('.mo_doc_lib_sc_tree__loader').show();
                $(`#mo_doc_lib_container__loader_${current_db_id}`).show();
                $(`#sps_embed_container_${current_db_id}`).html('Loading...');
            },
            success: function (data) {

                $(`#mo_doc_lib_container_${current_db_id}`).html('');
                $(`#sps_embed_container_${current_db_id}`).html('');

                $(`#mo_doc_lib_container_${current_db_id}`).show();
                $('.mo_doc_lib_shortcode_container').show();
                $(`#sps_embed_container_${current_db_id}`).show();
                $(`span[id^='mo_sps_breadcrumb_']`).removeAttr('disable');


                $('.mo_doc_lib_sc_tree__loader').hide();
                $(`#mo_doc_lib_container__loader_${current_db_id}`).hide();
                $(`#mo_doc_lib_table__loader_${current_db_id}`).hide();

                return data;
            },
        });

    }

    function docLibEmbedHandleBackendCallsForFolderTree(task, payload) {
        return $.ajax({
            url: `${embedConfig.ajax_url}?action=mo_doc_lib_embed&nonce=${embedConfig.nonce}`,
            type: "POST",
            data: {
                task,
                payload
            },
            cache: false,

            beforeSend: function () {
                $('.mo_doc_lib_sc_tree__loader').show();
            },
            success: function (data) {
                $('.mo_doc_lib_sc_tree__loader').hide();
                return data;
            },
        });
    }

    function docLibEmbedHandleBackendCallsForThumnails(task, payload) {
        return $.ajax({
            url: `${embedConfig.ajax_url}?action=mo_doc_lib_embed&nonce=${embedConfig.nonce}`,
            type: "POST",
            data: {
                task,
                payload
            },
            cache: false,
            success: function (data) {
                return data;
            },
        });
    }

    function docLibEmbedHandleBackendCallsForFiles(task, payload) {

        return $.ajax({
            url: `${embedConfig.ajax_url}?action=mo_doc_lib_embed&nonce=${embedConfig.nonce}`,
            type: "POST",
            data: {
                task,
                payload
            },
            cache: false,

            success: function (data) {

                return data;
            },
        });
    }

    async function docLibEmbedHandleBackendSaveFunctionality(task, payload) {
        return $.ajax({
            url: `${embedConfig.ajax_url}?action=mo_doc_lib_embed&nonce=${embedConfig.nonce}`,
            type: "POST",
            data: {
                task,
                payload
            },
            cache: false,

            success: function (data) {

                return data;
            },
        });
    }

    function docLibEmbedHandleBackendCallsForItemsInheritedPermissions(task, payload) {
        return $.ajax({
            url: `${embedConfig.ajax_url}?action=mo_doc_lib_embed&nonce=${embedConfig.nonce}`,
            type: "POST",
            data: {
                task,
                payload
            },
            cache: false,

            success: function (data) {

                return data;
            },
        });
    }

    //Helper Functions
    function mo_sps_get_doc_size(size, precision = 2) {
        base = Math.log(size) / Math.log(1024);
        suffixes = ['B', 'KB', 'MB', 'GB', 'TB'];
        return Math.round(Math.pow(1024, base - Math.floor(base)), precision) + ' ' + suffixes[Math.floor(base)];
    }

    function mo_sps_get_date_by_timestamp(inputDate, format = 'dd-MM-yyyy') {

        const date = new Date(inputDate);
        const day = date.getDate();
        const month = date.getMonth() + 1;
        const year = date.getFullYear();
        format = format.replace("MM", month.toString().padStart(2, "0"));
        if (format.indexOf("yyyy") > -1) {
            format = format.replace("yyyy", year.toString());
        } else if (format.indexOf("yy") > -1) {
            format = format.replace("yy", year.toString().substr(2, 2));
        }
        format = format.replace("dd", day.toString().padStart(2, "0"));

        return format;
    }

})(jQuery);

