(function($){

    let file_id = embedConfig.item_id;
    let drive_id = embedConfig.drive_id;
    let folder_id = embedConfig.folder_id;

    let permissions = embedConfig.permissions;
    
    let doc_type = "file";

    let thumbnail_url=null;
    let download_url=null;
    let preview_url=null; 
    let file_name = null;
    let file_size = null;
    let file_date = null;

    let thumb;
    let dwn;
    let prev;
   
    docLibEmbedHandleBackendCallsForThumnails('mo_sps_get_file_thumbnails',{drive_id:drive_id,file_id:file_id}).then((res)=>{
        
        if(!res.success)
            return;

        thumbnail_url = res.data;
    });
    getDownloadURL('mo_sps_get_download_url',{drive_id:drive_id,file_id:file_id}).then((res)=>{
        
        if(!res.success)
            return;
        
        download_url = res.data.download;
        file_name = res.data.name;
        file_size = res.data.size;
        file_date = res.data.lastModifiedDateTime;

    });
    getPreviewURL('mo_sps_get_specific_file',{drive_id:drive_id,file_id:file_id}).then((res)=>{
        
        if(!res.success)
            return;
        
        preview_url = res.data;
    });


    

$.when(thumb, dwn, prev).then(function() {
   process_file();
});


function process_file(){

    if(preview_url!=null && download_url!=null && thumbnail_url!=null && file_name!=null && file_id!=null){

        file_type = file_name.split('.');
        file_type = file_type.pop();
                
                let thumbnailRequired = ['png','jpg','jpeg','mp4','avi'];
                if(thumbnailRequired.includes(file_type)){
                
                    icon = thumbnail_url;
                    $(`#mo_doc_lib_file_icon_${file_id}`).attr('src',thumbnail_url);
                }
                else if(file_type == 'doc' || file_type == 'docx' || file_type == 'docm')
                    icon = embedConfig.worddoc_icon;
                else if(file_type == 'xlw' || file_type == 'xls' || file_type == 'xlt' || file_type == 'xlsm' || file_type == 'xlsb' || file_type == 'xltx' || file_type == 'xltm' || file_type == 'xlam' || file_type == 'ods' || file_type == 'xlsx')
                    icon = embedConfig.exceldoc_icon;
                else if(file_type == 'pdf')
                    icon = embedConfig.pdfdoc_icon;
                else 
                    icon = embedConfig.file_icon;

                

                let p_item_id = "#mo_doc_lib_container_"+ file_id;
        $(p_item_id).html(`<ul id="mo_doc_lib_all_docs_list" style="height:auto !important" class="mo_doc_lib_responsive-table"></ul>`);

    $("#mo_doc_lib_all_docs_list").append(`<li name="mo_doc_lib_${file_id}" breadcrumb="${file_name}" id="${file_id}" class="mo_doc_lib_table-row">

    <div name="mo_doc_lib_${doc_type}" breadcrumb="${file_name}" id="${file_id}" class="mo_doc_lib_col mo_doc_lib_fcol-1" data-label="Doc Name">    
 
        <img id="mo_doc_lib_file_icon_${file_id}" style="margin-right:10px" width="30px" height="30px" src="${icon}"/>${file_name}
    </div>

    <div name="mo_doc_lib_${doc_type}" breadcrumb="${file_name}" id="${file_id}" class="mo_doc_lib_col mo_doc_lib_fcol-2" data-label="Doc Date">${mo_sps_get_date_by_timestamp(file_date)}</div>
    <div name="mo_doc_lib_${doc_type}" breadcrumb="${file_name}" id="${file_id}" class="mo_doc_lib_col mo_doc_lib_fcol-4" data-label="Doc Size">${file_size?mo_sps_get_doc_size(file_size):'-'}</div>

    <div onclick='event.stopPropagation();' class="mo_doc_lib_col mo_doc_lib_fcol-5" data-label="Download" id="mo_doc_lib_file_download_${doc_type}">${doc_type === 'file'?`<a onclick='event.stopPropagation();' class="mo_doc_lib_file_download" href="${download_url}"><img onclick='event.stopPropagation();' width="20px" height="20px" src="${embedConfig.download_icon}"/></a>`:`-`}</div>
</li>`);
    }
}
  
    
   //Helper Functions
   function mo_sps_get_doc_size(size,precision = 2)
   {
       base = Math.log(size)/Math.log(1024);
       suffixes = ['', 'KB', 'MB', 'GB', 'TB'];   
       return Math.round(Math.pow(1024, base - Math.floor(base)), precision) +' '+ suffixes[Math.floor(base)];
   }

   function mo_sps_get_date_by_timestamp(inputDate, format = 'dd-MM-yyyy') {
 
       const date = new Date(inputDate);
       const day = date.getDate();
       const month = date.getMonth() + 1;
       const year = date.getFullYear();   
       format = format.replace("MM", month.toString().padStart(2,"0"));        
       if (format.indexOf("yyyy") > -1) {
           format = format.replace("yyyy", year.toString());
       } else if (format.indexOf("yy") > -1) {
           format = format.replace("yy", year.toString().substr(2,2));
       }
       format = format.replace("dd", day.toString().padStart(2,"0"));
     
       return format;
     }

    
function docLibEmbedHandleBackendCallsForThumnails(task,payload){
    
    thumb = $.ajax({
        url: `${embedConfig.ajax_url}?action=mo_doc_lib_embed&nonce=${embedConfig.nonce}`,
        type: "POST",
        data: {
            task,
            payload
        },
        cache:false,
        success: function(data){
            
            thumbnail_url = data.data;
            return data;
        },
    });

    return thumb;
}
    
function getDownloadURL(task,payload){
    

    dwn = $.ajax({
        url: `${embedConfig.ajax_url}?action=mo_doc_lib_embed&nonce=${embedConfig.nonce}`,
        type: 'POST',
        data: {
            task,
            payload
        },
        cache:false,
        success: function (data) {
        return data;
        },
    });

    return dwn;
}

function getPreviewURL(task,payload){
    

    prev = $.ajax({
        url: `${embedConfig.ajax_url}?action=mo_doc_lib_embed&nonce=${embedConfig.nonce}`,
        type: 'POST',
        data: {
            task,
            payload
        },
        cache:false,
        success: function (data) {

        return data;
 
        },
    });

    return prev;
     
}

$(document).on('click',"li[name='mo_doc_lib_"+file_id+"']",function(e){
    // selected_file_id = e.target.id;
    e.preventDefault();

    window.open(`${embedConfig.ajax_url}?action=mo_sps_sync_file&drive_id=${drive_id}&file_id=${file_id}`, '_blank');
    
});

})(jQuery);
