(function ($) {
    let selected_drive_id = azure_ajax_call.selected_drive_id ?? '';

    $(document).on("click", function (event) {
        if (!$(event.target).closest("#mySearch").length) {
            $("#mySearchDropdown").slideUp("fast");
        }
    });

    $(document).on('click', `#mo_med_lib_folder_search_button`, function(e){
        $(`#mo_med_lib_selected_folder`).hide();
        $(`#mo_med_lib_search_folder`).show();
        $(`#mo_med_lib_folder_search_button`).hide();
        $(`#mo_med_lib_folder_close_button`).show();
    });

    $(document).on('click', `#mo_med_lib_folder_close_button`, function(e){
        $(`#mo_med_lib_selected_folder`).show();
        $(`#mo_med_lib_search_folder`).hide();
        $(`#mo_med_lib_folder_search_button`).show();
        $(`#mo_med_lib_folder_close_button`).hide();
    });

    $(document).on('click', `div[id^='mo_sps_search_drpdn_folder_']`, function(e){
        $("#mySearchDropdown").slideUp('fast');
        $("#searching_div").hide();
        $(`#mo_med_lib_folder_search_button`).show();
        $(`#mo_med_lib_folder_close_button`).hide();

        var ele = e.currentTarget;
        var folder_name = ele.getAttribute('doc_name');
        var folder_id = ele.getAttribute('data-id');

        $(`#mo_med_lib_search_folder`).hide();
        $(`#mo_med_lib_selected_folder`).show();
        $(`#mo_med_lib_selected_folder`).html(`<img width="20px" src="${azure_ajax_call.folder_icon}">${folder_name}`);
        
        medLibHandleBackendCallsForFolder('mo_med_lib_folder_select', {folder_name: folder_name, folder_id: folder_id}).then((res)=>{
            if(!res.success)
                return;
        });
    })

    $(document).on('keyup', `#mo_med_lib_search_folder`, function (e) {
        if(e.keyCode == 13) {
            return;
        }

        $(`#listItems`).html('');
        var querystring = $(`#mo_med_lib_search_folder`).val();
        if (querystring.length >= 2) {
            $("#mySearchDropdown").show();
            $("#searching_div").show();
            medLibHandleBackendCallsForSearch('mo_sps_search_through_drive_items', { drive_id: selected_drive_id, querystring: querystring }).then((res) => {
                if (!res.success)
                    return;

                var all_docs = res.data;
                var content = '';
                var cnt = 0;
                all_docs.forEach(doc => {
                    $("#searching_div").hide();
                    if('folder' in doc) {
                        cnt ++;
                        content += `<div id="mo_sps_search_drpdn_folder_${doc.id}" data-id="${doc.id}" doc_name="${doc.name}" class="list_items"><div><img style="display:block;width:1.2rem;height:1.2rem;margin-right:10px;" src="${azure_ajax_call.folder_icon}" alt></div><div><div style="width:11rem"><span style="word-wrap:break-word;font-size:0.9rem;">${doc.name}</span></div></div></div>`;
                    }
                });
                if(cnt == 0 || all_docs == undefined) content = `<div><h4 class="heading-4-red">No Search Results Found.</h4></div>`;
                $(`#listItems`).html(content);
            });

        }
    });

    $(document).on('change', '#mo_sps_site_select', function (e) {
        $(`#mo_sps_drive_select_container`).hide();
        $(`#mo_sps_drive_select_loader`).show();
        var site_name = $("#mo_sps_site_select option:selected").val();
        var site_id = $("#mo_sps_site_select option:selected").data('id');
        medLibHandleBackendCallsForDrives('mo_med_lib_site_select', { name: 'site', siteId: site_id, siteName: site_name }).then((res) => {
            if (!res.success) {
                return;
            }

            var drives = res.data.value ?? res.data;
            selected_drive_id = drives[0] ? drives[0].id : '';
            var drive_name = drives[0] ? drives[0].name : '';

            if(drive_name !== '' && selected_drive_id !== '') {
                medLibHandleBackendCallsForDrives('mo_med_lib_drive_select', { name: 'drive', driveName: drive_name, driveId: selected_drive_id }).then((res) => {
                    $(`#mo_sps_drive_select_container`).show();
        
                    if (!res.success)
                        return;
        
                    location.reload();
                });
            }
        })
    });

    $(document).on('change', '#mo_sps_drive_select', function (e) {
        $(`#mo_sps_drive_select_container`).hide();
        $(`#mo_sps_drive_select_loader`).show();
        var drive_name = $("#mo_sps_drive_select option:selected").val();
        selected_drive_id = $("#mo_sps_drive_select option:selected").data('id');
        medLibHandleBackendCallsForDrives('mo_med_lib_drive_select', { name: 'drive', driveName: drive_name, driveId: selected_drive_id }).then((res) => {
            $(`#mo_sps_drive_select_container`).show();

            if (!res.success)
                return;

            location.reload();
        });

    });

    function handle_error(res) {
        content = `<p>${res.data}</p>`
        $(`.mo_doc_lib_error_notification`).html(content);
        $(`.mo_doc_lib_error_notification`).css('display', 'flex');
        $(`.mo_doc_lib_error_notification`).delay(2000).fadeOut();
    }

    function medLibHandleBackendCallsForDrives(task, payload) {
        return $.ajax({
            url: `${azure_ajax_call.ajax_on_url}?action=mo_azure_sync_ajax_submit&nonce=${azure_ajax_call.nonce}`,
            type: 'POST',
            data: {
                task,
                payload
            },
            cache: false,

            beforeSend: function () {
                $('#mo_sps_loader_gif').show();
            },
            complete: function () {
                $('#mo_sps_loader_gif').hide();
            },
            success: function (res) {
                $('#mo_sps_loader_gif').hide();
                return res;
            }
        });
    }

    function medLibHandleBackendCallsForSearch(task, payload) {
        return $.ajax({
            url: `${azure_ajax_call.ajax_on_url}?action=mo_azure_sync_ajax_submit&nonce=${azure_ajax_call.nonce}`,
            type: 'POST',
            data: {
                task,
                payload
            },
            cache: false,

            // beforeSend: function () {
                
            // },
            // complete: function () {
                
            // },
            success: function (res) {
                return res;
            }
        });
    }

    function medLibHandleBackendCallsForFolder(task, payload) {
        return $.ajax({
            url: `${azure_ajax_call.ajax_on_url}?action=mo_azure_sync_ajax_submit&nonce=${azure_ajax_call.nonce}`,
            type: 'POST',
            data: {
                task,
                payload
            },
            cache: false,

            success: function (res) {
                return res;
            }
        });
    }

})(jQuery);

