'use strict';

(function($){
    

})(jQuery);

jQuery(document).ready(function () {
  // Check for FileReader API (HTML5) support.
  if (!window.FileReader) {
    alert('This browser does not support the FileReader API.');
  }
});


var fileControl = document.getElementById('input_file');
var fileToUpload;

jQuery('#input_file').on('change', function () {
  var path = this.value;
  fileToUpload = (path.split('\\')).pop();
});

// Upload the file.
// You can upload files up to 2 GB with the REST API.

async function uploadChunks(file, res, db_id){
  var uploadUrl = res.data.uploadUrl;

  var reader = new FileReader(); 

  // Variables for byte stream position
  var position = 0; 
  var chunkLength = 320 * 1024;
  var continueRead = true; 
  jQuery(`#mo_sps_progress_div_${db_id}`).show();
  while (continueRead) {
      var chunk;
      try {
          continueRead = true; 
          //Try to read in the chunk
          try {
              let stopByte = position + chunkLength;

              chunk = await readFragmentAsync(file, position, stopByte); 
              if (chunk.byteLength > 0) {
                  continueRead = true;
              }else {
                  break; 
              }
          }catch (e) {
              break; 
          }

          // Try to upload the chunk.
          try {
              let progress = Math.round(((position + chunkLength) / file.size) * 100);
              let res = await uploadChunk(chunk, uploadUrl, position, file.size); 
              
              // Check the response.
              if (res.status !== 202 && res.status !== 201 && res.status !== 200)
                  throw ("Put operation did not return expected response");
              if (res.status === 201 || res.status === 200)
              {
                    jQuery(`#mo_sps_upload_progress_bar_${db_id}`).css('width','100%');
                    jQuery(`#mo_sps_upload_progress_percent_${db_id}`).empty();
                    jQuery(`#mo_sps_upload_progress_percent_${db_id}`).html('100%');
                  continueRead = false;
              }  
              else
              {
                    jQuery(`#mo_sps_upload_progress_bar_${db_id}`).css('width',progress + '%');
                    jQuery(`#mo_sps_upload_progress_percent_${db_id}`).empty();
                    jQuery(`#mo_sps_upload_progress_percent_${db_id}`).html(progress + '%');
                  position = Number(res.json.nextExpectedRanges[0].split('-')[0]);
              }    

          }catch (e) {
              console.error("Error occured when calling uploadChunk::" + e); 
          }

      }catch (e) {
          continueRead = false; 
      }
  }
  jQuery(`#mo_sps_progress_div_${db_id}`).delay(2500).fadeOut();
  jQuery(`#mo_sps_upload_status_msg_${db_id}`).show();

  jQuery(`#input_file_${db_id}`).val('');
  jQuery(`#dropArea_${db_id}`).html(`<p>Drag and drop a file here, or click to select one.</p>`);
}

// Reads in the chunk and returns a promise.
function readFragmentAsync(file, startByte, stopByte) {
  var frag = ""; 
  const reader = new FileReader(); 
  var blob = file.slice(startByte, stopByte); 
  reader.readAsArrayBuffer(blob);     
  return new Promise((resolve, reject) =>  {
      reader.onloadend = (event) =>  {
          if (reader.readyState === reader.DONE) {
              frag = reader.result; 
              resolve(frag); 
          }
      }; 
  }); 
}

// Upload each chunk using PUT
function uploadChunk(chunk, uploadURL, position, totalLength) {
  var max = position + chunk.byteLength - 1; 
  //var contentLength = position + chunk.byteLength

  return new Promise((resolve, reject) =>  {

      try {
          let crHeader = "bytes " + position + "-" + max + "/" + totalLength;
           //Execute PUT request to upload the content range.
          jQuery.ajax({
              type: "PUT",
              contentType: "application/octet-stream",
              url: uploadURL,
              data: chunk,
              processData: false,
              headers: {"Content-Range": crHeader}                    

          }).done(function (data, textStatus, jqXHR) {
              if (jqXHR.responseJSON.nextExpectedRanges) {
              }
              else {
              }                        
              
              let results = {}
              results.status = jqXHR.status,
              results.json = jqXHR.responseJSON,
              resolve(results);

          }).fail(function (response) {

          });
      }catch (e) {
          reject(e); 
      }
  }); 
}