<?php


namespace MoSharePointObjectSync\LicenseLibrary;

define(Mo_License_Config::OPTION_PREFIX . "\x5f\114\111\103\105\116\x53\x45\x5f\114\111\102\x52\101\x52\131\137\120\x41\124\x48", plugin_dir_url(__FILE__));
use MoSharePointObjectSync\LicenseLibrary\Classes\Mo_License_Constants;
use MoSharePointObjectSync\LicenseLibrary\Classes\Mo_License_Dao;
use MoSharePointObjectSync\LicenseLibrary\Exceptions\Mo_License_Grace_Expired_Exception;
use MoSharePointObjectSync\LicenseLibrary\Exceptions\Mo_License_Invalid_Expiry_Date_Exception;
use MoSharePointObjectSync\LicenseLibrary\Exceptions\Mo_License_Missing_Customer_Email_Exception;
use MoSharePointObjectSync\LicenseLibrary\Exceptions\Mo_License_Missing_License_Key_Exception;
use MoSharePointObjectSync\LicenseLibrary\Exceptions\Mo_License_Missing_Or_Invalid_Customer_Key_Exception;
use MoSharePointObjectSync\LicenseLibrary\Exceptions\Mo_License_Unknown_Error_Exception;
use MoSharePointObjectSync\LicenseLibrary\Utils\Mo_License_Actions_Utility;
use MoSharePointObjectSync\LicenseLibrary\Utils\Mo_License_Service_Utility;
if (defined("\x41\x42\x53\120\101\x54\110")) {
    goto aK;
}
exit;
aK:
class Mo_License_Service
{
    public static function is_license_expired()
    {
		return false;
        try {
            Mo_License_Service_Utility::check_customer_login_and_license();
            $eK = Mo_License_Service_Utility::is_license_grace_expired();
        } catch (Mo_License_Grace_Expired_Exception $rY) {
            return Mo_License_Service_Utility::return_true_with_code($rY::MESSAGE);
        } catch (Mo_License_Invalid_Expiry_Date_Exception $rY) {
            return Mo_License_Service_Utility::return_true_with_code($rY::MESSAGE);
        } catch (Mo_License_Missing_License_Key_Exception $rY) {
            return Mo_License_Service_Utility::return_true_with_code($rY::MESSAGE);
        } catch (Mo_License_Missing_Customer_Email_Exception $rY) {
            return Mo_License_Service_Utility::return_true_with_code($rY::MESSAGE);
        } catch (Mo_License_Missing_Or_Invalid_Customer_Key_Exception $rY) {
            return Mo_License_Service_Utility::return_true_with_code($rY::MESSAGE);
        } catch (Mo_License_Unknown_Error_Exception $rY) {
            return Mo_License_Service_Utility::return_true_with_code($rY::MESSAGE);
        }
        return Mo_License_Service_Utility::return_false_with_code($eK["\x43\x4f\104\105"]);
    }
    public static function is_customer_license_verified()
    {
		return true;
        try {
            Mo_License_Service_Utility::check_customer_login_and_license();
        } catch (Mo_License_Missing_Customer_Email_Exception $rY) {
            return false;
        } catch (Mo_License_Missing_Or_Invalid_Customer_Key_Exception $rY) {
            return false;
        } catch (Mo_License_Missing_License_Key_Exception $rY) {
            return false;
        }
        return true;
    }
    public static function is_customer_logged_into_plugin()
    {
        try {
            Mo_License_Service_Utility::check_customer_login();
        } catch (Mo_License_Missing_Customer_Email_Exception $rY) {
            return false;
        } catch (Mo_License_Missing_Or_Invalid_Customer_Key_Exception $rY) {
            return false;
        }
        return true;
    }
    public static function get_html_disabled_status($r5 = true)
    {
        if ($r5) {
            goto Xw;
        }
        $Bx = self::is_customer_license_verified();
        goto zG;
        Xw:
        $qK = self::is_license_expired();
        $Bx = !$qK["\123\x54\101\124\125\x53"];
        zG:
        if (!(false === $Bx)) {
            goto MD;
        }
        return "\144\x69\163\141\x62\154\145\144";
        MD:
        return '';
    }
    public static function refresh_license_expiry()
    {
        $QZ = Mo_License_Actions_Utility::fetch_license_expiry_date();
        if (!$QZ) {
            goto Q_;
        }
        self::update_license_expiry($QZ);
        return $QZ;
        Q_:
        return false;
    }
    public static function mo_check_admin_referer($YK = -1, $al = "\x5f\167\160\156\x6f\x6e\x63\145", $r5 = true)
    {
        $g1 = check_admin_referer($YK, $al);
        $qK = false;
        if ($r5) {
            goto Q0;
        }
        $Bx = self::is_customer_license_verified();
        goto cO;
        Q0:
        $qK = self::is_license_expired();
        $Bx = !$qK["\x53\x54\101\124\x55\x53"];
        cO:
        if (!(!$Bx || !$g1)) {
            goto ra;
        }
        wp_die(esc_html(Mo_License_Constants::ADMIN_ERROR_MESSAGE));
        ra:
        return true;
    }
    public static function mo_check_ajax_referer($jh = -1, $al = false, $iy = true, $r5 = true)
    {
        if ($r5) {
            goto J_;
        }
        $Bx = self::is_customer_license_verified();
        goto M2;
        J_:
        $qK = self::is_license_expired();
        $Bx = !$qK["\123\124\101\124\x55\x53"];
        M2:
        $NV = check_ajax_referer($jh, $al, $iy);
        if (!(!$Bx || !$NV)) {
            goto O4;
        }
        wp_send_json_error(array("\x6d\x65\163\x73\x61\147\x65" => "\111\156\166\141\154\x69\x64\40\114\x69\x63\145\156\163\145\40\x4b\x65\x79\x2e"), 403);
        exit;
        O4:
        wp_send_json_success(array("\x6d\145\163\x73\141\x67\x65" => "\x52\x65\x66\x65\162\145\x72\40\x76\x65\x72\x69\146\151\145\144\40\163\165\143\x63\145\163\163\146\165\x6c\x6c\x79\x2e"), 200);
    }
    public static function get_expiry_remaining_days($QZ)
    {
        $xf = strtotime($QZ);
        $J5 = strtotime(gmdate("\x59\x2d\x6d\x2d\x64"));
        $nF = $xf - $J5;
        $xj = floor($nF / (60 * 60 * 24));
        return $xj;
    }
    public static function get_grace_days_left($QZ)
    {
        $xj = self::get_expiry_remaining_days($QZ);
        if (!($xj > 0)) {
            goto p9;
        }
        return false;
        p9:
        return Mo_License_Config::GRACE_PERIOD_DAYS + $xj;
    }
    public static function get_disable_date($QZ)
    {
        return gmdate("\115\40\x64\x2c\x20\131", strtotime($QZ . "\x2b" . Mo_License_Config::GRACE_PERIOD_DAYS . "\x20\144\141\171\163"));
    }
    public static function get_expiry_date()
    {
        $NG = Mo_License_Service_Utility::mo_decrypt_data(Mo_License_Dao::mo_get_option(Mo_License_Constants::LICENSE_EXPIRY_DATE_OPTION));
        if ($NG) {
            goto QI;
        }
        $NG = Mo_License_Actions_Utility::fetch_license_expiry_date();
        if ($NG) {
            goto JY;
        }
        $NG = Mo_License_Constants::EPOCH_DATE;
        JY:
        self::update_license_expiry($NG);
        QI:
        return $NG;
    }
    public static function get_formatted_license_expiry_date($mk)
    {
        try {
            $Tu = new \DateTime($mk);
            $Gv = $Tu->getTimestamp();
            $mk = gmdate("\x46\40\x6a\54\40\x59", $Gv);
            return $mk;
        } catch (\Exception $rY) {
            return $mk;
        }
    }
    public static function is_customer_license_valid($sC = false, $r5 = true)
    {
		return true;
        if ($r5) {
            goto kG;
        }
        $Bx = self::is_customer_license_verified();
        goto XR;
        kG:
        $qK = self::is_license_expired();
        $Bx = !$qK["\x53\124\101\124\x55\x53"];
        XR:
        if (!(true === $Bx)) {
            goto v1;
        }
        return $sC ? '' : true;
        v1:
        return $sC ? "\x64\151\163\x61\x62\154\x65\144" : false;
    }
    public static function update_license_expiry($QZ)
    {
        Mo_License_Dao::mo_update_option(Mo_License_Constants::LICENSE_EXPIRY_DATE_OPTION, Mo_License_Service_Utility::mo_encrypt_data(self::get_formatted_license_expiry_date($QZ)));
        $e7 = self::is_license_expired();
        if (true === $e7["\x53\124\x41\124\x55\x53"]) {
            goto Rb;
        }
        if (!Mo_License_Dao::mo_get_option(Mo_License_Constants::LICENSE_EXPIRED_OPTION)) {
            goto oE;
        }
        self::reset_license_values();
        oE:
        goto S_;
        Rb:
        Mo_License_Dao::mo_update_option(Mo_License_Constants::LICENSE_EXPIRED_OPTION, true);
        S_:
    }
    public static function reset_license_values()
    {
        $I0 = Mo_License_Constants::get_constants();
        foreach ($I0 as $pk => $cc) {
            if (!(strpos($pk, "\117\120\124\x49\x4f\x4e") !== false)) {
                goto i5;
            }
            Mo_License_Dao::mo_delete_option($cc);
            i5:
            XF:
        }
        ua:
    }
}
