<?php


namespace MoSharePointObjectSync\LicenseLibrary\Utils;

use MoSharePointObjectSync\LicenseLibrary\Classes\Mo_AESEncryption;
use MoSharePointObjectSync\LicenseLibrary\Classes\Mo_License_Dao;
use MoSharePointObjectSync\LicenseLibrary\Exceptions\Mo_License_Grace_Expired_Exception;
use MoSharePointObjectSync\LicenseLibrary\Exceptions\Mo_License_Invalid_Expiry_Date_Exception;
use MoSharePointObjectSync\LicenseLibrary\Exceptions\Mo_License_Missing_Customer_Email_Exception;
use MoSharePointObjectSync\LicenseLibrary\Exceptions\Mo_License_Missing_License_Key_Exception;
use MoSharePointObjectSync\LicenseLibrary\Exceptions\Mo_License_Missing_Or_Invalid_Customer_Key_Exception;
use MoSharePointObjectSync\LicenseLibrary\Exceptions\Mo_License_Unknown_Error_Exception;
use MoSharePointObjectSync\LicenseLibrary\Classes\Mo_License_Constants;
use MoSharePointObjectSync\LicenseLibrary\Mo_License_Config;
use MoSharePointObjectSync\LicenseLibrary\Mo_License_Service;
if (defined("\101\102\123\120\101\x54\x48")) {
    goto iC;
}
exit;
iC:
class Mo_License_Service_Utility
{
    public static function check_customer_login()
    {
        $Wq = Mo_License_Dao::mo_get_option(Mo_License_Config::CUSTOMER_EMAIL_OPTION);
        $QC = Mo_License_Dao::mo_get_option(Mo_License_Config::CUSTOMER_KEY_OPTION);
        if (!$Wq) {
            goto yV;
        }
        if (!$QC || !is_numeric(trim($QC))) {
            goto ZP;
        }
        goto ZL;
        yV:
        throw new Mo_License_Missing_Customer_Email_Exception();
        goto ZL;
        ZP:
        throw new Mo_License_Missing_Or_Invalid_Customer_Key_Exception();
        ZL:
    }
    public static function check_customer_login_and_license()
    {
        self::check_customer_login();
        $h1 = Mo_License_Dao::mo_get_option(Mo_License_Config::LICENSE_KEY_OPTION);
        if ($h1) {
            goto ob;
        }
        throw new Mo_License_Missing_License_Key_Exception();
        ob:
    }
    public static function is_license_grace_expired()
    {
        $QZ = self::mo_decrypt_data(Mo_License_Dao::mo_get_option(Mo_License_Constants::LICENSE_EXPIRY_DATE_OPTION));
        if ($QZ) {
            goto Gk;
        }
        throw new Mo_License_Invalid_Expiry_Date_Exception();
        Gk:
        try {
            $In = gmdate("\131\x2d\x6d\55\144", strtotime($QZ));
            $Bs = strtotime("\53" . Mo_License_Config::GRACE_PERIOD_DAYS . "\40\144\x61\171\x73", strtotime($QZ));
            $Pe = gmdate("\131\55\x6d\55\x64", $Bs);
            $vJ = new \DateTime();
            $vJ = $vJ->format("\131\55\155\x2d\x64");
        } catch (\Exception $rY) {
            throw new Mo_License_Unknown_Error_Exception();
        }
        if ($vJ > $Pe) {
            goto aH;
        }
        if ($vJ > $In) {
            goto V1;
        }
        goto Lj;
        aH:
        throw new Mo_License_Grace_Expired_Exception();
        goto Lj;
        V1:
        return self::return_false_with_code("\114\x49\x43\x45\x4e\123\x45\137\x49\116\137\107\x52\101\103\x45");
        Lj:
        return self::return_false_with_code("\x4c\111\x43\105\116\123\x45\137\126\101\114\x49\104");
    }
    public static function return_true_with_code($ct)
    {
        return array("\x53\124\x41\124\x55\123" => true, "\103\117\x44\x45" => $ct);
    }
    public static function return_false_with_code($ct)
    {
        return array("\x53\x54\101\124\125\123" => false, "\103\117\x44\x45" => $ct);
    }
    public static function mo_decrypt_data($C1)
    {
        $pk = Mo_License_Dao::mo_get_option(Mo_License_Config::CUSTOMER_TOKEN_OPTION);
        $w0 = Mo_AESEncryption::decrypt_data($C1, $pk);
        return $w0;
    }
    public static function mo_encrypt_data($C1)
    {
        $pk = Mo_License_Dao::mo_get_option(Mo_License_Config::CUSTOMER_TOKEN_OPTION);
        $iq = Mo_AESEncryption::encrypt_data($C1, $pk);
        return $iq;
    }
}
